<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants,
                com.lombardisoftware.portal.utils.LocaleUtil"%>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.lombardisoftware.client.persistence.TWResourceBundleGroupFactory" %>
<%@ page import="com.lombardisoftware.client.delegate.RuntimeServicesDelegateFactory" %>
<%@ page import="com.lombardisoftware.utility.ApplicationServerPlatform" %>
<%@ page import="java.util.logging.Logger" %>
<%@ page import="com.lombardisoftware.logger.WLELoggerConstants" %>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration" %>
<%@ page import="java.util.List" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.lombardisoftware.client.delegate.SecurityDelegateFactory" %>
<%@ page import="com.lombardisoftware.client.delegate.SecurityDelegate" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<%@ include file="jsp/contextRoot.jsp" %>
<%!
    private static final Logger logger = Logger.getLogger(WLELoggerConstants.PORTAL_LOGGER, WLELoggerConstants.WLE_PIIMESSAGE_FILE);
%>
<%
    String successPage = request.getParameter("sp");
    if (successPage == null) {
        successPage = "<%= processPortalSupportContextRoot %>/jsp/getSavedSearch.do";
    }
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head>
    <title><bean:message key="login.title" bundle="ProcessPortal"/></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js"></script>
    <link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/login.css" media="screen, projection" />
    <script type="text/javascript">
    dojo.require("dijit._base.sniff");
    
AutoLogin.prototype = {
    init : function() {
        <%-- Auto-login only works with IE - with firefox, it'll challenge for a username and password, and then get
        into an infinite redirect/re-request loop.  Since NTLM and Kerberos are only supported on IE anyway, we skip
        the auto-login request on non-IE browsers, and simply redirect to the login page. --%>
        if (dojo.isIE) {
            dojo.xhrGet({
                url: "<%= processPortalSupportContextRoot %>/jsp/autoLogin.2.lsw",
                handleAs: "xml",
                load: dojo.hitch(this, function(data) {
                    this.loginSucceeded();
                }),
                error: dojo.hitch(this, function(error) {
                    this.loginFailed();
                })
            });
        } else {
            this.loginFailed();
        }
    },

    loginSucceeded : function() {
        document.location = "<%= successPage %>";
    },

    loginFailed : function() {
        <%
            String newLocation = "<%= processPortalSupportContextRoot %>/login.jsp?errorMessage=login.error.cantLogin";
            if (request.getParameter("sp") != null) {
                newLocation = newLocation + "&sp=" + URLEncoder.encode(request.getParameter("sp"));
            }
        %>
        document.location = "<%= newLocation %>";
    }
}
function AutoLogin() {}

var autologin = new AutoLogin();
    </script>
</head>
<body onLoad="autologin.init()">
    <div id="login-header">
        <div class="logo"></div>
    </div>
    <div id="login-body">
        <table cellpadding="0" cellspacing="0" width="100%">
            <tr>
                <td>&nbsp;</td>
                <td width="500">
                    <div id="login-content">
                        <table id="content-header" cellspacing="0" cellpadding="0">
                          <tr>
                            <td id="content-header-left"></td>
                            <td id="content-header-right"></td>
                          </tr>
                        </table>
                        <p><bean:message key="login.text.attemptingAutologin" bundle="ProcessPortal"/></p>
                        <p><a href="<%= processPortalSupportContextRoot %>/login.jsp"><bean:message key="login.text.loginPageLink" bundle="ProcessPortal"/></a></p>
                        <div id="login-copyright"><bean:message key="portal.common.copyright" bundle="ProcessPortal"/></div>
                        <table id="content-footer" cellspacing="0" cellpadding="0">
                          <tr>
                            <td id="content-footer-left"></td>
                            <td id="content-footer-right"></td>
                          </tr>
                        </table>
                    </div>
                </td>
                <td>&nbsp;</td>
            </tr>
        </table>
    </div>
</body>
</html>
