<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.psapi.data.User"%>
<%@ page import="com.lombardisoftware.portal.utils.SessionHelper"%>
<%@ page import="com.lombardisoftware.servlet.util.ServletStrings"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Locale"%>
<%@ page import="org.apache.struts.Globals"%>
<%@ include file="../contextRoot.jsp" %>

<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%!
    public String getUserName(HttpSession session) {
        User user=(User)session.getAttribute("user");

        SessionHelper sessionHelper=new SessionHelper(session);
        User loginUser=sessionHelper.getLoggedInUser();

        String fullname = "";
        if (user.getFullName() != null)
            fullname = user.getFullName();
        if (sessionHelper.isUserAssumed(loginUser)) {
            User assumed=sessionHelper.getAssumedUser();
            String fullnameAssume = "";
            if (assumed.getFullName() != null)
                fullnameAssume = assumed.getFullName();
            return fullname + " acting on behalf of " + fullnameAssume;
        }
        else {
            return fullname;
        }
    }
    
    public String getLocalizedHelpPath(HttpSession session) {
        //Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
        //return "/help/" + locale.toString() + "/index.html";
        return bpmHelpContextRoot +"/index.jsp?topic=/com.ibm.wbpm.wle.widget.doc/portalhelp/topic/starting_portal.html";
    }

%>
<div id="header">
    <div class="nav"></div>
    <div class="right"></div>
    <div class="center" style="white-space : nowrap;">
         <a href="<%= getLocalizedHelpPath(session) %>" target="_blank"><bean:message key="header.Help" bundle="ProcessPortal"/></a>&nbsp;&nbsp;|&nbsp;&nbsp;
<%
            // request.isUserInRole has different behavior on WLS and WAS
            List roles = (List) session.getAttribute(ServletStrings.USER_ROLE_MEMBERSHIP);
            if (roles.contains("tw_portal_admins")) {
%>
                <a href="<%= teamworksContextRoot %>/cs_main.lsw" target="_blank" ><bean:message key="header.Admin" bundle="ProcessPortal"/></a>&nbsp;&nbsp;|&nbsp;&nbsp;
<%
            }
%>
        <a href="<%=request.getContextPath()%>/jsp/generalPreferencesSetup.do">
            <bean:message key="header.Preferences" bundle="ProcessPortal"/>
        </a>&nbsp;&nbsp;|&nbsp;&nbsp;
        <a href="<%=request.getContextPath()%>/logoff.do"><bean:message key="header.LogOff" bundle="ProcessPortal"/></a>
    </div>
    <div class="left"></div>
    <div class="welcome"><bean:message key="header.Welcome" bundle="ProcessPortal"/>, <%= getUserName(session) %></div>
</div>