<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.client.delegate.common.FavoriteDetails"%>
<%@ page import="com.lombardisoftware.client.persistence.common.ID"%>
<%@ page import="com.lombardisoftware.client.persistence.common.Reference"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants"%>
<%@ page import="com.lombardisoftware.portal.utils.ExposedItemHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.SessionHelper" %>
<%@ page import="com.lombardisoftware.portal.viewhelper.NavigationHelper"%>
<%@ page import="com.lombardisoftware.portal.viewhelper.ProjectHelper" %>
<%@ page import="com.lombardisoftware.psapi.data.SavedSearch" %>
<%@ page import="com.lombardisoftware.psapi.data.User" %>
<%@ page import="com.lombardisoftware.servlet.util.ServletStrings" %>
<%@ page import="com.lombardisoftware.utility.ui.FolderItem" %>
<%@ page import="com.lombardisoftware.utility.ui.FolderNode" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.logging.*" %>
<%@ page import="java.util.logging.Logger" %>
<%@ page import="com.lombardisoftware.logger.WLELoggerConstants" %>
<%@ page import="com.lombardisoftware.utility.WLELoggerUtils" %>
<%@ page import="com.lombardisoftware.portal.utils.MessagesHelper" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%!
private static Logger logger = Logger.getLogger(WLELoggerConstants.PORTAL_LOGGER, WLELoggerConstants.WLE_PIIMESSAGE_FILE);
private static final String CLASS_NAME = "com.lombardisoftware.portal.jsp.Navigation";
%>

<% if(logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "com.lombardisoftware.portal.jsp.Navigation", "BEGIN"); %>

<script TYPE="text/javascript"src="<%=request.getContextPath()%>/js/toolbar.js"></script>
<script type="text/javascript">
function changeImg(liItem) {
    SetCookie("curNavItem",liItem.id);
}

function changeClass() {
    var ck=ReadCookie("curNavItem");
    if(ck==null || ck=="")
        ck="adminsaved0";

    var selItem=document.getElementById(ck);
    if (selItem) {
        selItem.className="on";
    }
}

function SetCookie(cookieName,cookieValue) {
    document.cookie = cookieName+"="+escape(cookieValue);
}

function ReadCookie(cookieName) {
    var theCookie=""+document.cookie;
    var ind=theCookie.indexOf(cookieName);
    if (ind==-1 || cookieName=="") return "";
    var ind1=theCookie.indexOf(';',ind);
    if (ind1==-1) ind1=theCookie.length;
    return unescape(theCookie.substring(ind+cookieName.length+1,ind1));
}
</script>


<div id="nav_header">
    <div class="heading">
        <div class="heading-right"></div>
        <h1><bean:message key="navigation.MenuHeading.MyTasks" bundle="ProcessPortal"/></h1>
    </div>
</div>

<%--<div class="heading"><bean:message key="navigation.MenuHeading.MyTasks" bundle="ProcessPortal"/></div>--%>
    <!-- Admin-Saved searches -->
    <ul>
        <%
            List adminsrch = NavigationHelper.getAdminSavedSearches();
            for(int i=0;i<adminsrch.size();i++) {
                SavedSearch srch=(SavedSearch)adminsrch.get(i);
				if (srch.getName() != null && srch.getName().startsWith(Constants.SavedSearch.PREFIX_MSG_KEY)) {
        %>

        <li id="adminsaved<%=i%>" onClick="changeImg(this);"><a href="<%=request.getContextPath()%>/jsp/getSavedSearch.do?startsWith=0&search=<%=srch.getSearchID()%>"><bean:message key="<%=srch.getName()%>" bundle="ProcessPortal"/></a></li>
        <%
				} else {
		%>
		<li id="adminsaved<%=i%>" onClick="changeImg(this);"><a href="<%=request.getContextPath()%>/jsp/getSavedSearch.do?startsWith=0&search=<%=srch.getSearchID()%>"><%=srch.getName()%></a></li>
		<%		    
				}
            }
        %>
        <!-- User-Saved searches -->
        <%
            User user = (new SessionHelper(session)).getUser();
            List usersrch = NavigationHelper.getUserSavedSearches(user.getUserID());
            for (int i = 0; i < usersrch.size(); i++) {
                SavedSearch srch = (SavedSearch) usersrch.get(i);
                if (request.getParameter("name") != null && request.getParameter("name").equals(srch.getName().trim())) {
        %>

        <li id="usersaved<%=i%>" class="on" onClick="changeImg(this);"><a href="<%=request.getContextPath()%>/jsp/getSavedSearch.do?startsWith=0&search=<%=srch.getSearchID()
                            %>"><%=srch.getName()%></a></li>
        <script>
            SetCookie("curNavItem","usersaved<%=i%>");
        </script>


        <%

        } else
        {
        %>

        <li id="usersaved<%=i%>" onClick="changeImg(this);"><a href="<%=request.getContextPath()%>/jsp/getSavedSearch.do?startsWith=0&search=<%=srch.getSearchID()%>"><%=srch.getName()%></a></li>
        <%}
        }
        %>

    </ul>

<%
    @SuppressWarnings({"unchecked"}) List<FavoriteDetails> scoreboardFavorites = (List<FavoriteDetails>) session.getAttribute(Constants.Session.SCOREBOARD_FAVORITES);
    if (scoreboardFavorites == null) {
        scoreboardFavorites = ExposedItemHelper.getExposedScoreboards();
        session.setAttribute(Constants.Session.SCOREBOARD_FAVORITES, scoreboardFavorites);
    }

    boolean adhocReportsEnabled = request.getSession().getAttribute(ServletStrings.SESSION_ENABLE_ADHOC_REPORTS_KEY) != null;
    boolean hasScoreboards = (scoreboardFavorites != null && scoreboardFavorites.size() > 0) || adhocReportsEnabled;
    if (hasScoreboards) {
%>
        <div class="divider">&nbsp;</div>

      <div id="nav_header">
            <div class="heading">
                <div class="heading-right"></div>
				<h1 style="display:none;"><bean:message key="navigation.MenuHeading.accessibilityHelp" bundle="ProcessPortal"/></h1>
                <h1><bean:message key="navigation.MenuHeading.MyScoreBoards" bundle="ProcessPortal"/></h1>
            </div>
        </div>

<%--<div class="heading"><bean:message key="navigation.MenuHeading.MyScoreBoards" bundle="ProcessPortal"/></div>--%>

        <ul>
<%
        if(scoreboardFavorites != null && scoreboardFavorites.size() > 0) {
            int rowNum = 0;
            for (FavoriteDetails favorite : scoreboardFavorites) {
                String encodedURL = URLEncoder.encode(ID.toExternalString(favorite.getId()), "UTF-8");
			    if (favorite.getItemName() != null && favorite.getDisplayName() != null && favorite.getItemName().startsWith(Constants.ScoreBoard.PREFIX_MSG_KEY) && favorite.getDisplayName().startsWith(favorite.getItemName())){
			    %>
			    	<li id="scoreboard<%=rowNum%>" onClick="changeImg(this);"> <a title="<bean:message key="<%= favorite.getItemName()%>" bundle="ProcessPortal"/><%= favorite.getDisplayName().substring(favorite.getItemName().length()) %>" href="<%=request.getContextPath()%>/jsp/viewScoreboard.do?id=<%= encodedURL %>"><bean:message key="<%= favorite.getItemName()%>" bundle="ProcessPortal"/><%= favorite.getDisplayName().substring(favorite.getItemName().length()) %></a></li>
			    <%
			    }else{
			    %>
			    	<li id="scoreboard<%=rowNum%>" onClick="changeImg(this);"> <a title="<%=favorite.getDisplayName()%>" href="<%=request.getContextPath()%>/jsp/viewScoreboard.do?id=<%= encodedURL %>"><%= favorite.getAbbreviatedName() %></a></li>
			    <%}
                rowNum++;
            }

            if (adhocReportsEnabled) {
%>
                <li><a href="<%=request.getContextPath()%>/jsp/viewGeneratedReports.do"><bean:message key="portal.navigation.reports" bundle="ProcessPortal"/></a></li>
<%
            }
        }
%>
        </ul>
<%
    }

    // TODO: Combine projects and projectfavorites into one method
    @SuppressWarnings({"unchecked"}) List<FavoriteDetails> projectFavorites = (List<FavoriteDetails>) request.getSession().getAttribute(Constants.Session.PROJECT_FAVORITES);
    if(projectFavorites == null) {
        projectFavorites = ExposedItemHelper.getExposedProjects();
        request.getSession().setAttribute(Constants.Session.PROJECT_FAVORITES, projectFavorites);
    }

    @SuppressWarnings({"unchecked"}) List<FolderNode> projects = (List<FolderNode>) request.getSession().getAttribute(Constants.Session.PROJECTS);
    if(projects == null) {
        List memberRoles = (List) request.getSession().getAttribute(ServletStrings.USER_ROLE_MEMBERSHIP);
        projects = ProjectHelper.getProjects(user.getUserName(), memberRoles);
        request.getSession().setAttribute(Constants.Session.PROJECTS, projects);
    }

    boolean hasFavorites = (projects != null && projects.size() > 0) || (projectFavorites != null && projectFavorites.size() > 0);

    if (hasFavorites) {
%>
        <div class="divider">&nbsp;</div>


        <div id="nav_header">
            <div class="heading">
                <div class="heading-right"></div>
                <h1><bean:message key="navigation.MenuHeading.MyProjects" bundle="ProcessPortal"/></h1>
            </div>
        </div>

       <%-- <div class="heading">
            <bean:message key="navigation.MenuHeading.MyProjects" bundle="ProcessPortal"/>
        </div>--%>
        <ul>
<%
        if (projects != null && projects.size() > 0) {
                int rowNum = 0;
                for(FolderNode node : projects) {
                    // Could also be an instance of Folder but we don't support hierarchies
                    if(node instanceof FolderItem) {
                        FolderItem project = (FolderItem) node;
%>
                        <li id="myProject<%=rowNum%>" onClick="changeImg(this);">
<%
                        if (project.isPop()) {
%>
                            <a target="_blank" href="<%= request.getContextPath() + project.getLink() %>"><%= project.getName() %></a>
<%
                        }
                        else if (project.isReplace()) {
%>
                            <a href="<%= request.getContextPath() + project.getLink() %>"><%= project.getName() %></a>
<%
                        }
                        else if (project.isFrame()) {
%>
                            <a href="<%= request.getContextPath() + project.getLink() %>"><%= project.getName() %></a>
<%
                        }
%>
                        </li>
<%
                    }
                    rowNum++;
                }
        }

        if(projectFavorites != null && projectFavorites.size() > 0) {
            int rowNum = 0;
            for(FavoriteDetails f : projectFavorites) {
%>                
                <li id="Service <%=rowNum%>" onClick="changeImg(this);">
                <a title="<%=f.getDisplayName()%>" href="<%=request.getContextPath()%>/jsp/viewProjectPage.do?pageUrl=/jsp/runServiceLayout.jsp?processRef=<%=Reference.toExternalString(f.getItemRef())%>&favId=<%=ID.getBigDecimal(f.getId())%>"><%=f.getAbbreviatedName()%></a>
                </li>
<%
                rowNum++;
            }
        }
%>
    </ul>

<%
    }
%>
<script>
    changeClass();
</script>

<% if(logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "com.lombardisoftware.portal.jsp.Navigation", "END"); %>