<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import="java.util.Locale" %>
<%@ page import="java.util.Map"%>
<%@ page import="com.lombardisoftware.psapi.data.User"%>
<%@ page import="com.lombardisoftware.client.delegate.UserGroupAPIFacadeDelegateFactory"%>
<%@ page import="com.lombardisoftware.client.delegate.SecurityDelegateFactory"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants" %>
<%@ page import="com.lombardisoftware.client.persistence.common.LegacyIDHelper"%>
<%@ page import="com.lombardisoftware.utility.i18n.LocaleUtils" %>
<%@ page import="com.lombardisoftware.core.UserPreference"%> 
<%@ page import="com.lombardisoftware.client.persistence.common.ID"%>
<%@ page import="com.lombardisoftware.client.persistence.common.POType"%>

<%@ include file="../contextRoot.jsp" %>

<%

    /**
     * We do not explicitly support Arabic, Hebrew, Turkish, Danish, Finnish, Norwegian Bokmal, Norwegian, Slovak, or Swedish in Heritage UIs as of 8.0
     **/

	com.lombardisoftware.psapi.data.User rawUser = UserGroupAPIFacadeDelegateFactory.getInstance().newInstance().getCurrentUser();

	// User Preference Data
	String userLocale = null;
	ID<POType.User> id = LegacyIDHelper.fromLong(POType.User, rawUser.getUserID());
	Map<String, String> attrData = SecurityDelegateFactory.getInstance().newInstance().getUserAttributes(id);
	if (attrData != null) {
		userLocale = attrData.get("Locale");
		if(userLocale == null) {
		    userLocale = com.lombardisoftware.client.LocaleUtils.getCurrentUserLocale().getLanguage();
		}
	} else {
		// If locale can not be retrieved for this user, default to English
		out.println("console.log('Using default locale');");
		userLocale = Constants.Application.DEFAULT_LOCALE.toString();
	}
    String language = userLocale.toLowerCase().replace('_', '-');
%>

<script TYPE="text/javascript"src="<%=request.getContextPath()%>/js/toolbar.js"></script>
<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js"
        djConfig="locale:'<%= language %>', extraLocale:'en'"></script>

