<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.servlet.InjectServlet" %>
<%@ page import="java.math.BigDecimal" %>
<%@ page import="java.util.Map" %>
<%@ page import="com.lombardisoftware.client.delegate.AuthorizationAPIDelegateFactory,
                 com.lombardisoftware.server.api.ActionPolicy"%>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.Set" %>
<%@ page import="com.lombardisoftware.core.TeamWorksException" %>
<%@ page import="com.lombardisoftware.bpd.model.bpmn.BpmnObjectId" %>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.lombardisoftware.portal.utils.LocaleUtil" %>
<%@ include file="contextRoot.jsp" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%!private static final String BPD_INSTANCE_ID_PARAM = "bpdInstanceId"; %>

<%
    String[] instanceIdsString = request.getParameterValues(BPD_INSTANCE_ID_PARAM);
    if (instanceIdsString == null || instanceIdsString.length == 0) {
        throw new TeamWorksException("There is no one '" + BPD_INSTANCE_ID_PARAM + "' parameter found in the request");
    }

    BigDecimal[] instanceIds;
    instanceIds = new BigDecimal[instanceIdsString.length];
    for (int i = 0; i < instanceIdsString.length; i++) {
        instanceIds[i] = new BigDecimal(instanceIdsString[i]);
    }

    String localeLanguage = "";
    Locale userLocale = LocaleUtil.getLocaleFromUserPreferences(request);
    System.out.println("Lang: " + userLocale);
    if(Locale.CHINESE.getLanguage().equals(userLocale.getLanguage())) {
        localeLanguage = userLocale.toString();
        if("zh_HK".equals(userLocale.toString())) {
            localeLanguage = Locale.TRADITIONAL_CHINESE.toString();
        } else if("zh_SG".equals(userLocale.toString())) {
            localeLanguage = Locale.SIMPLIFIED_CHINESE.toString();
        } else if(!Locale.SIMPLIFIED_CHINESE.equals(userLocale) && !Locale.TRADITIONAL_CHINESE.equals(userLocale)) {
           localeLanguage = Locale.SIMPLIFIED_CHINESE.toString();
        }
    } else if(Locale.JAPAN.equals(userLocale) ||
            Locale.JAPANESE.equals(userLocale) ||
            Locale.KOREA.equals(userLocale) ||
            Locale.KOREAN.equals(userLocale)) {
        localeLanguage = userLocale.getLanguage();
    }
    System.out.println("Lang for flash: " + localeLanguage);
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title><bean:message key="main.message.title" bundle="ProcessPortal"/></title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/hint.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/ajaxutils.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/utils.js"></script>

<link rel="stylesheet" type="text/css" href="<%=request.getContextPath()%>/jsp/css/hint.css" />

<link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css" media="screen, projection" />

<link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css" />

<script type="text/javascript">
    dojo.require("dijit.Dialog");
    dojo.require("dijit.form.Button");
    dojo.require("dijit.form.TextBox");
    dojo.require("dijit.Menu");
    dojo.require("dijit.MenuItem");

    var message_initiate_flow = "Initiate Flow...";
    var message_reroute = "Re-route...";
    var message_reassign_task = "Re-assign Task...";
    var reassign_back_to_group = "Re-assign Task Back to Group";
    var reassign_to_user_or_group = "Re-assign Task to a User or Group";
    var reassign_task_title = "Re-assign Task";
    
    var jsonResURL = "<%= teamworksContextRoot %>/jsonResBundleLoader?bundle=FlashDiagramMessages";
    
dojo.xhrGet( {
    url: jsonResURL,
    handleAs: "json",
    load: function(o) {
	    message_initiate_flow = o.menu_initiate_flow;
        message_reroute = o.menu_reroute;
        message_reassign_task = o.menu_reassign_task;
        reassign_back_to_group = o.reassign_back_to_group;
        reassign_to_user_or_group = o.reassign_to_user_or_group;
        reassign_task_title = o.reassign_task_title;
        
    }});    
</script>

<script language="JavaScript">
<!--
var sURL = unescape(window.location.pathname);
function refresh() {
    window.location.href = sURL;
}
//-->
</script>

<script language="JavaScript1.1">
<!--
function refresh() { window.location.replace( sURL ); }
//-->
</script>

<script language="JavaScript1.2">
<!--
function refresh() { window.location.reload( false ); }
//-->
</script>

<style type="text/css">

#hintbox{ /*CSS for pop up hint box */
    position:absolute;
    top: 0;
    background-color: lightyellow;
    width: 150px; /*Default width of hint.*/
    padding: 3px;
    border:1px solid black;
    font:normal 11px Verdana;
    line-height:18px;
    z-index:100;
    border-right: 3px solid black;
    border-bottom: 3px solid black;
    visibility: hidden;
}

.hintanchor{ /*CSS for link that shows hint onmouseover*/
    font-weight: bold;
    color: navy;
    margin: 3px 8px;
}
/*
#reassignDialog .dijitDialogTitleBar,
#adhocDialog .dijitDialogTitleBar {
    display: none;
}
*/

#reassignDialog .dijitDialogPaneContent,
#adhocDialog .dijitDialogPaneContent,
#activitiesDialog .dijitDialogPaneContent{
    padding: 0px;
    border: none;
}
/* make html/body to fit the height of its parent */
html {
    height: 100%;
    overflow: hidden;
}
body {
    height: 100%;
    margin: 0;
    padding: 0;
    overflow:hidden;
}
</style>

<script type="text/javascript">
    // Disable automatic onload handler.  Must be set before including
    // the BPD.js script
    var LOMBARDI_BPD_ONLOAD = false;
</script>
<script type="text/javascript" src="<%=request.getContextPath()%>/jsp/js/core.jsp"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/flash/BPD.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/main.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/jsp/js/messages.jsp"></script>
<script type="text/javascript">

    var firstRun = true;
    function tableToDiagram(param) {
        if (!param) return;

        if (param.stack) {

            // If we're showing other diagram.
            if (param.stack[param.stack.length - 1].parentId != stack[stack.length - 1].parentId) {
                var diagramToDisplay = param.stack[param.stack.length - 1];

                // Override drill stack.
                stack = param.stack;
                window.parent.drillStack = stack;

                // Kill selection.
                if (selectedId) {
                    bpd.setSelected(selectedId, false);
                    selectedId = null;
                }
                
                showBpd(diagramToDisplay.bpdId, diagramToDisplay.name, diagramToDisplay.parentId);
            }
        }

        if (param.action == "select") {
            if (selectedId) {
                bpd.setSelected(selectedId, false);
            }
            selectedId = param.idToSelect;
            bpd.setSelected(param.idToSelect, true);
            
        } else if (param.action == "deselect") {
            bpd.setSelected(selectedId, false);
            selectedId = null;
        }
    }

    var horizontal_offset = "9px"; //horizontal offset of hint box from anchor link

    /////No further editting needed

    var vertical_offset = "0"; //horizontal offset of hint box from anchor link. No need to change.
    var ie = document.all;
    var ns6 = document.getElementById && !document.all;
    function createhintbox() {
        var divblock = document.createElement("div");
        divblock.setAttribute("id", "hintbox");
        document.body.appendChild(divblock);
    }

    if (window.addEventListener) {
        window.addEventListener("load", createhintbox, false);
    }
    else if (window.attachEvent) {
        window.attachEvent("onload", createhintbox);
    }
    else if (document.getElementById) {
        window.onload = createhintbox;
    }

    var DOUBLE_CLICK_INTERVAL = 700;
    var DRILL_BUTTON_LABELS = {
        drillIn: showDiagram_flash_button_drillIn,
        drillOut: showDiagram_flash_button_drillOut
    };
    var DATA_URL_PARTS = {
        path: "generateProcessInstanceFlashData.jsp",
        instanceIdParam: "bpdInstanceId",
        bpdIdParam: "bpdId",
        parentId: "parentId",
        cpType: "cpType"
    };
    var ESCAPED_PARAM_DELIMITER = "%26";
    var PARAM_DELIMITER = "&";

    var stack = window.parent.drillStack;
    var last = stack[stack.length - 1];
    var bpdId = last.bpdId;
    var parentId = last.parentId; 
    var instanceId = window.parent.instanceId;
    var instanceIds = window.parent.instanceIds;
    var cpType = window.parent.cpType;
    var activeActivityId;
    var idsOfActivitiesWithTokens;
    var bpdFlashElementId = "flash_" + bpdId + "_" + instanceId;

    var bpd = com.lombardi.BPD.getBPD(bpdFlashElementId);
    var selectedId = null;
    var waitingForSecondClick = false;
    var timer;
    var timerOver;
    var drillButton;
    var clickx;
    var clicky;

    var bpdItemDataRequest;
    var tokenChangeRequest;
    var reassignTo;
    var ACTION_REASSIGN_TASK_BACK_TO_ROLE = '<%= InjectServlet.REASSIGN_TASK_BACK_TO_ROLE %>';
    var ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE = '<%= InjectServlet.REASSIGN_TASK_TO_A_USER_OR_ROLE %>';

    var participantDialog;
    var errorDialog;

    var reassignMenu;
    var reassignDialog;
    var adHocMenu;
    var adHocDialog;
    var activitiesMenu;
    var activitiesDialog;
    var isFlashInstalledAndSufficient;

    var handleCancel = function() {
        var errorMsgElem = document.getElementById("participantDialog.errorMessage");
        setDisplayVisible(errorMsgElem, false);
        errorMsgElem.innerHTML = "";
        dijit.byId("participantDialog").hide();
    };

    var handleSubmit = function() {
        reassignTo = dijit.byId("participant").attr("value");
        dijit.byId("participantDialog").hide();
        sendTokenChangeRequest(activeActivityId, ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE);
    };

    var handleErrorDialogOk = function() {
        var errorMsgElem = document.getElementById("errorDialog.errorMessage");
        errorMsgElem.innerHTML = "";
        dijit.byId("participantDialog").hide();
    };

    dojo.addOnLoad(function(){
        // Add key listener to participant dialog text box
        dijit.byId("participant").connect(this, "onkeydown", function(event) {
            if(event.keyCode == dojo.keys.ENTER) {
                handleSubmit();
                dojo.stopEvent(event);
            }
        });
    });

    function onLoad() {
        drillButton = document.getElementById("drillButton");

        // Build reassign menu, and then wrap it in a dialog
        reassignMenu = new dijit.Menu({
            targetNodeIds:["reassign-menu"],
            id: "dojo-menu"
            //contextMenuForWindow: true
        });

        reassignMenu.addChild(
            new dijit.MenuItem({
                id:ACTION_REASSIGN_TASK_BACK_TO_ROLE,
                label: reassign_back_to_group,
                disabled: false,
                onClick:  function() {
                    sendTokenChangeRequest(activeActivityId, ACTION_REASSIGN_TASK_BACK_TO_ROLE);
                    reassignDialog.hide();
                }
            })
        );

        //menuItem.value = ACTION_REASSIGN_TASK_BACK_TO_ROLE;
        reassignMenu.addChild(
            new dijit.MenuItem({
                id:ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE,
                label:reassign_to_user_or_group,
                disabled: false,
                onClick: function() {
                    var errorMsgElem = document.getElementById("participantDialog.errorMessage");
                    setDisplayVisible(errorMsgElem, false);
                    errorMsgElem.innerHTML = "";
                    dijit.byId("reassignDialog").hide();
                    dijit.byId("participantDialog").show();
                }
            })
        );
        // Initialize the menu
        reassignMenu.startup();
        //menuItem.value = ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE;

        // Create a dialog and put the menu in so we can display like a popup
        reassignDialog = new dijit.Dialog({
            title: reassign_task_title,
            id: "reassignDialog",
            style: "min-width:130px;"
        });
        reassignDialog.attr("content", reassignMenu);

        // Build Adhoc menu, and then wrap it in a dialog
        adHocMenu = new dijit.Menu({
            id: "adhocmenu"
        });

//        adHocMenu.addChild(
//            new dijit.MenuItem({
//                label:"Initiate Flow...",
//                disabled: true
//            })
//        );

        <%
            Map map = InjectServlet.getStartInjectionEvents(instanceIds);
            Iterator items = map.keySet().iterator();
            while(items.hasNext()) {
                String adHocItem = (String) items.next();
        %>
            adHocMenu.addChild(
                new dijit.MenuItem({
                    label: "<%= map.get(adHocItem) %>",
                    onClick: function() {
                        sendTokenChangeRequest('<%= adHocItem %>', '');
                    }
                }
            ));
        <% } %>
        adHocMenu.startup();

        // Add the adhoc menu to the dialog
        adHocDialog = new dijit.Dialog({
            title: "Initiate Flow",
            id: "adhocDialog",
            style: "min-width:130px;"
        });

        adHocDialog.attr("content", adHocMenu);

        // Build Activities menu
        activitiesMenu = new dijit.Menu({
            id: "activitiesmenu"
        });

//        activitiesMenu.addChild(
//            new dijit.MenuItem({
//                label:"Re-route...",
//                disabled: true
//            })
//        );

        <%
            map = InjectServlet.getActivities(instanceIds);
            items = map.entrySet().iterator();
            while(items.hasNext()) {
                Map.Entry item = (Map.Entry) items.next();
        %>
            activitiesMenu.addChild(
                new dijit.MenuItem({
                    label: "<%= item.getValue() %>",
                    onClick: function() {
                        sendTokenChangeRequest('<%= item.getKey() %>', 'move');
                    }
                }
            ));

        <% } %>
        activitiesMenu.startup();

        // Add the adhoc menu to the dialog
        activitiesDialog = new dijit.Dialog({
            title: "Re-route...",
            id: "activitiesDialog",
            style: "min-width:130px;"
        });

        activitiesDialog.attr("content", activitiesMenu);

        // gather ids of activities with token
        idsOfActivitiesWithTokens = new Array(); <%
        Set set = InjectServlet.getActivityIdWithTokens(instanceIds);
        for(Object aSet: set){
            %>idsOfActivitiesWithTokens[idsOfActivitiesWithTokens.length] = '<%=aSet%>';<%
        } %>

        isFlashInstalledAndSufficient = com.lombardi.BPD.detectFlashVersion();
        if (isFlashInstalledAndSufficient) {
            var diagram = document.createElement("bpd");
            diagram.setAttribute("id", bpdFlashElementId);
            diagram.setAttribute("flash-url", "<%= processPortalSupportContextRoot %>/flash/preloader.swf");
            var dataUrl = generateDataUrl(bpdId, ESCAPED_PARAM_DELIMITER, parentId, cpType);
            diagram.setAttribute("bpd-url", dataUrl);
            diagram.setAttribute("lang", "<%= localeLanguage %>");
            document.body.appendChild(diagram);
            com.lombardi.BPD.replaceTags();
        }
        else {
            var alternateContent =
                '<p class=\"body-message\">' + showDiagram_flash_noFlashMessage +
                '<a  href=\"http://www.adobe.com/go/getflash/\" target=\"_blank\">' + showDiagram_flash_getFlashMessage + '</a></p>';
            document.body.bgColor = "white";
            document.body.innerHTML = alternateContent;
        }
    }

    function generateDataUrl(bpdId, paramDelimiter, parentId, cpType) {
        var instanceIdsParams = "";

        for (var i = 0; i < instanceIds.length; i++) {
            instanceIdsParams += DATA_URL_PARTS.instanceIdParam + "=" +  instanceIds[i];
            if (i < instanceIds.length - 1)
                instanceIdsParams += paramDelimiter;
         }

        var newUrl = DATA_URL_PARTS.path + "?" + instanceIdsParams;
        if (bpdId != undefined && bpdId != null && bpdId != "null" && bpdId.length > 0) {
            newUrl += paramDelimiter + DATA_URL_PARTS.bpdIdParam + "=" + bpdId;
        }

        if (cpType && cpType !== "null") {
            newUrl += paramDelimiter + DATA_URL_PARTS.cpType + "=" + cpType;
        }

        if (parentId && parentId !== "null") {
            newUrl += paramDelimiter + DATA_URL_PARTS.parentId + "=" + parentId;
        }
        window.parent.parentId = parentId;
        
        return newUrl;
    }

    function openBPDbyID(name, bpdId, parentId) {
        bpd.setSelected(selectedId, false);
        selectedId = null;
        stack.push({bpdId:bpdId, name:name, parentId: parentId});
        showBpd(bpdId, name, parentId);
        //prepareDrillButton();
    }

    function openParentBPD() {
        bpd.setSelected(selectedId, false);
        selectedId = null;
        stack.pop();
        var current = stack[stack.length - 1];
        showBpd(current.bpdId, current.name, current.parentId);
        //prepareDrillButton();
    }

    function showBpd(bpdId, name, parentId) {
        bpd.setCurrentBPD(generateDataUrl(bpdId, PARAM_DELIMITER, parentId, cpType), "drillUp", 0, 0, 1.0);
        window.parent.setTitle(name);
    }

    function prepareDrillButton() {
        if (selectedId != null) {
            var info = bpd.getInfo(selectedId);
            if (info.attachedOverlay == "attachedSubprocess") {
                showDrillInButton(info.attachedId, info.name, info.id);
                return;
            }
        }
        if (stack.length > 1) {
            showDrillOutButton();
        } else {
            hideDrillButton();
        }
    }

    function showDrillInButton(bpdId, name, parentId) {
        drillButton.style.visibility = "visible";
        drillButton.value = DRILL_BUTTON_LABELS.drillIn;
        drillButton.onclick = function() {
            openBPDbyID(name, bpdId, parentId);
        };
    }

    function showDrillOutButton() {
        drillButton.style.visibility = "visible";
        drillButton.value = DRILL_BUTTON_LABELS.drillOut;
        drillButton.onclick = function() {
            openParentBPD();
        };
    }

    function hideDrillButton() {
        drillButton.style.visibility = "hidden";
    }

    function GetXmlHttpObject() {
        var newXmlHttp = null;
        try {
            // Firefox, Opera 8.0+, Safari, IE7
            newXmlHttp = new XMLHttpRequest();
        } catch (e) {
            // Internet Explorer
            try {
                newXmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (e) {
                newXmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            }
        }
        return newXmlHttp;
    }
    function showItemData(instanceId, selectedId, x, y) {
        bpdItemDataRequest = GetXmlHttpObject();
        if (bpdItemDataRequest == null) {
            alert("Your browser does not support AJAX!");
            return;
        }
        clickx = x;
        clicky = y;
        var url = "getBPDItemData.do?bpdInstanceId=" + instanceId + "&flowObjId=" + selectedId;
        bpdItemDataRequest.onreadystatechange = stateChanged;
        bpdItemDataRequest.open("GET", url, true);
        // Set this header to prevent caching of response by IE
        bpdItemDataRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
        bpdItemDataRequest.send(null);
    }

    function stateChanged() {
        if (bpdItemDataRequest.readyState == 4) {

            var doc = bpdItemDataRequest.responseXML;
            var taskData = doc.getElementsByTagName("TASKDATA");

            if(taskData.length != 0) {
                var taskInfoTables = "";

                for (var i = 0; i < taskData.length; i++) {
                    var data = taskData[i].getElementsByTagName('DATA');
                    if(data.length != 0) {
                        var isTaskOpen = true;
                        var table = "<table class=\"content-table\">";
                        for (var j = 0; j < data.length; j++) {
                            var property = data[j].getElementsByTagName('NAME');
                            var value = data[j].getElementsByTagName('VALUE');
                            var text;
                            var valueText;
                            if(isInternetExplorer()){
                                text = property[0].text;
                                valueText = value[0].text;
                            } else {
                                text = property[0].textContent;
                                valueText = value[0].textContent;
                            }

                            if (text == "Status:") {
                                if(valueText == "Closed") {
                                    // in case of a closed task don't show the details for it
                                    isTaskOpen = false;
                                    break;
                                }
                            } else if (isInternetExplorer()) { // Firefox or Internet Explorer
                                table = table + '<tr><td><b>' + text + '</font></b></td><td>';
                                table = table + valueText + '</font></td></tr>';
                            } else {
                                table = table + '<tr><td><b>' + text + '</font></b></td><td>';
                                table = table + valueText + '</font></td></tr>';
                            }
                        }
                        table = table + '</table>';
                        if (isTaskOpen) {
                            taskInfoTables += table;
                        }
                    }
                }
                if (taskInfoTables != "") {
                    showTip(taskInfoTables, clickx, clicky, '260px');
                }
           }
        }
    }

    function showTip(menucontents, x, y, tipwidth) {
        if ((ie || ns6) && document.getElementById("hintbox")) {
            var dropmenuobj = document.getElementById("hintbox");
            dropmenuobj.innerHTML = menucontents;
            dropmenuobj.style.left = dropmenuobj.style.top = -500;
            if (tipwidth != "") {
                dropmenuobj.widthobj = dropmenuobj.style;
                dropmenuobj.widthobj.width = tipwidth;
            }
            dropmenuobj.x = x;
            dropmenuobj.y = y;
            dropmenuobj.style.left = (dropmenuobj.x + 5) + 'px';
            dropmenuobj.style.top = (dropmenuobj.y + 20) + 'px';
            dropmenuobj.style.visibility = "visible";
        }
    }

    function isInternetExplorer() {
        return window.ActiveXObject;
    }

    bpd.onMouseClicked = function(bpdId, x, y) {
        var previousSelectedId = selectedId;
        if (waitingForSecondClick) {
            waitingForSecondClick = false;
            clearTimeout(timer);
            var info = this.getInfo(bpdId);
            //double click has happened - test for an attached subprocess and open it
            if (info != null && info.attachedOverlay == "attachedSubprocess" &&
                (selectedId == null || (selectedId != null && bpdId == selectedId))) {

                openBPDbyID(info.name, info.attachedId, info.id);
                return;
            }

        } else {
            //start timer for wait for possible double click
            waitingForSecondClick = true;
            timer = setTimeout("waitingForSecondClick = false", DOUBLE_CLICK_INTERVAL);
        }

        //switch between selected and unselected state
        if (selectedId != null) {
            bpd.setSelected(selectedId, false);
            selectedId = null;
        }
        if (previousSelectedId != bpdId) {
            bpd.setSelected(bpdId, true);
            selectedId = bpdId;
        }

        if (parent.opener && parent.opener.diagramToTable)
        parent.opener.diagramToTable({action: "select", id: selectedId});
    };

    function sendTokenChangeRequest(flowObjId, action) {
        tokenChangeRequest = GetXmlHttpObject();
        if (tokenChangeRequest == null) {
            alert("Your browser does not support AJAX!");
            return;
        }
        var url = "inject?";
        var instanceIdsParams = "";
        for (var i = 0; i < instanceIds.length; i++) {
            instanceIdsParams += DATA_URL_PARTS.instanceIdParam + "=" +  instanceIds[i];
            if (i < instanceIds.length - 1)
                instanceIdsParams += "&";
        }
        url += "bpdInstanceId=" + instanceIdsParams + "&flowObjId=" + flowObjId;

        if (action == 'move') {
            url += "&flowObjIdFrom=" + activeActivityId;
            url += "&move=t";
        }

        if(action == ACTION_REASSIGN_TASK_BACK_TO_ROLE) {
            url += "&action=" + ACTION_REASSIGN_TASK_BACK_TO_ROLE;
        }

        if(action == ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE) {
            url += "&action=" + ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE;
            url += "&participant=" + reassignTo;
        }

        tokenChangeRequest.onreadystatechange = function () {
            if (tokenChangeRequest.readyState == 4 && tokenChangeRequest.status == 200) {
                processTokenChangeResponse(tokenChangeRequest.responseXML, action);
            }
        };
        tokenChangeRequest.open("GET", url, true);
        // Set this header to prevent caching of response by IE
        tokenChangeRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
        tokenChangeRequest.send(null);
        window.parent.wait.show();
    }

    function callAjax(url, stateChangeFunc, ajaxRequest) {

        if (ajaxRequest == null) {
            alert("Your browser does not support AJAX!");
            return;
        }

        ajaxRequest.onreadystatechange = stateChangeFunc;

        ajaxRequest.open("GET", url, true);
        // Set this header to prevent caching of response by IE
        ajaxRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
        ajaxRequest.send(null);
    }

    function showMenuWithAuthorizedActions(menu, flowObjectId) {
        var url = "inject?";
        var instanceIdsParams = "";
        //var menuItems = menu.getItems();

        url += "&authorize=true";
        var j = 0;

        var items = menu.getChildren();
        for (; j < items.length; j++) {
            if (items[j].id != undefined && items[j].id != "") {
                url += "&action=" + items[j].id;
            }
        }
        /*while ((item = menu.getItem(j++)) != undefined) {
            if (item.value != undefined && item.value != "") {
                url += "&action=" + item.value;
            }
        }*/

        /*for (var i = 0; i < menuItems.length; i++) {
            if (menuItems[i].value != undefined && menuItems[i].value != "") {
                url += "&action=" + menuItems[i].value;
            }
        }*/

        for (var i = 0; i < instanceIds.length; i++) {
            instanceIdsParams += "&" + DATA_URL_PARTS.instanceIdParam + "=" + instanceIds[i];
        }

        url += instanceIdsParams + "&flowObjId=" + flowObjectId;
        activeActivityId = flowObjectId;

        dojo.xhrGet({
            url: url,
            handleAs: "xml",
            load: dojo.hitch(this, function(data) {
                showMenuAuthSuccessHandler(data, menu);
            }),
            error: dojo.hitch(this, function(error, ioargs) {
                showMenuAuthFailureHandler(error, ioargs);
            })
        });
    }

    function showMenuAuthSuccessHandler(o, menuToShow) {
        var doc = o;
        var authorizationData = doc.getElementsByTagName("AUTHORIZATION-DATA");
        //var menuItems = o.argument.menuToShow.getItems();
        
        var items = menuToShow.getChildren();
        for (var j = 0; j < items.length; j++) {
            if (items[j].id != undefined && items[j].id != "") {
                items[j].disabled = !isActionPermitted(items[j].id, authorizationData);
            }
        }
        /*while ((menuItem = menu.getItem(j++)) != undefined) {
            if (menuItem.value != undefined && menuItem.value != "") {
                menuItem.cfg.setProperty("disabled", !isActionPermitted(menuItem.value, authorizationData));
            }
        }*/

    /*    for (var i = 0; i < menuItems.length; i++) {
            menuItems[i].cfg.setProperty("disabled", !isActionPermitted(menuItems[i].value, authorizationData));
        }*/

        reassignDialog.show();
        dojo.style(dojo.byId("dojo-menu"), "display", "block");
    }

    function showMenuAuthFailureHandler(o, ioargs){
        alert("Authorization request failed." +  ioargs.xhr.status + " " + o);
    }

    function isActionPermitted(requestedActionName, authorizationData) {
        var actions = authorizationData[0].getElementsByTagName("ACTION");
        if (actions.length != 0) {
            for (var i = 0; i < actions.length; i++) {
                var actionNameNode = actions[i].getElementsByTagName("NAME");
                var isPermittedNode = actions[i].getElementsByTagName("PERMITTED");
                var actionName  = actionNameNode[0].firstChild.nodeValue;
                var isPermitted = isPermittedNode[0].firstChild.nodeValue;

               /* if (isInternetExplorer()) {
                    actionName = actionNameNode[0].text;
                    isPermitted = isPermittedNode[0].text;
                } else {
                    actionName = actionNameNode[0].textContent;
                    isPermitted = isPermittedNode[0].textContent;
                }*/
                if (requestedActionName == actionName) {
                    if (isPermitted == "true") {
                        return true;
                    } else {
                        return false;
                    }
                }
            }
        }
        return false;
    }

    var isMouseOver = false;
    bpd.onMouseOver = function(bpdId, x, y) {
        timerOver = setTimeout("bpd.doOnMouseOver('" + bpdId + "'," + x + "," + y + ")", 1000);
    };

    function processTokenChangeResponse(response, action) {
        window.parent.wait.hide();

        if (response != undefined) {
            var errorElem = response.getElementsByTagName("ERROR");
            if (errorElem != undefined && errorElem.length != 0) {
                var errorCode = errorElem[0].attributes.getNamedItem("code").value;

                if(action == ACTION_REASSIGN_TASK_BACK_TO_ROLE) {
                    var errorMsgElem = document.getElementById("errorDialog.errorMessage");
                    if (errorCode == "reassign.task.user-or-role.not-authorized") {
                        errorMsgElem.innerHTML = "<p>You are not authorized to reassign<br>the task(s)</p>";
                    }
                    errorDialog.show();
                }
                else if(action == ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE) {
                    var errorMsgElem = document.getElementById("participantDialog.errorMessage");
                    if (errorCode == "reassign.task.user-or-role.not-authorized") {
                        errorMsgElem.innerHTML = "<p>You are not authorized to reassign<br>the task(s) to this user or group</p>";
                    }
                    else if (errorCode == "reassign.task.user-or-role.not-found") {
                        errorMsgElem.innerHTML = "<p>No valid user or group supplied</p>";
                    }
                    setDisplayVisible(errorMsgElem, true);
                    dijit.byId("participantDialog").show();
                    //participantDialog.show();
                }

                return;
            }
        }

        if(action != ACTION_REASSIGN_TASK_BACK_TO_ROLE && action != ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE) { 
            refresh();
        }
            
        // Notify parent "processDiagram" window about process instance's state change
        if (window.parent.processInstanceStateChangedFromProcessInstanceDiagram) {
            window.parent.processInstanceStateChangedFromProcessInstanceDiagram();
        }
    }

    bpd.doOnMouseOver = function(bpdId, x, y) {
        if(!isMouseOver) {
            isMouseOver = true; // prevent bunch of calls to server as it hungs to the flash diagram
            var info = this.getInfo(bpdId);
            if (info != null && info.componentType == "Activity") {
                showItemData(instanceId, bpdId, x, y);
            }
        }
    };

    bpd.onMouseOut = function(bpdId, x, y) {
        var dropmenuobj = document.getElementById("hintbox");
        dropmenuobj.style.visibility = "hidden";
        dropmenuobj.style.left = "-500px";
        isMouseOver = false; // release
        clearTimeout(timerOver);
    };

    bpd.onContextMenu = function(flowObjectId) {
        var info = this.getInfo(flowObjectId);
        var activeElements = info.activeFlowObjects;
        var enableInjectToken = <%= AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecuteAction(ActionPolicy.ACTION_INJECT_TOKEN, null) ? "true" : "false" %>;
        var enableMoveToken = <%= AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecuteAction(ActionPolicy.ACTION_MOVE_TOKEN, null) &
                                  TWConfiguration.getInstance().getServer().getPortal().isAdhocRerouteEnabled() ? "true" : "false" %>;
        var menu = new Array();
        if (enableInjectToken) {
            menu[menu.length] = [
                message_initiate_flow
                <% if(!InjectServlet.getStartInjectionEvents(instanceIds).isEmpty()) { %> , function () {
                    adHocDialog.show();
                }
                <% } %>
            ];
        }

        var func = null;
        var disabled = true;
        for (var i = 0; i < idsOfActivitiesWithTokens.length; i++) {
            if (idsOfActivitiesWithTokens[i] == flowObjectId) {
                disabled = false;
                break;
            }
        }

        if (enableMoveToken) {
            if (!disabled) func = function () {
                activeActivityId = flowObjectId;
                activitiesDialog.show();
            };
            menu[menu.length] = [
                message_reroute, func
            ];
        }

        func = null;
        if (!disabled && info.attachedOverlay != "attachedSubprocess") {
            func = function () {
                showMenuWithAuthorizedActions (reassignMenu, flowObjectId);
                //requestAuthorizationForReassignTasks(flowObjectId);
            };
        }

        
        menu[menu.length] = [
            message_reassign_task, func
        ];

        if (info.attachedOverlay == "attachedSubprocess") {
            menu[menu.length] = [
                showDiagram_flash_contextMenu_viewSubprocess + " \"" + info.name + "\"", function() {
                    openBPDbyID(info.name, info.attachedId, info.id);
                }
            ];
        }
        if (stack.length > 1) {
            menu[menu.length] = [
                showDiagram_flash_contextMenu_viewSuperprocess, function() {
                    openParentBPD();
                }
            ];
        }
        return menu;
    };

    bpd.onLoadBPD = function() {
        var activeElements = bpd.getInfo(bpd.getCurrentBPD()).activeFlowObjects;

        if (activeElements) {
            var haloObjects = new Array();
            for (var i = 0; i < activeElements.length; i++) {
                var currentObj = haloObjects[activeElements[i].flowObjectID];
                if (currentObj) {
                    haloObjects[activeElements[i].flowObjectID].counter += 1;//", #" + activeElements[i].instanceID;
                } else {
                    haloObjects[activeElements[i].flowObjectID] = {
                         counter: 1, //showDiagram_flash_view_token + " #" + activeElements[i].instanceID;
                         hasToken: !!(activeElements[i].tokenID)
                    };
                }
            }
            for (var key in haloObjects) {
                if (haloObjects[key].hasToken) {
                    bpd.setHaloColor(key, parseInt("0xffff00"));
                } else {
                    bpd.setHaloColor(key, parseInt("0x3934ff"));
                }
                // this line commented according to TW-170
               if(haloObjects[key].counter > 1) bpd.setHaloText(key, "#" + haloObjects[key].counter);
            }
        }

        // Load delayed selection if any. Should be set only if manually calling showBpd(...)
        // i.e. when selecting item while still waiting bpd diagram to load. 
        if (selectedId) {
            bpd.setSelected(selectedId, true);
        }

        if (firstRun && parent.opener && parent.opener.diagramToTable) {
            firstRun = false;
            parent.opener.diagramToTable({action: "onload"});
        }
    };

    <%--
    function changeSkin() {
        bpd.setCurrentSkin( skinSelect.value );
    }
    */
    --%>
</script>

</head>
<body onload="onLoad();" class="soria">
<!-- The content of "participantDialog". Initially, the content is not displayable. -->
<div id="participantDialog" dojoType="dijit.Dialog" title='<bean:message key="generateprocess.div.title.user.role" bundle="ProcessPortal"/>'>
    <div class="bd">
        <div id="participantDialog.errorMessage" style="color: red; display: none">
    </div>
        <form name="dlgForm" method="POST" action="inject">
            <p><bean:message key="generateprocess.message.user.role" bundle="ProcessPortal"/></p>
            <label for="participant"><bean:message key="generateprocess.label.user.role" bundle="ProcessPortal"/></label>
            <input id="participant" dojoType="dijit.form.TextBox" name="participant" />
        </form>
    </div>
    <button dojoType="dijit.form.Button" style="float:right;" type="button" onClick="handleCancel()">
        <bean:message key="generateprocess.button.cancle" bundle="ProcessPortal"/>
    </button>
    <button dojoType="dijit.form.Button" style="float:right;" type="submit" onClick="handleSubmit()">
        <bean:message key="generateprocess.button.ok" bundle="ProcessPortal"/>
    </button>
    <div style="clear:both;"></div>
</div>

<!-- The content of "errorDialog". Initially, the content is not displayable. -->
<div id="errorDialog" dojoType="dijit.Dialog" title='<bean:message key="generateprocess.div.title.error" bundle="ProcessPortal"/>'>
    <div class="bd">
        <div id="errorDialog.errorMessage" style="color: red; display: block">
    </div>
    <button dojoType="dijit.form.Button" style="float:right;" type="submit" onClick="handleErrorDialogOk()">
        <bean:message key="generateprocess.button.ok" bundle="ProcessPortal"/>
    </button>
    <div style="clear:both;"></div>
</div>
<div id="reassign-menu" style="display:none;"></div>
<nobr class="body-notice"><strong><bean:message key="generateprocess.message.note" bundle="ProcessPortal"/></strong> <bean:message key="generateprocess.message.expose" bundle="ProcessPortal"/></nobr>
<%--<span style="color: #BFCFDE; font-weight: bold;">Skin: </span>
<select id="skins" onkeyup="changeSkin()" onchange="changeSkin()"></select>--%>
<input type="button" id="drillButton" value="" style="visibility: hidden;" >
<%--
<bpd id="flash" flash-url="/portal/flash/diagram.swf"
     bpd-url="generateProcessInstanceFlashData.jsp?bpdInstanceId=<%=request.getParameter("bpdInstanceId") %>"></bpd>
--%>
</body>
</html>
