<%@ page language="java" pageEncoding="UTF-8" contentType="text/xml; charset=UTF-8"%>
<%@ page import="java.math.BigDecimal"%>
<%@ page import="com.lombardisoftware.portal.utils.BPDToSVG"%>
<%@ page import="com.lombardisoftware.data.criticalpath.CPPathData" %>
<%@ page import="com.lombardisoftware.client.persistence.common.POType"%>
<%@ page import="com.lombardisoftware.client.persistence.common.ID"%>
<%
    response.setHeader("Cache-Control","max-age=0"); //HTTP 1.1
    response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
    response.setHeader("Pragma","public"); //HTTP 1.0
    String instanceIdStrings[] = request.getParameterValues("bpdInstanceId");
    String bpdIdString = request.getParameter("bpdId");
    String parentGUID = request.getParameter("parentId");
    String cpTypeString = request.getParameter("cpType");
    CPPathData cpData = (CPPathData) request.getSession().getAttribute("criticalPath");

    // Trim path component.
    int pathDelimiter = bpdIdString.lastIndexOf("/");
    if (pathDelimiter >= 0) {
        bpdIdString = bpdIdString.substring(pathDelimiter + 1);
    }
    
    ID<POType.BPD> bpdId = POType.BPD.cast(ID.fromExternalString(bpdIdString));

    if (instanceIdStrings != null && instanceIdStrings.length > 0 && bpdIdString != null && bpdIdString.length() > 0) {
        BigDecimal[] instanceIds = new BigDecimal[instanceIdStrings.length];
        for (int i = 0; i < instanceIdStrings.length; i++ ) {
            instanceIds[i] = new BigDecimal(instanceIdStrings[i]);
        }
        if (cpData != null && cpTypeString != null) {
            out.println(BPDToSVG.getBpdXml(instanceIds, bpdId, parentGUID, cpData));
        } else {
            out.println(BPDToSVG.getBpdXml(instanceIds, bpdId));   
        }
    } else {
%>
<error>'bpdInstanceId' parameter was not found</error>
<%  } %>
