<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.servlet.InjectServlet" %>
<%@ page import="java.math.BigDecimal" %>
<%@ page import="java.util.Map, java.util.List" %>
<%@ page import="com.lombardisoftware.client.delegate.AuthorizationAPIDelegateFactory,
                 com.lombardisoftware.server.api.ActionPolicy"%>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.Set" %>
<%@ page import="com.lombardisoftware.core.TeamWorksException" %>
<%@ page import="com.lombardisoftware.bpd.model.bpmn.BpmnObjectId" %>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.lombardisoftware.portal.utils.LocaleUtil" %>
<%@ page import="com.lombardisoftware.client.delegate.BPDInstanceAPIDelegate, com.lombardisoftware.data.criticalpath.CPPathData,
                                com.lombardisoftware.client.delegate.BPDInstanceAPIDelegateFactory" %>
<%@ include file="contextRoot.jsp" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%!private static final String BPD_INSTANCE_ID_PARAM = "bpdInstanceId"; %>

<%
    String[] instanceIdsString = request.getParameterValues(BPD_INSTANCE_ID_PARAM);
    if (instanceIdsString == null || instanceIdsString.length == 0) {
        throw new TeamWorksException("There is no one '" + BPD_INSTANCE_ID_PARAM + "' parameter found in the request");
    }

    BigDecimal[] instanceIds;
    instanceIds = new BigDecimal[instanceIdsString.length];
    for (int i = 0; i < instanceIdsString.length; i++) {
        instanceIds[i] = new BigDecimal(instanceIdsString[i]);
    }

    String localeLanguage = "";
    Locale userLocale = LocaleUtil.getLocaleFromUserPreferences(request);
    System.out.println("Lang: " + userLocale);
    if(Locale.CHINESE.getLanguage().equals(userLocale.getLanguage())) {
        localeLanguage = userLocale.toString();
        if("zh_HK".equals(userLocale.toString())) {
            localeLanguage = Locale.TRADITIONAL_CHINESE.toString();
        } else if("zh_SG".equals(userLocale.toString())) {
            localeLanguage = Locale.SIMPLIFIED_CHINESE.toString();
        } else if(!Locale.SIMPLIFIED_CHINESE.equals(userLocale) && !Locale.TRADITIONAL_CHINESE.equals(userLocale)) {
           localeLanguage = Locale.SIMPLIFIED_CHINESE.toString();
        }
    } else if(Locale.JAPAN.equals(userLocale) ||
            Locale.JAPANESE.equals(userLocale) ||
            Locale.KOREA.equals(userLocale) ||
            Locale.KOREAN.equals(userLocale)) {
        localeLanguage = userLocale.getLanguage();
    }
    System.out.println("Lang for iLog: " + localeLanguage);
    
    String locale = localeLanguage;    
    
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title><bean:message key="main.message.title" bundle="ProcessPortal"/></title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE7" />
<link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css" media="screen, projection" />
<%@ include file="diagrammerCss.jsp" %>
<%@ include file="diagrammerEnv.jsp" %>

<link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css" media="screen, projection" />
<link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css" />

<script type="text/javascript" src="<%=request.getContextPath()%>/js/hint.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/ajaxutils.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/utils.js"></script>


<script type="text/javascript">
    dojo.require("dijit.Dialog");
    dojo.require("dijit.form.Button");
    dojo.require("dijit.form.TextBox");
    dojo.require("dijit.Menu");
    dojo.require("dijit.MenuItem");

    dojo.require("dojo.data.ItemFileWriteStore");
    dojo.require("dijit.layout.BorderContainer");
    dojo.require("dijit.layout.ContentPane");
            
    dojo.require( "com.ibm.bpm.wpd.document.bpd.view.BPDViewer");
    dojo.require("com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider");
        dojo.require("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");

    var message_initiate_flow = "Initiate Flow...";
    var message_reroute = "Re-route...";
    var message_reassign_task = "Re-assign Task...";
    var reassign_back_to_group = "Re-assign Task Back to Group";
    var reassign_to_user_or_group = "Re-assign Task to a User or Group";
    var reassign_task_title = "Re-assign Task";
    var reroute_task_title = "Re-route";
    var message_initiate_title = "Initiate Flow";
    
    var jsonResURL = "<%= teamworksContextRoot %>/jsonResBundleLoader?bundle=FlashDiagramMessages";
    
    dojo.xhrGet( {
      url: jsonResURL,
      handleAs: "json",
      load: function(o) {
        message_initiate_flow = o.menu_initiate_flow;
        message_reroute = o.menu_reroute;
        message_reassign_task = o.menu_reassign_task;
        reassign_back_to_group = o.reassign_back_to_group;
        reassign_to_user_or_group = o.reassign_to_user_or_group;
        reassign_task_title = o.reassign_task_title;
        // TBD: need to add two more messages
        // reroute_task_title = o.reroute_task_title;
        // message_initiate_title = o.message_initiate_title;

        // Render after the resource is ready to use
        render();
      },
      error: function(o) {
        // Try to render with English labels
        render();
      }
    });
</script>

<script language="JavaScript">
<!--
var sURL = unescape(window.location.pathname);
function refresh() {
    window.location.href = sURL;
}
//-->
</script>

<script language="JavaScript1.1">
<!--
function refresh() { window.location.replace( sURL ); }
//-->
</script>

<script language="JavaScript1.2">
<!--
function refresh() { window.location.reload( false ); }
//-->
</script>

<style type="text/css">


#hintbox{ /*CSS for pop up hint box */
    position:absolute;
    top: 0;
    background-color: lightyellow;
    width: 150px; /*Default width of hint.*/
    padding: 3px;
    border:1px solid black;
    font:normal 11px Verdana;
    line-height:18px;
    z-index:100;
    border-right: 3px solid black;
    border-bottom: 3px solid black;
    visibility: hidden;
}

.hintanchor{ /*CSS for link that shows hint onmouseover*/
    font-weight: bold;
    color: navy;
    margin: 3px 8px;
}


#reassignDialog .dijitDialogPaneContent,
#adhocDialog .dijitDialogPaneContent,
#activitiesDialog .dijitDialogPaneContent{
    padding: 0px;
    border: none;
}
/* make html/body to fit the height of its parent */
html {
    height: 100%;
    overflow: hidden;
}
body {
    height: 100%;
    margin: 0;
    padding: 0;
    overflow:hidden;
}
</style>


<script type="text/javascript" src="<%=request.getContextPath()%>/jsp/js/core.jsp"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/main.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/jsp/js/messages.jsp"></script>
<script type="text/javascript">

    var firstRun = true;
    function tableToDiagram(param) {
 
    }

    var horizontal_offset = "9px"; //horizontal offset of hint box from anchor link

    /////No further editting needed

    var vertical_offset = "0"; //horizontal offset of hint box from anchor link. No need to change.
    var ie = document.all;
    var ns6 = document.getElementById && !document.all;
    function createhintbox() {
        var divblock = document.createElement("div");
        divblock.setAttribute("id", "hintbox");
        document.body.appendChild(divblock);
    }

    if (window.addEventListener) {
        window.addEventListener("load", createhintbox, false);
    }
    else if (window.attachEvent) {
        window.attachEvent("onload", createhintbox);
    }
    else if (document.getElementById) {
        window.onload = createhintbox;
    }

    var DATA_URL_PARTS = {
        path: "generateProcessInstanceFlashData.jsp",
        instanceIdParam: "bpdInstanceId",
        bpdIdParam: "bpdId",
        parentId: "parentId",
        cpType: "cpType"
    };
    var ESCAPED_PARAM_DELIMITER = "%26";
    var PARAM_DELIMITER = "&";

    var instanceId = window.parent.instanceId;
    var instanceIds = window.parent.instanceIds;
    var cpType = window.parent.cpType;
    var activeActivityId;
    var idsOfActivitiesWithTokens;
 
    var bpd;
    var selectedId = null;
    var waitingForSecondClick = false;
    var timer;
    var timerOver;
    var drillButton;
    var clickx;
    var clicky;
    var contextMenu;

    var bpdItemDataRequest;
    var tokenChangeRequest;
    var reassignTo;
    var ACTION_REASSIGN_TASK_BACK_TO_ROLE = '<%= InjectServlet.REASSIGN_TASK_BACK_TO_ROLE %>';
    var ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE = '<%= InjectServlet.REASSIGN_TASK_TO_A_USER_OR_ROLE %>';

    var participantDialog;
    var errorDialog;
    var reassignMenu;
    var reassignDialog;
    var contextMenu;
    var contextDialog;
    var adHocMenu;
    var adHocDialog;
    var activitiesMenu;
    var activitiesDialog;


    var handleCancel = function() {
  console.debug ("cacnel begin");
        var errorMsgElem = document.getElementById("participantDialog.errorMessage");
        setDisplayVisible(errorMsgElem, false);
        errorMsgElem.innerHTML = "";
        // dijit.byId("participantDialog").hide();
        participantDialog.hide();
        
   console.debug ("cacnel end");
    };

    var handleSubmit = function() {
        // debugger;
        console.debug ("submitting");
        reassignTo = dijit.byId("participant").attr("value");
        // dijit.byId("participantDialog").hide();
        sendTokenChangeRequest(activeActivityId, ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE);
    };

    var handleErrorDialogOk = function() {
        var errorMsgElem = document.getElementById("errorDialog.errorMessage");
        errorMsgElem.innerHTML = "";
        // dijit.byId("participantDialog").hide();
        participantDialog.hide();
    };


    dojo.addOnLoad(function(){
        // Add key listener to participant dialog text box
        dijit.byId("participant").connect(this, "onkeydown", function(event) {
            if(event.keyCode == dojo.keys.ENTER) {
                handleSubmit();
                dojo.stopEvent(event);
            }
        });
    });

 
 
    function render() {
        drillButton = document.getElementById("drillButton");
    
        // Build reassign menu, and then wrap it in a dialog
        reassignMenu = new dijit.Menu({
            targetNodeIds:["reassign-menu"],
            id: "dojo-menu"
        });

        reassignMenu.addChild(
            new dijit.MenuItem({
                label: reassign_back_to_group,
                disabled: false,
                onClick:  function() {
                    sendTokenChangeRequest(activeActivityId, ACTION_REASSIGN_TASK_BACK_TO_ROLE);
                    reassignDialog.hide();
                }
            })
        );

        reassignMenu.addChild(
            new dijit.MenuItem({
                label:reassign_to_user_or_group,
                disabled: false,
                onClick: function() {
                    var errorMsgElem = document.getElementById("participantDialog.errorMessage");
                    setDisplayVisible(errorMsgElem, false);
                    errorMsgElem.innerHTML = "";
                    dijit.byId("reassignDialog").hide();
                    // dijit.byId("participantDialog").show();
                    participantDialog.show();
                }
            })
        );
     
        reassignMenu.startup();

        // Create a dialog and put the menu in so we can display like a popup
        reassignDialog = new dijit.Dialog({
            title: reassign_task_title,
            id: "reassignDialog",
            style: "min-width:130px;"
        });
        reassignDialog.attr("content", reassignMenu);

        // Build Adhoc menu, and then wrap it in a dialog
        adHocMenu = new dijit.Menu({
            id: "adhocmenu"
        });

        <%
            Map map = InjectServlet.getStartInjectionEvents(instanceIds);
            Iterator items = map.keySet().iterator();
            while(items.hasNext()) {
                String adHocItem = (String) items.next();
        %>
            adHocMenu.addChild(
                new dijit.MenuItem({
                    label: "<%= map.get(adHocItem) %>",
                    onClick: function() {
                        sendTokenChangeRequest('<%= adHocItem %>', '');
                    }
                }
            ));
        <% } %>
        adHocMenu.startup();

        // Add the adhoc menu to the dialog
        adHocDialog = new dijit.Dialog({
            title: message_initiate_title,
            id: "adhocDialog",
            style: "min-width:130px;"
        });

        adHocDialog.attr("content", adHocMenu);

        // Build Activities menu
        activitiesMenu = new dijit.Menu({
            id: "activitiesmenu"
        });


        <%
            map = InjectServlet.getActivities(instanceIds);
            items = map.entrySet().iterator();
            while(items.hasNext()) {
                Map.Entry item = (Map.Entry) items.next();
        %>
            activitiesMenu.addChild(
                new dijit.MenuItem({
                    label: "<%= item.getValue() %>",
                    onClick: function() {
                        sendTokenChangeRequest('<%= item.getKey() %>', 'move');
                    }
                }
            ));

        <% } %>
        activitiesMenu.startup();

        // Add the adhoc menu to the dialog

        activitiesDialog = new dijit.Dialog({
            title: reroute_task_title,
            id: "activitiesDialog",
            style: "min-width:130px;"
        });

        activitiesDialog.attr("content", activitiesMenu);

        // gather ids of activities with token
        idsOfActivitiesWithTokens = new Array(); <%
        Set set = InjectServlet.getActivityIdWithTokens(instanceIds);
        for(Object aSet: set){
            %>idsOfActivitiesWithTokens[idsOfActivitiesWithTokens.length] = '<%=aSet%>';<%
        } %>


             participantDialog = dijit.byId("participantDialog");
             createDiagram();
        
             if (firstRun && parent.opener && parent.opener.diagramToTable) {
            firstRun = false;
            parent.opener.diagramToTable({action: "onload"});
        }
   
        }
        
     
     function createDiagram (){
            var project={};
            var state = "Portal";
            var style = "position: absolute; top: 0px; bottom: 0px; right:0px; left:0px; border:0px";
            var criticalPathFlowIds =new Array()
<%
    String parentGUID = request.getParameter("parentId");
    String cpTypeString = request.getParameter("cpType");    
    CPPathData cpData = (CPPathData) request.getSession().getAttribute("criticalPath");
    BPDInstanceAPIDelegate delegate = BPDInstanceAPIDelegateFactory.getInstance().newInstance();
    if (cpData!=null && cpTypeString!=null) {
        List<String> criticalPathFlows = delegate.getCriticalPathFlows(cpData, parentGUID); 
        for (int i=0; i<criticalPathFlows.size(); i++) {
%>          
                criticalPathFlowIds[<%=i%>]='<%=criticalPathFlows.get(i)%>';
<%          
        }   
    }

%>          
            var provider = new com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider();
        provider.config = {
            onNodeContextMenu : creatContextMenu,
                    onMouseMove: hideItem,
                    onNodeClick : showItem,
                    showExecutionPath : true,
                    showCurrentActivites : true,
                    showNote : false,
                    showColor : true,
                    showToolbarOnBreadCrumb: true,
                    showSearchOnToolBar: false,
                    criticalPathFlowIds : criticalPathFlowIds
        };
        
            // provider.diagramEventHandlers = diagramEventHandlers;
            var providers = [provider];

            // this is a div in the dom tree to which the webviewer component will be attached to by dojo       
            var t = document.getElementById("bpdEditor");
            // BreadcrumView will instantiate both the breadcrum and the bpd diagram view
            var view =  com.ibm.bpm.wpd.base.createWebViewerComponenet("com.ibm.bpm.wpd.core.view.BreadcrumbView", project, style, t, state, providers);
            
            var params = {
                    instanceId : instanceId,
                    instanceIds : instanceIds,
                    type : "ProcessInstanceType",
                    bpdId : window.parent.instanceBpdId,
                    instanceName : window.parent.instanceName
                };
    
            // fire the open doc event to open the diagram and the breadcrumb
          (new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent(params)).dispatch();       
     }
        
        function showItem (node,ev){
                debugger;

                //Handle the user clicking on a PNG with <div> elements
                if ( !ev ){
                    ev = node;
                    var x = ev.layerX + 40;
                    var y = ev.layerY + 40;
                    var flowId = node.target.getAttribute('name');
                    //var flowId = node.target.getAttribute('name'): 
                    var item = this.IDtoItemMap.item( flowId );
                    var nodeType = item.type;
                    var bpmn2Type = item.bpmn2TaskType;
                    node.isActive = item.counter;

                }else{
                    //Handle other cases
                    //Get the x & y co-ordinates where the user clicked on the diagram.
                    var x = ev.layerX ? ev.layerX + 40 : ev.clientX + 5;
                    var y = ev.layerY ? ev.layerY + 30 : ev.clientX + 5;
                    var item = node._data.item;
                    var flowId = node._data.item.id[0];
                    var nodeType = node._data.item.type[0];
                    var bpmn2Type = item.bpmn2TaskType[0];
                }

           
                if (nodeType == "activity"  && bpmn2Type == "UserTask" && node.isActive) {
                    // debugger;
                    showItemData(instanceId, flowId, x, y);
                }
        }
        
        function showItemData(instanceId, selectedId, x, y) {
        
        bpdItemDataRequest = GetXmlHttpObject();
        if (bpdItemDataRequest == null) {
            alert("Your browser does not support AJAX!");
            return;
        }
        clickx = x;
        clicky = y;
        var url = "getBPDItemData.do?bpdInstanceId=" + instanceId + "&flowObjId=" + selectedId;
        bpdItemDataRequest.onreadystatechange = stateChanged;
        bpdItemDataRequest.open("GET", url, true);
        // Set this header to prevent caching of response by IE
        bpdItemDataRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
        bpdItemDataRequest.send(null);
    }

        
        function hideItem (node,ev) {
         
            var dropmenuobj = document.getElementById("hintbox");
            if ( dropmenuobj ){
                dropmenuobj.style.visibility = "hidden";
                dropmenuobj.style.left = "-500px";
            }
        }
   
   // create a context menu for an active user task 
   function creatContextMenu (node, ev) {

        debugger;

        //Special target handling for silverlight nodes. 
        //Use the DOM element for the Silverlight container.
        var isSilverlight = false;
        var reassignTask = true;


        if ( node.target ){
            //Image is being rendered with a server side PNG
            var evtSource = 'PNG';
            var id = node.target.getAttribute( 'name' );
            var item = this.IDtoItemMap.item( id );
            var type = item.type;
            var bpmn2TaskType = item.bpmn2TaskType;
            var flowObjectId = id;
            node.isActive = item.counter;
                    
        }else if ( node['getData'] == undefined ){
            //Image is being rendered by Silverlight
            var evtSource = 'Silverlight';
            node = this;
            
        }else{
            var evtSource = "SVG";
             var data = node.getData();
            var item = data.item;
            var store = data.store;
            var type = store.getValue( item, 'type' );
            var bpmn2TaskType = store.getValue( item, 'bpmn2TaskType' );
            var flowObjectId = store.getValue( item, 'id' );
        }
     
             activeActivityId = flowObjectId;
/*
            if (type != "activity" ||  bpmn2TaskType != "UserTask" || !node.isActive )
                    return;
 */
 						if (type != "activity" ||  bpmn2TaskType != "UserTask" || !node.isActive )
                     reassignTask = false;
                    
            // console.debug ("attach context menu to an active task"); 

                    
       hideItem(node, ev);
       var enableInjectToken = <%= AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecuteAction(ActionPolicy.ACTION_INJECT_TOKEN, instanceIds[0]) ? "true" : "false" %>;
       var enableMoveToken = <%= AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecuteAction(ActionPolicy.ACTION_MOVE_TOKEN, instanceIds[0]) &
                                  TWConfiguration.getInstance().getServer().getPortal().isAdhocRerouteEnabled() ? "true" : "false" %>;
 
       contextMenu = new dijit.Menu({});       
 
             var isAdhoc = <%= (!InjectServlet.getStartInjectionEvents(instanceIds).isEmpty())? "true" : "false" %>;
         if (enableInjectToken ) {
            contextMenu.addChild(
            new dijit.MenuItem({
                label:  message_initiate_flow,
                disabled: !isAdhoc,
                style:"margin:25px;",
                onClick: function() {
                                adHocDialog.show();  
                }
            })
            )};

        var func = null;
        var disabled = true;
        for (var i = 0; i < idsOfActivitiesWithTokens.length; i++) {
            if (idsOfActivitiesWithTokens[i] == flowObjectId) {
                disabled = false;
                break;
            }
        }

         contextMenu.addChild(
            new dijit.MenuItem({
                label:  message_reroute,
                disabled: !enableMoveToken,
                onClick: function() {
                    activitiesDialog.show();  
                }
            })
            );

       func = null;
       if (!disabled ) {
            func = function () {
                showMenuWithAuthorizedActions (reassignDialog, flowObjectId);
            };
       }
        
       contextMenu.addChild(
            new dijit.MenuItem({
                label: message_reassign_task ,
                disabled: !reassignTask,
                onClick:  func
            })
       );
        
       
       contextMenu.startup();
       if ( evtSource == 'PNG' ){
            contextMenu.bindDomNode(node.target);
       }
       else if ( evtSource == 'Silverlight' )
            contextMenu.bindDomNode(node.viewer.domNode);
        else
            contextMenu.bindDomNode( node.getEventSource() );

        }

    function GetXmlHttpObject() {
        var newXmlHttp = null;
        try {
            // Firefox, Opera 8.0+, Safari, IE7
            newXmlHttp = new XMLHttpRequest();
        } catch (e) {
            // Internet Explorer
            try {
                newXmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (e) {
                newXmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            }
        }
        return newXmlHttp;
    }
    

    function stateChanged() {
        if (bpdItemDataRequest.readyState == 4) {

            var doc = bpdItemDataRequest.responseXML;
            var taskData = doc.getElementsByTagName("TASKDATA");

            if(taskData.length != 0) {
                var taskInfoTables = "";

                for (var i = 0; i < taskData.length; i++) {
                    var data = taskData[i].getElementsByTagName('DATA');
                    if(data.length != 0) {
                        var isTaskOpen = true;
                        var table = "<table class=\"content-table\">";
                        for (var j = 0; j < data.length; j++) {
                            var property = data[j].getElementsByTagName('NAME');
                            var value = data[j].getElementsByTagName('VALUE');
                            var text;
                            var valueText;
                            if(isInternetExplorer()){
                                text = property[0].text;
                                valueText = value[0].text;
                            } else {
                                text = property[0].textContent;
                                valueText = value[0].textContent;
                            }

                            if (text == "Status:") {
                                if(valueText == "Closed") {
                                    // in case of a closed task don't show the details for it
                                    isTaskOpen = false;
                                    break;
                                }
                            } else if (isInternetExplorer()) { // Firefox or Internet Explorer
                                table = table + '<tr><td><b>' + text + '</font></b></td><td>';
                                table = table + valueText + '</font></td></tr>';
                            } else {
                                table = table + '<tr><td><b>' + text + '</font></b></td><td>';
                                table = table + valueText + '</font></td></tr>';
                            }
                        }
                        table = table + '</table>';
                        if (isTaskOpen) {
                            taskInfoTables += table;
                        }
                    }
                }
                if (taskInfoTables != "") {
                    showTip(taskInfoTables, clickx, clicky, '260px');
                }
           }
        }
    }

    function showTip(menucontents, x, y, tipwidth) {
        if ((ie || ns6) && document.getElementById("hintbox")) {
            var dropmenuobj = document.getElementById("hintbox");
            dropmenuobj.innerHTML = menucontents;
            dropmenuobj.style.left = dropmenuobj.style.top = -500;
            if (tipwidth != "") {
                dropmenuobj.widthobj = dropmenuobj.style;
                dropmenuobj.widthobj.width = tipwidth;
            }
            dropmenuobj.x = x;
            dropmenuobj.y = y;
            dropmenuobj.style.left = (dropmenuobj.x + 5) + 'px';
            dropmenuobj.style.top = (dropmenuobj.y + 20) + 'px';
            dropmenuobj.style.visibility = "visible";
        }
    }

    function isInternetExplorer() {
        return window.ActiveXObject;
    }


    function sendTokenChangeRequest(flowObjId, action) {
        tokenChangeRequest = GetXmlHttpObject();
        if (tokenChangeRequest == null) {
            alert("Your browser does not support AJAX!");
            return;
        }
        var url = "inject?";
        var instanceIdsParams = "";
        for (var i = 0; i < instanceIds.length; i++) {
            instanceIdsParams += DATA_URL_PARTS.instanceIdParam + "=" +  instanceIds[i];
            if (i < instanceIds.length - 1)
                instanceIdsParams += "&";
        }
        url += "bpdInstanceId=" + instanceIdsParams + "&flowObjId=" + flowObjId;

        if (action == 'move') {
            url += "&flowObjIdFrom=" + activeActivityId;
            url += "&move=t";
        }

        if(action == ACTION_REASSIGN_TASK_BACK_TO_ROLE) {
            url += "&action=" + ACTION_REASSIGN_TASK_BACK_TO_ROLE;
        }

        if(action == ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE) {
            url += "&action=" + ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE;
            url += "&participant=" + reassignTo;
        }

        tokenChangeRequest.onreadystatechange = function () {
              console.debug ("send request, on state change, state =" + tokenChangeRequest.readyState);
            if (tokenChangeRequest.readyState == 4 && tokenChangeRequest.status == 200) {
                processTokenChangeResponse(tokenChangeRequest.responseXML, action);
            }
        };
        
        console.debug ("send request, url =" + url);
        
        tokenChangeRequest.open("GET", url, true);
        // Set this header to prevent caching of response by IE
        tokenChangeRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
        tokenChangeRequest.send(null);
        window.parent.wait.show();
   
    }

    function callAjax(url, stateChangeFunc, ajaxRequest) {

        if (ajaxRequest == null) {
            alert("Your browser does not support AJAX!");
            return;
        }

        ajaxRequest.onreadystatechange = stateChangeFunc;

        ajaxRequest.open("GET", url, true);
        // Set this header to prevent caching of response by IE
        ajaxRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
        ajaxRequest.send(null);
    }

    function showMenuWithAuthorizedActions(menu, flowObjectId) {
        reassignDialog.show();
        return;
        
        // there are bugs in the code below as menu is a dialog
        var url = "inject?";
        var instanceIdsParams = "";
        //var menuItems = menu.getItems();

        url += "&authorize=true";
        var item;
        var j = 0;

        while ((item = menu.getItem(j++)) != undefined) {
            if (item.value != undefined && item.value != "") {
                url += "&action=" + item.value;
            }
        }

        /*for (var i = 0; i < menuItems.length; i++) {
            if (menuItems[i].value != undefined && menuItems[i].value != "") {
                url += "&action=" + menuItems[i].value;
            }
        }*/

        for (var i = 0; i < instanceIds.length; i++) {
            instanceIdsParams += "&" + DATA_URL_PARTS.instanceIdParam + "=" + instanceIds[i];
        }

        url += instanceIdsParams + "&flowObjId=" + flowObjectId;
        activeActivityId = flowObjectId;

        dojo.xhrGet({
            url: url,
            handleAs: "xml",
            load: dojo.hitch(this, function(data) {
                showMenuAuthSuccessHandler(data, menu);
            }),
            error: dojo.hitch(this, function(error, ioargs) {
                showMenuAuthFailureHandler(error, ioargs);
            })
        });
    }

    function showMenuAuthSuccessHandler(o, menuToShow) {
        debugger;
        var doc = o;
        var authorizationData = doc.getElementsByTagName("AUTHORIZATION-DATA");
        //var menuItems = o.argument.menuToShow.getItems();
        var menu = menuToShow;
        var j = 0;

        while ((menuItem = menu.getItem(j++)) != undefined) {
            if (menuItem.value != undefined && menuItem.value != "") {
                menuItem.cfg.setProperty("disabled", !isActionPermitted(menuItem.value, authorizationData));
            }
        }

    /*    for (var i = 0; i < menuItems.length; i++) {
            menuItems[i].cfg.setProperty("disabled", !isActionPermitted(menuItems[i].value, authorizationData));
        }*/

        reassignDialog.show();
        dojo.style(dojo.byId("dojo-menu"), "display", "block");
    }

    function showMenuAuthFailureHandler(o, ioargs){
            debugger;
        alert("Authorization request failed." +  ioargs.xhr.status + " " + o);
    }

    function isActionPermitted(requestedActionName, authorizationData) {
        var actions = authorizationData[0].getElementsByTagName("ACTION");
        if (actions.length != 0) {
            for (var i = 0; i < actions.length; i++) {
                var actionNameNode = actions[i].getElementsByTagName("NAME");
                var isPermittedNode = actions[i].getElementsByTagName("PERMITTED");
                var actionName  = actionNameNode[0].firstChild.nodeValue;
                var isPermitted = isPermittedNode[0].firstChild.nodeValue;

               /* if (isInternetExplorer()) {
                    actionName = actionNameNode[0].text;
                    isPermitted = isPermittedNode[0].text;
                } else {
                    actionName = actionNameNode[0].textContent;
                    isPermitted = isPermittedNode[0].textContent;
                }*/
                if (requestedActionName == actionName) {
                    if (isPermitted == "true") {
                        return true;
                    } else {
                        return false;
                    }
                }
            }
        }
        return false;
    }

 
    function processTokenChangeResponse(response, action) {
        
        
            console.debug ("process response, action =" + action);
        window.parent.wait.hide();

        if (response != undefined) {
                    console.debug ("process response, response is defined");
            var errorElem = response.getElementsByTagName("ERROR");
            if (errorElem != undefined && errorElem.length != 0) {
                var errorCode = errorElem[0].attributes.getNamedItem("code").value;

                if(action == ACTION_REASSIGN_TASK_BACK_TO_ROLE) {
                    var errorMsgElem = document.getElementById("errorDialog.errorMessage");
                    if (errorCode == "reassign.task.user-or-role.not-authorized") {
                        errorMsgElem.innerHTML = "<p>You are not authorized to reassign<br>the task(s)</p>";
                    }
                     // TBD: errorDiaglog seems not initialzed.
                    errorDialog.show();
                }
                else if(action == ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE) {
                        // debugger;
                    var errorMsgElem = document.getElementById("participantDialog.errorMessage");
                    if (errorCode == "reassign.task.user-or-role.not-authorized") {
                        errorMsgElem.innerHTML = "<p>You are not authorized to reassign<br>the task(s) to this user or group</p>";
                    }
                    else if (errorCode == "reassign.task.user-or-role.not-found") {
                        errorMsgElem.innerHTML = "<p>No valid user or group supplied</p>";
                    }
                    setDisplayVisible(errorMsgElem, true);
                    // dijit.byId("participantDialog").show();
                    participantDialog.show();
                    console.debug ("process response, displayed error diaglog");
                 
                }
                return true;             
            }
        }
        // we don't want to refresh the diagram always that cause the UI to flash but we need to hide the left over dialog

                if (action == ACTION_REASSIGN_TASK_BACK_TO_ROLE || action == ACTION_REASSIGN_TASK_TO_A_USER_OR_ROLE)
                participantDialog.hide();
        else 
                refresh ();
        // Notify parent "processDiagram" window about process instance's state change
        if (window.parent.processInstanceStateChangedFromProcessInstanceDiagram) {
            window.parent.processInstanceStateChangedFromProcessInstanceDiagram();
        }
    }


    <%--
    function changeSkin() {
        bpd.setCurrentSkin( skinSelect.value );
    }
    */
    --%>
</script>

</head>
<!--
form name="dlgForm" method="POST" action="inject" onsubmit="handleSubmit()"
-->

<!-- the hello div to be removed.. inserted for testing-->
<body  class="soria" >
<div id="bpdEditor"  region="center" style="height: 100%; width: 100%"> 
<!-- The content of "participantDialog". Initially, the content is not displayable. -->
<div id="participantDialog" dojoType="dijit.Dialog" title='<bean:message key="generateprocess.div.title.user.role" bundle="ProcessPortal"/>'>
    <div class="bd">
        <div id="participantDialog.errorMessage" style="color: red; display: none">
    </div>
        <form name="dlgForm" method="Get" action="javascript:handleSubmit()">
            <p><bean:message key="generateprocess.message.user.role" bundle="ProcessPortal"/></p>
            <label for="participant"><bean:message key="generateprocess.label.user.role" bundle="ProcessPortal"/></label>
            <input id="participant" dojoType="dijit.form.TextBox" name="participant" />           
                    <input type=SUBMIT value ="<bean:message key="generateprocess.button.ok" bundle="ProcessPortal"/>">
                        </input>


                

        </form>
    </div>

    <div style="clear:both;"></div>
</div>

<!-- The content of "errorDialog". Initially, the content is not displayable. -->
<div id="errorDialog" dojoType="dijit.Dialog" title='<bean:message key="generateprocess.div.title.error" bundle="ProcessPortal"/>'>
    <div class="bd">
        <div id="errorDialog.errorMessage" style="color: red; display: block">
    </div>
    <button dojoType="dijit.form.Button" style="float:right;" type="submit" onClick="handleErrorDialogOk()">
        <bean:message key="generateprocess.button.ok" bundle="ProcessPortal"/>
    </button>
    <div style="clear:both;"></div>
</div>

<div id="reassign-menu" style="display:none;"></div>
<nobr class="body-notice"><strong><bean:message key="generateprocess.message.note" bundle="ProcessPortal"/></strong> <bean:message key="generateprocess.message.expose" bundle="ProcessPortal"/></nobr>
<%--<span style="color: #BFCFDE; font-weight: bold;">Skin: </span>
<select id="skins" onkeyup="changeSkin()" onchange="changeSkin()"></select>--%>
<input type="button" id="drillButton" value="" style="visibility: hidden;" >

</body>
</html>
