<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.utils.BPDToSVG, 
                 java.math.BigDecimal, 
                 com.lombardisoftware.bpd.model.impl.BPDBusinessProcessDiagramImpl,
                 com.lombardisoftware.core.config.TWConfiguration" %>
<%@ page import="com.lombardisoftware.core.StringUtils" %>
<%@ page import="java.util.Collections" %>
<%@ page import="com.lombardisoftware.core.TeamWorksException" %>
<%@ page import="com.lombardisoftware.bpd.model.impl.BPDBusinessProcessDiagramFactory" %>
<%@ page import="com.lombardisoftware.portal.struts.Constants" %>
<%@ page import="com.lombardisoftware.server.api.ActionPolicy" %>
<%@ page import="com.lombardisoftware.client.persistence.common.ID" %>
<%@ include file="contextRoot.jsp" %>

<%!private static final String BPD_INSTANCE_ID_PARAM = "bpdInstanceId"; %>

<%
    BigDecimal instanceIds[] = (BigDecimal[]) request.getAttribute(Constants.Request.BPD_INSTANCE_IDS);
    BPDBusinessProcessDiagramImpl bpd = (BPDBusinessProcessDiagramImpl) request.getAttribute(Constants.Request.BPD);
    String bpdId = ID.toExternalString(bpd.getId());
    String title = bpd.getName();
%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <title><bean:message key="showDiagram.Title" bundle="ProcessPortal"/></title>
    <link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css" media="screen, projection" />
    <script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
    <script TYPE="text/javascript" src="<%=request.getContextPath()%>/js/toolbar.js"></script>
    <script TYPE="text/javascript" src="<%=request.getContextPath()%>/jsp/js/core.jsp"></script>
    <script TYPE="text/javascript" src="<%=request.getContextPath()%>/js/main.js"></script>

    <script type="text/javascript" src="<%=request.getContextPath()%>/js/jquery/jquery-1.2.6.js"></script>
    <script>
    window.bpm_context_roots = {
        "webviewer.war": "<%= webviewerContextRoot %>",
        "process-portal.war": "<%= processPortalContextRoot %>",
        "process-portal-support.war": "<%= processPortalSupportContextRoot %>",
        "bpmrest.war": "<%= bpmRestContextRoot %>"
    };
    </script>


    <link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

    <style type="text/css">
        #wait  .dijitDialogPaneContent {
            padding: 2px;
            border: none;
        }
        
        #wait .dijitDialogTitleBar {
            display: none;
        }
        /* make html/body to fit the height of its parent */
        html {
            height: 100%;
            overflow: hidden;
        }
        body {
            height: 100%;
            margin: 0;
            padding: 0;
            overflow:hidden;
        }
    </style>

    <script type="text/javascript">

 // Focus self on open;
    self.focus();

    function tableToDiagram(param) {
        if (!param) return;

        if (param.action === "reload") {
            if (document.getElementById('flashFrame').contentWindow) {
                document.getElementById('flashFrame').contentWindow.location.reload(true);
            } else {
                frames['flashFrame'].document.window.location.reload(true);;
            }
        } else if (param.action === "load") {
            document.location.href = param.url;
        } else {
            if (document.getElementById('flashFrame').contentWindow) {
                document.getElementById('flashFrame').contentWindow.tableToDiagram(param);
            } else {
                frames['flashFrame'].document.tableToDiagram(param);
            }
        }
    }
    
var drillStack = [{bpdId: "<%=bpdId%>", name: "<%= title %>"}];
var instanceId = "<%=instanceIds[0].longValue() %>";
var instanceName =  "<%=title%>";
var instanceBpdId = "<%=bpdId%>";
var cpType = "<%= request.getAttribute(Constants.Request.BPD_CRITICAL_PATH_TYPE) %>";
var parentId = "<%= request.getAttribute(Constants.Request.BPD_CRITICAL_PARENT_ID) %>";

var instanceIds = [
        <% for (int i = 0; i < instanceIds.length; i++) {%>
            <%=instanceIds[i].longValue()%>
            <%=(i < instanceIds.length - 1 ? "," : "")%>
        <%}%>
        ];
var flashDiagramEnabled = <%=TWConfiguration.getInstance().getServer().getPortal().isEnableFlashDiagram() %>;
var diagramTitle;
var wait;
var iFrame;

// Caculate the offiset of iframe
function offsetY(elem) {
    return elem.offsetParent ? (elem.offsetTop + offsetY(elem.offsetParent)) : elem.offsetTop;
}
// Resize flash iframe
function iframeResize(){
	 console.debug ("in inframe resize");
		// debugger;
    // var iFrame = document.getElementById('flashFrame');
    if (iFrame == null)
    	return;
    var heightFrame = window.innerHeight || document.body.clientHeight || document.documentElement.clientHeight;
    heightFrame -= offsetY(iFrame);
    heightFrame = (heightFrame < 0) ? 0 : heightFrame;
    iFrame.style.height = heightFrame + 'px';
}

function onLoad() {
    dojo.require("dijit.Dialog");
    dojo.require("dijit.layout.ContentPane");
    dojo.require("dijit._base.popup");

    diagramTitle = document.getElementById("diagramTitle");
    wait = dijit.byId("wait");
    if (window.ActiveXObject)
    {// Only use js to set the height of iframe on IE
        window.onresize = iframeResize;
        iframeResize();
    }
}

function setTitle(title) {
    diagramTitle.innerHTML = title;
}

function showAudit() {
    var url = "processAudit.jsp?bpdInstanceId=" + instanceId;
    window.open(url, "_blank", "height=600,width=800,scrollbars=no,resizable=yes").focus();
}
/**
 * Invoked by "generateProcessInstanceFlash" child window after process instance's state
 * was changed (re-assign to user/role, re-assign back to role, re-routing etc.).
 * 
 * See generateProcessInstanceFlash.jsp
 */
function processInstanceStateChangedFromProcessInstanceDiagram() {
	// Propagate the event to "processDetails" window.
	// It is assumed that "processDetails" window is opener of "processInstanceDiagram" window.
	if (window.opener && window.opener.processInstanceStateChangedFromProcessInstanceDiagram) {
		window.opener.processInstanceStateChangedFromProcessInstanceDiagram();
	}
}
 
</script>
</head>
<body class="soria" onLoad="onLoad()">
<div dojoType="dijit.Dialog" title='<bean:message key="processInstanceDiagram.div.dialog.title" bundle="ProcessPortal"/>' id="wait">
    <div dojoType="dijit.layout.ContentPane" id="wait-content">
        <img src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/tundra/images/loading.gif" alt="<bean:message key="processInstanceDiagram.message.processing" bundle="ProcessPortal"/>" />
        <span style="margin-left:5px;"><bean:message key="processInstanceDiagram.message.processing" bundle="ProcessPortal"/></span>
    </div>
</div>
<table cellspacing="0" cellpadding="0" border="0" style="width:99%;height:99%" id="layout">
    <tr valign="top">
        <td align="left" id="content" nowrap>
            <div class="heading" style='display:none'>
                <div class="heading-right"></div>
                <h1 id="diagramTitle"><%= title %></h1>
            </div>
            <div id="toolbar" style='display:none; z-index: 4;'>
                <table border="0" cellspacing="0" cellpadding="0">
                    <tr valign="top">
     	                	<td class="button">
                            <span id="actionButtonFlash">
                                <a title="<bean:message key="showDiagram.link.ViewFlash.tip" bundle="ProcessPortal"/>"
                                        href="javascript:showDiagram('flash');">
                                    <bean:message key="showDiagram.link.ViewFlash" bundle="ProcessPortal"/></a>
                            </span>
                        </td>
                        <td class="divider"><span id="actionButtonFlashDivider">|</span></td>
     
                        <td class="button">
                          <span id="actionButtonPNG">
                              <a title="<bean:message key="showDiagram.link.ViewPNG.tip" bundle="ProcessPortal"/>"
                                        href="javascript:showDiagram('png');">
                                 <bean:message key="showDiagram.link.ViewPNG" bundle="ProcessPortal"/></a>
                          </span>
                        </td>
                        <td class="divider"><span id="actionButtonPNGDivider">|</span></td>
                        
												<td class="button">
			    							<span id="actionButtonILOG">
                                <a title="View the diagram as an iLog Diagram"
                                        href="javascript:showDiagram('ilog');">View as iLog</a>
                            </span>
                        </td>
                        <td class="divider"><span id="actionButtonILogDivider">|</span></td>

                        <td class="button">
                            <span id="actionButton<%= ActionPolicy.ACTION_VIEW_PROCESS_AUDIT %>">
                                <a title="Show Process Audit page" href="javascript:showAudit();"><bean:message key="processInstanceDiagram.Audit" bundle="ProcessPortal"/></a>
                            </span>
                        </td>
                    </tr>
                </table>
            </div>
        </td>
    </tr>
    <tr valign="top" style="width:100%;height:100%">
        <td>
            <!-- note the iframe(s) are put inside here by javascript -->
            <span id="framecontainer" style="height:100%"></span>
        </td>
    </tr>
    <tr valign="top">
        <td>
            <div id="content-bottom">
                <div class="left"></div>
                <div class="right"></div>
            </div>
        </td>
    </tr>
    <tr valign="top"><td>
    </td></tr>
</table>

<script type="text/javascript">

var useVBMethod = false;    // use VBScript or JavaScript?
var allowed = ["flash", "svg", "png", "ilog"];
var flashFrame = null;
var iLogFrame = null;


var DIAGRAM_TYPES = new Array();
DIAGRAM_TYPES["flash"] = {
    name: "Flash", 
    hasSupport: false, 
    path: "generateProcessInstanceFlash.jsp", 
    mimeType: "application/x-shockwave-flash", 
    activeScriptObject: "ShockwaveFlash.ShockwaveFlash.8"
}; 
DIAGRAM_TYPES["svg"] = {
    name: "SVG", 
    hasSupport: false, 
    path: "generateProcessInstanceSVG.jsp", 
    mimeType: "image/svg+xml", 
    activeScriptObject: "Adobe.SVGCtl"
};
DIAGRAM_TYPES["png"] = {
    name: "PNG", 
    hasSupport: false, 
    path: "generateProcessInstancePNG.jsp", 
    mimeType: "image/png", 
    activeScriptObject: ""
};

DIAGRAM_TYPES["ilog"] = {
	    name: "ILOG", 
	    hasSupport: false, 
	    path: "generateProcessInstanceIlog.jsp", 
	    // mimeType: "application/javascript", 
	    mimeType: "application/x-shockwave-flash", 
	    activeScriptObject: ""
};

var diagrams = [];
    
function generateUrl(typeName) {
    var type = DIAGRAM_TYPES[typeName];
    var bpdId = drillStack[drillStack.length - 1].bpdId;
    var newUrl = "";
    var instanceIdsString = "?";

    for (var i = 0; i < instanceIds.length; i++) {
        instanceIdsString += "bpdInstanceId=" + instanceIds[i];
        if (i < instanceIds.length - 1)
            instanceIdsString += "&";    
    }
    newUrl = type.path + instanceIdsString;

    if (bpdId != "null" && bpdId.length > 0) {
        newUrl += "&bpdId=" + bpdId;
    }

    if (cpType && cpType != "null") {
        newUrl += "&cpType=" + cpType;
    }

    if (parentId && parentId != "null") {
        newUrl += "&parentId=" + parentId;
    }
    
    return newUrl;
}

function generateDiagram(type) {
    var result;

    result = document.createElement("iframe");
    result.setAttribute("id", type + "Frame");
    result.setAttribute("name", type + "Frame");
    result.setAttribute("src", generateUrl(type));
    result.setAttribute("width","100%");
    result.setAttribute("height","100%");
    result.setAttribute("frameborder","0");
    return result;
}

/*
    Internet Explorer returns 0 as the number of MIME types,
    so this code will not be executed by it. This is our indication
    to use VBScript to detect SVG support.
*/
var hasFlashSupport;
var hasSVGSupport;
if (navigator.mimeTypes != null && navigator.mimeTypes.length > 0) {
    for(var i in allowed) {
        var type = DIAGRAM_TYPES[allowed[i]];
        if (navigator.mimeTypes[type.mimeType] != null) {
            type.hasSupport = true;
        }
    }
} else {
    useVBMethod = true;
}
</script>
<!--
    Visual Basic Script to detect support of Adobe SVG plugin.
    This code is not run on browsers which report they have MIME types,
    and it is also not run by browsers which do not have VBScript support.
-->
<script type="text/vbscript">
On Error Resume Next

If useVBMethod = true Then
	hasSVGSupport = IsObject(CreateObject("Adobe.SVGCtl"))
    hasFlashSupport = IsObject(CreateObject("ShockwaveFlash.ShockwaveFlash.8"))
End If
</script>

<script language="javascript">

if (useVBMethod) {
    DIAGRAM_TYPES["flash"].hasSupport = hasFlashSupport;
    DIAGRAM_TYPES["svg"].hasSupport = hasSVGSupport;
    DIAGRAM_TYPES["png"].hasSupport = true;
    DIAGRAM_TYPES["ilog"].hasSupport = true;
}

// we lazily create IFRAME elements for the svg or png when needed so that:
// a) we don't hit the server for both up front
// b) we can flip back and forth between them once they're both loaded.

var bodyElement = document.getElementById("framecontainer");
var toolbarElement = document.getElementById("toolbar");

// temp solution
var diagram = null;
function showDiagram(type) {

    if (flashFrame != null && flashFrame.style.display != 'none') {
        flashFrame.style.display = 'none';
    } else if (diagram != null) {
        diagram.style.display = 'none';
        bodyElement.removeChild(diagram);
        diagram = null;
    }

    if ((type == "flash")) {
        if (flashFrame == null) {
            flashFrame = generateDiagram(type);
            bodyElement.appendChild(flashFrame);
        }
        flashFrame.style.display = '';
        iFrame = flashFrame;
    }  else if (type == "ilog") {
					if (iLogFrame == null) {
    	    	diagram = generateDiagram(type);
            iLogFrame = diagram;
          }
          else
          		diagram = iLogFrame;
          bodyElement.appendChild(diagram);
          diagram.style.display = '';
         iFrame = iLogFrame;
    }
    
    else {
        diagram = generateDiagram(type);
        bodyElement.appendChild(diagram);
        diagram.style.display = '';
        iFrame = diagram;
    }

    markCurrentDiagramButton(type);
}

function markCurrentDiagramButton(currentType) {
    for (var i in DIAGRAM_TYPES) {
        var type = DIAGRAM_TYPES[i];
        var buttonLink = document.getElementById("actionButton" + type.name);
        if (type.hasSupport) {
            if(currentType == i)
                buttonLink.style.fontWeight = "bold";
            else
                buttonLink.style.fontWeight = "normal";

        }
    }
}

var showToolbar = true;
var diagramToShow = null;

//override all svg and flash detection results:

//BLOCK USAGE OF THE SVG
DIAGRAM_TYPES["svg"].hasSupport = false;
// Fix for THU-4431 and TW-6757
DIAGRAM_TYPES["png"].hasSupport = true;
//force this flag to show always 'View as Flash' button if flash is allowed in the config 
DIAGRAM_TYPES["flash"].hasSupport = flashDiagramEnabled;
DIAGRAM_TYPES["ilog"].hasSupport = true;

for (var i in DIAGRAM_TYPES) {
    var type = DIAGRAM_TYPES[i];
    if (!type.hasSupport) {
        var diagramLink = document.getElementById("actionButton" + type.name);
        if (diagramLink != null) {
            diagramLink.style.display='none';
        }  
        var divider = document.getElementById("actionButton" + type.name + "Divider");
        if (divider != null) {
            divider.style.display='none';
        }
    } else {
        showToolbar = true;
        if (diagramToShow == null) {
            diagramToShow = i;
        }
    }
}
// not to show toobar since we only have ilog diagram
showToolbar = false;
if (showToolbar) {
    // show the menu for switching display if both SVG and PNG are enabled.
    toolbarElement.style.display='';
}

// always use iLog diagram in Apollo
diagramToShow = "ilog";

if (diagramToShow != null) {
    showDiagram(diagramToShow);
}

// register all selected instance ids for authorization request
for (var i = 0; i < instanceIds.length; i++) {
    updateInstanceChecked(instanceIds[i], true);
}

// do authorization request
onSelectionChange();


</script>
</body>
</html>
