<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants.Request" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<bean:define id="fileTypes" name="<%= Request.FILE_TYPES %>" scope="request" type="java.util.Map"/>

<html:javascript formName="AddDocumentVersionExecute"/>

<div style="text-align: left" stid="body">
    <div class="body">
	<logic:messagesPresent>
		<html:messages id="msg" header="errors.header" footer="errors.footer" bundle="ProcessPortal">
			<li><bean:write name="msg" bundle="ProcessPortal"/></li>
		</html:messages>
	</logic:messagesPresent>
	<html:form action="/jsp/addDocumentVersionExecute.do" method="POST" enctype="multipart/form-data" focus="fileType" onsubmit="return validateAddDocumentVersionExecute(this)">
            <table class="content-table-no-lines">
                <tr>
                    <td><label for="fileTypeId"><bean:message key="addDocument.fields.fileType" bundle="ProcessPortal"/></label></td>
                    <td align="left">
	                    <html:select styleId="fileTypeId" property="fileType" style="height:20;" onchange="changeOption(this);" >
	                    	<html:options collection="<%= Request.FILE_TYPES %>" property="key" labelProperty="value"/>
	                    </html:select>
                    </td>
                </tr>
                <tr style="display: none;" id="file">
                    <td><label for="fileContentId"><bean:message key="addDocument.fields.fileContent" bundle="ProcessPortal"/></label></td>
                    <td align="left"><html:file styleId="fileContentId" property="fileContent" style="height:20;" size="60"/></td>
                </tr>
                <tr style="display: none;" id="URL">
                    <td><label for="urlTextId"><bean:message key="addDocument.fields.urlText" bundle="ProcessPortal"/></label></td>
                    <td align="left"><html:text styleId="urlTextId" property="urlText" style="height:20;" size="90"/></td>
                </tr>
            </table>
        <html:hidden property="bpdInstanceId"/>
        <html:hidden property="userID" name="user"/>
        <html:hidden property="parentId"/>
        <html:submit style="height:20;">
            <bean:message key="common.buttonSubmit" bundle="ProcessPortal"/>
        </html:submit>
        <input type="button" value="<bean:message key="common.buttonCancel" bundle="ProcessPortal"/>" style="height:20;" onclick="cancel();">
	</html:form>
    </div>
    <script type="text/javascript">
        regulateLayers();
    </script>
</div>