<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="org.apache.struts.action.DynaActionForm"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants"%>
<%@ page import="java.util.Locale" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%@ include file="../contextRoot.jsp" %>

<%
    DynaActionForm form = (DynaActionForm) request.getAttribute(Constants.FormBeans.ChangeDueDateSetup.FORM_NAME);
    String idSend = null;
    String type = null;
    if (form == null) {
        idSend = (String) session.getAttribute("changeDueDate.idSend");
        type = (String) session.getAttribute("changeDueDate.type");
    } else {
        String[] idStrings = form.getStrings(Constants.FormBeans.ChangeDueDateSetup.ID);
        StringBuffer sb = new StringBuffer(64);
        for (int i = 0; i < idStrings.length; i++) {
            if (i > 0) {
                sb.append("&id=");
            }
            sb.append(idStrings[i]);
        }
        idSend = sb.toString();
        type = form.getString(Constants.FormBeans.ChangeDueDateSetup.TYPE);
        session.setAttribute("changeDueDate.idSend", idSend);
        session.setAttribute("changeDueDate.type", type);
    }

    // Norwegian in "no" in Java but "nb" in Dojo.
    String language = ((Locale) session.getAttribute(Globals.LOCALE_KEY)).toString();
    if (language.equals("no")) {
        language = "nb";
    }else{
        language = language.toLowerCase().replace('_', '-');
    }
%>

<link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css">

<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js"
        djConfig="parseOnLoad:true, locale:'<%= language %>'"></script>

<script type="text/javascript">
    // TODO: dojify
    function validateDueDate() {
        var dueDate=dojo.byId('due').value;
        if (dueDate.length != 0) {
            // var ignoringCollision = (dojo.byId('forceCheckbox').checked ? "true" : "false");
            var ignoringCollision = "false";
			var isGregorianDate = getDateTime() instanceof Date;
            var url = '<%=request.getContextPath()%>/jsp/<%= (String) session.getAttribute("changeDueDate.type") %>/changeDueDateExecute.do';
            window.location.href = url + '?id=<%=(String) session.getAttribute("changeDueDate.idSend")%>&force=' + ignoringCollision + '&due=' + (isGregorianDate ? getDateTime().getTime():getDateTime());
        } else {
            alert("<bean:message key="changeDueDate.DateNotSelectedError" bundle="ProcessPortal" encodeTo="js" />");
        }
    }
</script>
