<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.core.TeamWorksException, com.lombardisoftware.data.api.BusinessData" %>
<%@ page import="java.util.*"%>
<%@ page import="com.lombardisoftware.portal.utils.MessagesHelper"%>
<%@ page import="com.lombardisoftware.portal.viewhelper.SearchColumnInfo"%>
<%@ page import="com.lombardisoftware.server.ejb.api.ProcessSearchAPIInterface"%>
<%@ page import="com.lombardisoftware.client.delegate.ProcessSearchAPIDelegate"%>
<%@ page import="com.lombardisoftware.servlet.util.ServletStrings"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants"%>
<%@ page import="com.lombardisoftware.psapi.data.Query" %>
<%@ page import="com.lombardisoftware.server.psapi.dao.BPDInstanceStatusDAO" %>
<%@ page import="com.lombardisoftware.server.psapi.dao.BPDInstanceStatusDAOImpl" %>
<%@ page import="com.lombardisoftware.server.psapi.dao.PriorityDAOImpl" %>
<%@ page import="com.lombardisoftware.server.psapi.dao.TaskStatusDAOImpl" %>
<%@ page import="com.lombardisoftware.server.psapi.dao.TaskStatusDAO" %>
<%@ page import="com.lombardisoftware.server.psapi.dao.PriorityDAO" %>
<%@ page import="com.lombardisoftware.psapi.data.Priority" %>
<%@ page import="com.lombardisoftware.psapi.data.BusinessDataAlias" %>
<%@ page import="com.lombardisoftware.psapi.data.BusinessDataType" %>

<%@ include file="../contextRoot.jsp" %>

<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<jsp:useBean id="user" class="com.lombardisoftware.psapi.data.User" scope="session" />
<jsp:useBean id="savedSearch" class="com.lombardisoftware.psapi.data.SavedSearch" scope="session" />

<%
// Norwegian in "no" in Java but "nb" in Dojo.
String language = ((Locale) session.getAttribute(org.apache.struts.Globals.LOCALE_KEY)).toString();
if (language.equals("no")) {
    language = "nb";
}else{
    language = language.toLowerCase().replace('_', '-');
}
%>

<link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css">

<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js"
    djConfig="parseOnLoad:true, locale:'<%= language %>'"></script>

<script type="text/javascript">
    dojo.require("dijit.form.DateTextBox");
    dojo.require("dojo.date.locale");
</script>
<jsp:include page="bidi/BidiDateUtility.jsp" flush="true" />
<script TYPE="text/javascript" src="<%=request.getContextPath()%>/js/DateTimePicker.js"></script>
<script TYPE="text/javascript" src="<%=request.getContextPath()%>/js/search.js"></script>

<%
 BPDInstanceStatusDAO bpdInstanceStatus = new BPDInstanceStatusDAOImpl();
 List bpdStatusList = bpdInstanceStatus.findBPDInstanceStatus();
 TaskStatusDAO taskStatus = new TaskStatusDAOImpl();
 List taskStatusList = taskStatus.findTaskStatus();
 PriorityDAO priorityDAO = new PriorityDAOImpl();
 Collection priorities = priorityDAO.findPriorities();
 List userRoles = (List) session.getAttribute(ServletStrings.USER_ROLE_MEMBERSHIP);
 String[][] orders = {{"ASC", MessagesHelper.getMessage(application, request, "newsearch.SortOrder.ascending", "ProcessPortal")},{"DESC", MessagesHelper.getMessage(application, request, "newsearch.SortOrder.descending", "ProcessPortal")}};
 String bdColLabelPrefix = MessagesHelper.getMessage(application, request, "newsearch.BusinessData", "ProcessPortal");
 String instanceColLabelPrefix = MessagesHelper.getMessage(application, request, "newsearch.Instance", "ProcessPortal");
 String taskColLabelPrefix = MessagesHelper.getMessage(application, request, "newsearch.Task", "ProcessPortal");
%>
<%!private static String jScriptEncode(String str) {
	if (str == null)
	  return str;
	StringBuffer out = new StringBuffer();
	char ch;
	for (int i=0, len = str.length(); i<len; i++) {
	 ch = str.charAt(i);
	 switch (ch) {
	 case '\u001B':  out.append("\\x1B"); break;
	 case '\t':  out.append("\\t"); break;
	 case '\n':  out.append("\\n"); break;
	 case '\r':  out.append("\\r");  break;
	 case '\"':  out.append("\\\""); break;
	 case '\'':  out.append("\\\'"); break;
	 default:  out.append(ch);}
	}
	return out.toString();
}

/**
 * Create and return lookup table of view-oriented search columns.
 * 
 * @param query the <code>Query</code> object from which to retrieve search data.
 * @param lookup table of view-oriented search columns.
 */
private Map<String, SearchColumnInfo> getSearchResultColumns(Query query, javax.servlet.ServletContext application, javax.servlet.http.HttpServletRequest request) {
    Map<String, SearchColumnInfo> columnMap = new TreeMap<String, SearchColumnInfo>();

	for (Iterator i = query.getAllColumns().iterator(); i.hasNext(); ) {
		Query.Column resultColumn = (Query.Column)i.next();

		String columnName = resultColumn.getName();
		String columnLabel;
		String colNamePrefix;
		String colLabelPrefix;
		
		if (resultColumn instanceof Query.BusinessDataColumn) {
			columnLabel = ((Query.BusinessDataColumn)resultColumn).getAlias();
			colNamePrefix = Constants.FormBeans.ExecuteAdvancedSearch.BD_COL_PRFIX;
			colLabelPrefix = MessagesHelper.getMessage(application, request, "newsearch.BusinessData", "ProcessPortal");
		}
		else {
			columnLabel = MessagesHelper.getColumnDisplayName(application, request, columnName, "ProcessPortal");
			if (Query.isInstanceColumn(columnName)) {
				colNamePrefix = Constants.FormBeans.ExecuteAdvancedSearch.INSTANCE_COL_PRFIX;
				colLabelPrefix = MessagesHelper.getMessage(application, request, "newsearch.Instance", "ProcessPortal");
			} else {
				colNamePrefix = Constants.FormBeans.ExecuteAdvancedSearch.TASK_COL_PRFIX;
				colLabelPrefix = MessagesHelper.getMessage(application, request, "newsearch.Task", "ProcessPortal");
			}
		}
		columnMap.put(columnName, new SearchColumnInfo(columnName, columnLabel, colNamePrefix, colLabelPrefix));
	}
	
	return columnMap;
}%>
<script language="JavaScript">
var labelInstancePrefix = "<%= jScriptEncode(instanceColLabelPrefix) %>";
var labelTaskPrefix = "<%= jScriptEncode(taskColLabelPrefix) %>";
var labelBDPrefix = "<%= jScriptEncode(bdColLabelPrefix) %>";

<%
  java.util.Collection aliasedBDVars = (java.util.Collection) request.getAttribute(Constants.Request.BUSINESS_DATA_ALIASES);
  if (aliasedBDVars == null) {
    // TODO: log warning
    aliasedBDVars = Collections.EMPTY_LIST;
  }

  Set<String> bdCustomTypeNames = new HashSet<String>();
  for (Iterator it = aliasedBDVars.iterator(); it.hasNext(); ) {
    BusinessDataAlias alias = (BusinessDataAlias) it.next();
    BusinessDataType dataType = alias.getType();
    if (dataType.isCustomType() && !bdCustomTypeNames.contains(dataType.getJavaScriptName())) {
    %>
TWType.registerTWType(new TWType(TWType.findByName('<%= jScriptEncode(dataType.getBaseType().getJavaScriptName()) %>'), '<%= jScriptEncode(dataType.getJavaScriptName()) %>'));
    <%
      bdCustomTypeNames.add(dataType.getJavaScriptName());
    }
  }
%>

var bdSearchAliases = new Array(
<%
  for (Iterator it = aliasedBDVars.iterator(); it.hasNext(); ) {
    BusinessDataAlias alias = (BusinessDataAlias) it.next();
    BusinessDataType dataType = alias.getType();
    %>
    new BDSearchVariable('<%= jScriptEncode(alias.getName()) %>', TWType.findByName('<%= jScriptEncode(dataType.getJavaScriptName()) %>')) <%= it.hasNext() ? "," : "" %>
    <%
  }
%>
);
var instanceStatusCodeList=new Array(<%=bpdStatusList.size()%>);
var instanceStatusValueCodeList=new Array(<%=bpdStatusList.size()%>);
var taskStatusCodeList=new Array(<%=taskStatusList.size()%>);
var taskStatusCodeValueList=new Array(<%=taskStatusList.size()%>);
var taskPriorityList=new Array(<%=priorities.size()%>);
var datetimeFormat = "<bean:message key="calendar.DefDateFormat" bundle="ProcessPortal" encodeTo="js" /> <bean:message key="calendar.DefDateTimeFormat" bundle="ProcessPortal" encodeTo="js" />";

//This method reads the tasks and bpdinstace status codes
function readStatus() {<%
 for(int i=0;i<bpdStatusList.size();i++)
 {%>
 instanceStatusValueCodeList[<%=i%>]="<%=bpdStatusList.get(i)%>";
 instanceStatusCodeList[<%=i%>]="<bean:message key="<%=MessagesHelper.INSTANCE_STATUS_DISPLAY_NAME_PREFIX + bpdStatusList.get(i)%>" bundle="ProcessPortal"/>"; <%}%><%
 for(int i=0;i<taskStatusList.size();i++)
 {%>
 taskStatusCodeValueList[<%=i%>]="<%=taskStatusList.get(i)%>";
 taskStatusCodeList[<%=i%>]="<bean:message key="<%=MessagesHelper.TASK_STATUS_DISPLAY_NAME_PREFIX + taskStatusList.get(i)%>" bundle="ProcessPortal"/>"; <%}%><%
 int ii = 0;
 for (Iterator it = priorities.iterator(); it.hasNext(); ) {
  Priority p = (Priority) it.next();
 %>
 taskPriorityList[<%=ii%>]="<%= p.getPriorityName() %>"; <%  ii++;
 }
%>
}
readStatus();
</script>
<jsp:useBean id="queryObject" class="com.lombardisoftware.psapi.data.Query" scope="session"/>
<%
// always have one condition otherwise the add button doesn't show up!
int conditionCount = Math.max(1, queryObject.getConstraintsSize());
int MAX_CONSTRAINTS = 10;

Map<String, SearchColumnInfo> selectedMap = getSearchResultColumns(queryObject, application, request);
%>
<div id=search class="soria"><div id=header>
<table border=0 width="100%" cellspacing="0" cellpadding="0"><tr valign="bottom">
 <td style="padding-bottom:3px"><bean:message key="advancedSearchResults.newSearchArea.heading" bundle="ProcessPortal"/></td>
 <td align="right">
  <table border="0" width="0" cellspacing="0" cellpadding="0"><tr>
   <td><%
   if(queryObject.isOrganizedByInstance()){
   %><input id="searchOrganizationButton" type=button onClick="return changeSearchOrganization()" value="<bean:message key="newsearch.button.ShowTasks" bundle="ProcessPortal"/>" style="height:20px"/><%
   } else {
   %><input id="searchOrganizationButton" type=button onClick="return changeSearchOrganization()" value="<bean:message key="newsearch.button.ShowInstances" bundle="ProcessPortal"/>" style="height:20px"/><%
   }
   %></td>
   <td><input id="searchBuilderButton" type=button onClick="return toggleSearch('search-body', this)" value="<bean:message key="newsearch.button.ShowSearch" bundle="ProcessPortal"/>" style="height:20px" /></td>
   </tr></table>
 </td>
</tr></table>
</div>
<div id=search-body>
<form id="searchFormId" method="POST" action="advancedSearch.do" onSubmit="convertResultColumns('itemDisplayColumns');enableSelects(this);selectBusinessData();return validateExposedBPD(this);">
<%--<input type="button" style="height:20px;" name="Hide Search" value="Hide Search" onClick="toggle('newsearch', 'hide');" />--%>
<table  class="search-table" cellSpacing=0 cellPadding=0 border=0>
<tr>
 <td><img src="images/spacer.gif" height="1" width="10" alt="" ></td>
 <td>
 <table cellSpacing=0 cellPadding=0 border="0">
 <tr><td>
  
  <!-- ==================================================================================== -->
  <!-- =========================== Conditions BEGIN ======================================= -->
  <!-- ==================================================================================== -->
 
  <table id="searchcontraints" cellSpacing=0 cellPadding=0 border=0>
  <tr valign="top"><td><bean:message key="newsearch.SearchConditions" bundle="ProcessPortal"/><input name="conditionCount" id="conditionCount" type="hidden" value="<%= conditionCount %>"/>&nbsp;</td>
  <td>
  <%
    String processName = null;
    for (int i = 0; i < MAX_CONSTRAINTS; i++) {
      String conditionColumnName = null;
      String operatorName = null;
      Object conditionValue = null;
      boolean isBusinessDataCondition = false;
      String qualifiedBusinessDataColumn = null;
      boolean conditionIsSet = (i < conditionCount);
      if (conditionIsSet) {
        Query.Constraint condition = queryObject.getConstraint(i);
        if (condition instanceof Query.BusinessDataConstraint) {
          isBusinessDataCondition = true;
          qualifiedBusinessDataColumn = ((Query.BusinessDataConstraint)condition).getVariableNameWithType();
        }
        conditionColumnName = (condition == null) ? null : condition.getColumnName();
        operatorName = (condition == null) ? null : condition.getOperator().getName();
        conditionValue = (condition == null) ? null : condition.getValue();
        if (ProcessSearchAPIDelegate.PROP_BPD_NAME.equals(conditionColumnName)) {
          processName = String.valueOf(conditionValue);
        }
      }
  %>
  <div id="condition<%=i%>" class="condition" style="display:<%= (i < conditionCount) ? "block" : "none"%>;">
  
  <!--  table with conditions - BEGIN -->
  <table cellSpacing=0 cellPadding=0 border="0">
  <%
  if (0 != i) {
  %>
  <tr><td><img src="images/spacer.gif" height="1" width="20" alt="" ><bean:message key="newsearch.And" bundle="ProcessPortal"/></td>
  </tr><%
  }
  %>
  <tr><td>
   <label for="condition<%=i%>column"></label><select class="condition" id="condition<%=i%>column" name="condition<%=i%>column"
    onChange="updateOperator(this); hideSaveSearch();" size="1" style="height:20px">
    <option value="">&laquo;<bean:message key="newsearch.ChooseOne" bundle="ProcessPortal"/>&raquo;</option>
    <%
    for (int j = 0; j < Query.CONDITION_COLUMNS.length; j++) { String column = Query.CONDITION_COLUMNS[j];
    %>
    <option value="<%=column%>"
       <%= column.equals(conditionColumnName) ? "selected=\"true\"" : "" %>><bean:message key="<%= MessagesHelper.COLUMN_DISPLAY_NAME_PREFIX + column %>"
       bundle="ProcessPortal" /></option>
    <%
    }
    %>
    <!-- TODO: V Melnykov, we should take it from i18 -->
    <option value="<%= Constants.FormBeans.ExecuteAdvancedSearch.BUSINESS_DATA_COLUMN %>" ><bean:message key="newSearch.option.businessData" bundle="ProcessPortal"/></option>
    </select></td>
  <td><div style="width:5px;border:0px;"><img src="images/spacer.gif" alt="" height="5" width="1"/></div></td>
  <td><p id="condition<%=i%>opp">
    <label for="condition<%=i%>operator"></label><select id="condition<%=i%>operator" name="condition<%=i%>operator" size="1" style="height:20px" onchange="hideSaveSearch();">
    <%
    for (int j = 0; j < Query.CONDITION_OPERATORS.length; j++) {
    %>
      <option value="<%=Query.CONDITION_OPERATORS[j]%>"<%=(Query.CONDITION_OPERATORS[j] != null && Query.CONDITION_OPERATORS[j].equals(operatorName)) ? "selected=\"true\"" : "" %>><bean:message key="<%=MessagesHelper.CONDITION_DISPLAY_NAME_PREFIX + Query.CONDITION_OPERATORS[j]%>" bundle="ProcessPortal"/></option>
    <%
    }
    %>
   </select>
   </p>
  </td>
  <td><div style="width:5px;border:0px;"><img src="images/spacer.gif" alt="" height="5" width="1"/></div></td>
  <td><p id="condition<%=i%>p">
    <%--
    <input id="condition<%=i%>value" type="text" name="condition<%=i%>value" style="width: 142px; height:15px;border: 1px solid #3161bd;" maxlength="32" onBlur="onConditionChange(this)" onchange="hideSaveSearch();" value="<%= (null != conditionValue) ? conditionValue : "" %>">
    --%>
    <label for="condition<%=i%>value"></label><input id="condition<%=i%>value" type="text" name="condition<%=i%>value"
       style="width: 142px; height:15px;border: 1px solid #3161bd;" maxlength="32"  value="" />
    </p></td>
  <td><div style="width:5px;border:0px;"><img src="images/spacer.gif"  alt="" height="5" width="1"/></div></td>
  <td>
  <p id="condition<%=i%>bdValue"></p>
  </td></td>
  </tr>
  </table>
  <!--  table with conditions - END -->
  </div>
  
  <div id="addRemove<%=i%>" class="condition" style="display:<%=((conditionCount - 1) == i) ? "block" : "none"%>;">
  <input type="button" value="<bean:message key="newsearch.button.AddNewCondition" bundle="ProcessPortal"/>" style="visibility:<%=(MAX_CONSTRAINTS == (i + 1)) ? "hidden" : "visible"%>;" onClick="addButtonPressed(<%=i%>);" style="height:20px;" />
  <input type="button" value="<bean:message key="newsearch.button.RemoveCondition" bundle="ProcessPortal"/>" style="visibility:<%=(i == 0) ? "hidden" : "visible"%>;" onClick="removeButtonPressed(<%=i%>);" style="height:20px;" />
  </div>
  
  <%
    if (conditionIsSet) {
    %>
  <script> addConstraintByIndex(<%= i %>, '<%= jScriptEncode( isBusinessDataCondition
		  ? ProcessSearchAPIDelegate.PROP_BUSINESS_DATA_PREFIX + qualifiedBusinessDataColumn : conditionColumnName) %>',
      '<%= jScriptEncode(operatorName) %>', '<%= jScriptEncode(String.valueOf(conditionValue))%>' ); </script>
  
  <%
    }
    %>
  <%
     } // for loop
     if (processName != null) { out.println("<script>prevBPDName = '" + jScriptEncode(processName) + "';</script>"); }
  %>
  </td>
 </tr>
 </table>

  <!-- ==================================================================================== -->
  <!-- =========================== Conditions END ========================================= -->
  <!-- ==================================================================================== -->

 </td>
 </tr>
 <tr><td><div id="less"><input type="button" style="height:20px;" onClick="return toggle('less','more');" value="<bean:message key="newsearch.button.More" bundle="ProcessPortal"/>"/></div></td></tr>
 <tr>
  <td><div id="more" style="display:none;">

  <!-- ==================================================================================== -->
  <!-- ============================ Colums BEGIN ========================================== -->
  <!-- ==================================================================================== -->

  <table cellSpacing=0 cellPadding=0>
   <tr valign=top>
   <td>
   <table width="100%">
    <tr><td colspan="5"><bean:message key="newsearch.ChooseColumnsToDisplay" bundle="ProcessPortal"/></td></tr>
    <tr><td colspan="2"><label for="itemPossibleColumns"><bean:message key="newsearch.candidateColumns" bundle="ProcessPortal"/></label></td>
	<td colspan="2"><label for="itemDisplayColumns"><bean:message key="newsearch.displayColumns" bundle="ProcessPortal"/></label></td>	
        <td colspan="1"><bean:message key="newsearch.ChooseColumnsToSortOn" bundle="ProcessPortal"/></td></tr>
    <tr><td>
    
    <!-- possible columns BEGIN -->
    <select id="itemPossibleColumns"
      size="<%= Query.INSTANCE_COLUMNS.length + Query.TASK_COLUMNS.length - 4%>"
      multiple="multiple" class="multi-search" onchange="hideSaveSearch();" >
      
    <!-- instance columns -->
    <%
            for (int i = 0; i < Query.INSTANCE_COLUMNS.length; i++) {   //if (!queryObject.hasInstanceResult(Query.INSTANCE_COLUMNS[i]))
            String instanceColumn = Query.INSTANCE_COLUMNS[i];
        	if (!queryObject.hasItemResult(instanceColumn)) {
    %>
        <option value="<%= Constants.FormBeans.ExecuteAdvancedSearch.INSTANCE_COL_PRFIX + instanceColumn %>">
          <bean:message key="newsearch.Instance" bundle="ProcessPortal" /><bean:message
           key="<%= MessagesHelper.COLUMN_DISPLAY_NAME_PREFIX + instanceColumn %>" bundle="ProcessPortal"/>
        </option>
      <%
            } 
            }
      %>
      
      
    <!-- task columns -->
    <%
        	for (int i = 0; i < Query.TASK_COLUMNS.length; i++) {
        	String taskColumn = Query.TASK_COLUMNS[i];
            if (!queryObject.hasTaskResult(taskColumn)) {
    %>
        <option value="<%= Constants.FormBeans.ExecuteAdvancedSearch.TASK_COL_PRFIX + taskColumn%>">
          <bean:message key="newsearch.Task" bundle="ProcessPortal" /><bean:message
            key="<%= MessagesHelper.COLUMN_DISPLAY_NAME_PREFIX + taskColumn %>" bundle="ProcessPortal"/>
        </option>
      <%
            } 
            }
      %>

    <!-- business data alias columns -->
    <%
            for (Iterator it = aliasedBDVars.iterator(); it.hasNext(); ) {
            BusinessDataAlias alias = (BusinessDataAlias) it.next();
            String selectQualifiedName = Constants.FormBeans.ExecuteAdvancedSearch.BD_COL_PRFIX + alias.getTypeQualifiedVariableName();
            if (queryObject.hasBusinessDataResult(alias.getTypeQualifiedVariableName())) {
            	continue;
            }
    %>
        <option value="<%= selectQualifiedName %>">
          <bean:message key="newsearch.BusinessData" bundle="ProcessPortal"/><%=alias.getName()%>
        </option>
      <%
      }
      %>
     

     <%--
      // now we use searchable aliases instead of business data variables for specified BPD
      if (processName != null) {
        try {
         BusinessData bd = BusinessDataUtils.getBusinessDataByProcessName(processName);
         if (bd != null) {  //Collection variables = bd.getVariables();
          for (Iterator iterator = bd.getVariables().iterator(); iterator.hasNext();) {
           BusinessData.Variable variable = (BusinessData.Variable) iterator.next();
           final String name = variable.getName();
           final String nameWithType = variable.getNameWithType();
           if (!variable.getVisibleInSearch()) {
             continue;
           }
           if (!queryObject.hasBusinessDataResult(name)
               && !queryObject.hasBusinessDataResult(nameWithType)) { %>
    <option value="<%= Constants.FormBeans.ExecuteAdvancedSearch.BD_COL_PRFIX + nameWithType %>"><bean:message key="newsearch.BusinessData" bundle="ProcessPortal"/><%=name%></option>
<%            }
           }
         }
         } catch (TeamWorksException e) {     // ignore
         }
       } --%>
       
       
     </select>
     <!-- possible columns END -->

     <input type="hidden" id="itemResultColumns" name="itemResultColumns"/>
     </td>
     <td><input type="image" width="18" height="18" src="images/search_right.gif" alt="<bean:message key="NewSearch.rightArrow" bundle="ProcessPortal"/>" onclick="moveColumns2('itemPossibleColumns', 'itemDisplayColumns', true, this.form); return false;"/><br/>
     <input type="image" width="18" height="18" src="images/search_left.gif" alt="<bean:message key="NewSearch.leftArrow" bundle="ProcessPortal"/>" onclick="moveColumns3('itemDisplayColumns', 'itemPossibleColumns', false, this.form);  return false;"/></td>
     <td><select id="itemDisplayColumns" name="instanceDisplayColumns"  size="<%= Query.INSTANCE_COLUMNS.length + Query.TASK_COLUMNS.length - 4%>"  multiple="multiple" class="multi-search" onchange="hideSaveSearch(); checkRenameBD(this);">
      <%
             for (Iterator itemResultIt = queryObject.getAllColumns().iterator(); itemResultIt.hasNext(); ) {
             Query.Column resultColumn = (Query.Column) itemResultIt.next();
             String columnName = resultColumn.getName();
             SearchColumnInfo column = selectedMap.get(columnName);
      %>
       <option value="<%= column.getNamePrefix() + column.getName()%>"><%=column.getLabelPrefix() + column.getLabel()%></option>
       <%
       }
       %>
    </select>
    <%
          for (java.util.Iterator bdResultIter = queryObject.getBusinessDataResults().iterator();
          bdResultIter.hasNext(); ) {
          Query.BusinessDataColumn resultColumn = (Query.BusinessDataColumn) bdResultIter.next();
          String columnName = resultColumn.getName();
          String columnLabel = resultColumn.getAlias();
    %>
    <input type="hidden" name="<%=columnName%>" value="<%=columnLabel%>" /><%
    }
    %>
    </td>
    <td width="32">
    <input type="image" width="18" height="18" src="images/search_up.gif" alt="<bean:message key="NewSearch.upArrow" bundle="ProcessPortal"/>" onclick="reorderColumns('itemDisplayColumns', 'up'); return false;"/><br/>
    <input type="image" width="18" height="18" src="images/search_down.gif" alt="<bean:message key="NewSearch.downArrow" bundle="ProcessPortal"/>" onclick="reorderColumns('itemDisplayColumns', 'down'); return false;"/>
    <div id="renameDiv" style="display:none"><br/>
    <div id="renameTextOriginal">&nbsp;</div>
    <div><label for="renameTextInput"></label><input style="height:15px;border: 1px solid #3161bd;" onblur="renameBDOption(this)" type="text" id="renameTextInput" disabled="true" readonly="true" value="" onchange="hideSaveSearch();"/></div>
    </div>
   </td>
   <td valign="top">

  <table width="100%">
  <!-- ==================================================================================== -->
  <!-- ============================ Sorting BEGIN ========================================= -->
  <!-- ==================================================================================== -->


   <tr><td><label for="sort1"><bean:message key="newsearch.Primary" bundle="ProcessPortal"/> <bean:message key="newsearch.ColumnName" bundle="ProcessPortal"/></label></td>
    <td><label for="newsearch.Task.prefix"></label><input type="text" id="newsearch.Task.prefix" style="display: none" value="<bean:message key="newsearch.Task" bundle="ProcessPortal" />" />
    <label for="newsearch.Instance.prefix"></label><input type="text" id="newsearch.Instance.prefix" style="display: none" value="<bean:message key="newsearch.Instance" bundle="ProcessPortal" />" />
    <label for="newsearch.BusinessData.prefix"></label><input type="text" id="newsearch.BusinessData.prefix" style="display: none" value="<bean:message key="newsearch.BusinessData" bundle="ProcessPortal"/>" />
    </td><td><label for="sortOrder1"><bean:message key="newsearch.SortOrder" bundle="ProcessPortal"/></label></td>
   </tr>
   <tr><td>
    <select id="sort1" class="condition" name="primarySort" size="1" style="width: 160px;" onchange="hideSaveSearch();">
      <option value="">&laquo;<bean:message key="newsearch.ChooseOne" bundle="ProcessPortal"/>&raquo;</option>
      <%
               Query.Column first = queryObject.getFirstSortColumn();
               for (String columnName : selectedMap.keySet()) {
                   SearchColumnInfo column = selectedMap.get(columnName);
      %>
             <option value="<%=columnName%>" <%= first != null && columnName.equals(first.getName()) ? "selected=\"true\"" : "" %>><%=column.getLabel()%></option>
             <%
             }
             %>
   </select>
   </td>
   <td>
   </td>
   <td>
    <select class="condition" id="sortOrder1" name="primarySortOrder" size="1" style="width: 100px;" onchange="hideSaveSearch();">
    <%
          String firstOrder = queryObject.getFirstSortColumnOrder();
          for (int i = 0; i < orders.length; i++) {
              String[] entry = orders[i];
    %><option value="<%=entry[0]%>" <%= firstOrder != null && entry[0].equals(firstOrder) ? "selected=\"true\"" : "" %>><%=entry[1]%></option> <%
 }
 %>
    </select>
   </td>
   </tr>
   <tr><td><br><label for="sort2"><bean:message key="newsearch.Secondary" bundle="ProcessPortal"/> <bean:message key="newsearch.ColumnName" bundle="ProcessPortal"/></label></td>
   <td></td><td><br><label for="sortOrder2"><bean:message key="newsearch.SortOrder" bundle="ProcessPortal"/></label></td>
   </tr>
   <tr><td>
    <select class="condition" id="sort2" name="secondarySort" size="1" style="width: 160px;" onchange="hideSaveSearch();">
    <option value="">&laquo;<bean:message key="newsearch.ChooseOne" bundle="ProcessPortal"/>&raquo;</option>
    <%
           Query.Column second = queryObject.getSecondSortColumn();
           for (String columnName : selectedMap.keySet()) {
               SearchColumnInfo column = selectedMap.get(columnName);
    %>
           <option value="<%=columnName%>" <%= second != null && columnName.equals(second.getName()) ? "selected=\"true\"" : "" %>><%=column.getLabel()%></option>
           <%
       }
    %>
  </td>
   <td></td>
   <td>
    <select class="condition" id="sortOrder2" name="secondarySortOrder" size="1" style="width: 100px;" onchange="hideSaveSearch();"> <% String secondOrder = queryObject.getSecondSortColumnOrder();
     for (int i = 0; i < orders.length; i++) { String[] entry = orders[i]; %><option value="<%=entry[0]%>" <%= (secondOrder != null && entry[0].equals(secondOrder)) ? "selected=\"true\"" : "" %>><%=entry[1]%></option><% } %></select>
   </td>
   </tr>
   </table><br>
<div style="width:1px;height:12px;border:0px;"><img src="images/spacer.gif"  alt="" height="12" width="1"/></div>
 <table id="searchborder" width="100%">
  <tr>
  <td style="width: 160px;"><br><label for="maxRowsId"><bean:message key="newsearch.ChooseItemsPerPage" bundle="ProcessPortal"/></label></td>
  <td>&nbsp;</td>
  <td><select id="maxRowsId" class="condition" name="maxRows" size="1" style="width: 60px;" onchange="hideSaveSearch();">
   <%
    String[] list = {"10", "20", "30", "50", "75", "100"};
    for (int i = 0; i < list.length; i++) {
    String s = list[i];
    out.write("<option value=\""+s+"\"");
    out.write(" ");
    if(queryObject.getMaxRows() == Integer.parseInt(list[i])) {
     out.write("selected=\"selected\"");
    }
    out.write(">");
    out.write(s);
    out.write("</option>");
    } %>
  </select>
 </td>
 </tr>
 </table>
 <div style="width:1px;height:5px;border:0px;"><img src="images/spacer.gif"  alt="" height="5" width="1"/></div>
  </td>
   </tr>
   <tr><td><input type="button" style="height:20px;" onClick="return toggle('less','more');" value="<bean:message key="newsearch.button.Less" bundle="ProcessPortal"/>" /></td></tr>
   </table>
  </div>

      <%--
      <!-- ======================================================================================= -->
      <!-- ============================= BUSINESS DATA SEARCH - BEGIN ============================ -->
      <!-- ======================================================================================= -->

      <table border="0">
      <% for (int i=0; i<15; i++) { %>

         <tr id="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_CONSTRAINT_PANE_ID_PREFIX + i %>"
             style="border: solid 1px red; display: none;">
         <td>

         <!-- Variable <%= i %> -->
         <!-- TODO: replace <input name> by value from i18. -->
         <input id="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_VAR_NAME_ID_PREFIX + i %>"
                name="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_VAR_NAME_ID_PREFIX + i %>"
                type="text" value="" class="condition"
                onfocus="if (this.value == BusinessDataConstants.INPUT_VAR_NAME_PROMPT) this.value='';"
                onblur="if (this.value == '') this.value=BusinessDataConstants.INPUT_VAR_NAME_PROMPT;"
         />

         < % - - alias flag
         </td>
         <td>

         <input id="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_IS_ALIAS_ID_PEFIX + i %>"
                name="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_IS_ALIAS_ID_PEFIX + i %>"
                type="checkbox" value="true" class="condition"
         />
         - - % >

         </td>
         <td>
         
         <select id="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_TYPE_ID_PEFIX + i %>"
                 name="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_TYPE_ID_PEFIX + i %>"
                 class="condition"
                 onchange="fillOperatorsForType('<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_OPERATOR_ID_PEFIX + i 
                 %>', getSingleSelection(this), getSingleSelection('<%=
                 Constants.FormBeans.ExecuteAdvancedSearch.BD_OPERATOR_ID_PEFIX + i %>'))"
         >
         </select>
         <script>fillWithTWTypes('<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_TYPE_ID_PEFIX + i %>', Operator.EQUALS)</script>

         </td>
         <td>

         <select id="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_OPERATOR_ID_PEFIX + i %>"
                 name="<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_OPERATOR_ID_PEFIX + i %>"
                 class="condition"
         >
         </select>
         <script>fillOperatorsForType('<%=Constants.FormBeans.ExecuteAdvancedSearch.BD_OPERATOR_ID_PEFIX + i %>', TWType.STRING);</script>

         </td>
         <td>

         <input id="<%= Constants.FormBeans.ExecuteAdvancedSearch.BD_VALUE_ID_PEFIX + i %>"
                name="<%= Constants.FormBeans.ExecuteAdvancedSearch.BD_VALUE_ID_PEFIX + i %>"
                type="text" value="" class="condition"
                onfocus="if (this.value == BusinessDataConstants.INPUT_VALUE_PROMPT) this.value='';"
                onblur_1="if (this.value == '') this.value = BusinessDataConstants.INPUT_VALUE_PROMPT;"
         />
         </td>
         </tr> <!-- id="bdConstraintPane<%= i %>" -->


      <% } %>
      </table>
      <input type="button" id="addBDConstraintButton"    value="Add constraint"
           onclick="addBDConstraint()" />
      <input type="button" id="removeBDConstraintButton" value="Remove constraint"
           onclick="removeBDConstraint()" style='display: none;' />

      <!-- ======================================================================================= -->
      <!-- ============================= BUSINESS DATA SEARCH - END   ============================ -->
      <!-- ======================================================================================= -->
      --%>

    </td>
    </tr>
  </table>
  </td></tr>
  </table>
 </td>
 </tr>
</table>
&nbsp;&nbsp;<input type="checkbox" id="tasksShows" name="organization" value="byTask" onchange="hideSaveSearch();" <%= queryObject.isOrganizedByInstance()?"":"CHECKED"%>/><label for="tasksShows"><bean:message key="newsearch.checkbox.OrganizeByTask" bundle="ProcessPortal"/></label>
<br/>
&nbsp;&nbsp;<input type="button" id="searchSubmit" value="<bean:message key="newsearch.button.StartSearch" bundle="ProcessPortal"/>" onClick="if(this.form.onsubmit)if(!this.form.onsubmit())return false;return this.form.submit();" />
<%
 boolean isPortalAdmin = (userRoles.contains("tw_portal_admins"));
 if ((savedSearch == null) || (savedSearch.getSearchID() == 0)) {
%>
<input type="button" onClick="doSave(); return false;" value="<bean:message key="newsearch.button.SaveSearch" bundle="ProcessPortal"/>" id="saveSearchButton" name="saveSearchButton" style="visibility:visible"/>
<%
 } else {
   if (savedSearch.getUserID() == user.getUserID()) {%>
<input type="button" onClick="doDelete(<%= savedSearch.getSearchID() %>); return false;" value="<bean:message key="newsearch.button.DeleteSearch" bundle="ProcessPortal"/>" />
<% if (isPortalAdmin) {%>
<input type="button" onClick="doShare(<%= savedSearch.getSearchID() %>); return false;" value="<bean:message key="newsearch.button.ShareSearch" bundle="ProcessPortal"/>" />
<% }
    } else if ((savedSearch.isShared()) && (isPortalAdmin)) {%>
<input type="button" onClick="doDelete(<%= savedSearch.getSearchID() %>); return false;" value="<bean:message key="newsearch.button.DeleteSharedSearch" bundle="ProcessPortal"/>" />
<%  }
 }%>
</form>
</div>
</div>
<%--
<% for (int i = 0; i < MAX_CONSTRAINTS; i++) {
if (i < conditionCount) {
 Query.Constraint condition = queryObject.getConstraint(i);
 if (condition != null) {
   String conditionValue = condition.getValue();
%>
<script type="text/javascript">
initializeOperator(document.getElementById('condition<%=i%>column')<%= (conditionValue != null) ? ", \"" + conditionValue +"\"": "" %>);
</script>
<%  }
}
}%>
--%>


<%--
<script>
for (Iterator it = queryObject.getBusinessDataConstraints().iterator(); it.hasNext(); ) {
  Query.BusinessDataConstraint constr = (Query.BusinessDataConstraint) it.next();
%>
  addBDConstraintForVariable("<%= jScriptEncode(constr.getVariableName()) %>",
      "<%= jScriptEncode(constr.getType().getJavaScriptName()) %>",
      "<%= jScriptEncode(constr.getOperator().getName()) %>",
      "<%= jScriptEncode(constr.getValue()) %>"
   );
<%  
}
</script>
--%>
