<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page language="java" import="com.lombardisoftware.data.DocumentShell,
  com.lombardisoftware.bpd.BPDConstants,
  com.lombardisoftware.portal.utils.CommentHelper,
  com.lombardisoftware.portal.utils.SessionHelper,
  com.lombardisoftware.portal.viewhelper.DocumentsHelper,
  com.lombardisoftware.client.delegate.AuthorizationAPIDelegateFactory,
  com.lombardisoftware.server.api.ActionPolicy,
  com.lombardisoftware.client.delegate.BusinessDelegateException,
  com.lombardisoftware.core.TeamWorksException,
  com.lombardisoftware.core.config.server.PortalConfig,
  com.lombardisoftware.core.config.TWConfiguration,
  com.lombardisoftware.core.TWConstants,
  com.lombardisoftware.client.delegate.AuthorizationAPIDelegateFactory,
  com.lombardisoftware.client.delegate.AuthorizationAPIDelegate,
  com.lombardisoftware.portal.utils.TaskInstanceUtils,
  com.lombardisoftware.portal.utils.AccessibilityUtils,
  com.lombardisoftware.core.*,
  com.ibm.icu.text.DateFormat,
  com.lombardisoftware.client.DateFormatUtils,
  java.util.*" %>
<%@ page import="com.lombardisoftware.psapi.data.Group"%>
<%@ page import="com.lombardisoftware.psapi.data.Task"%>
<%@ page import="com.lombardisoftware.psapi.data.User"%>
<%@ page import="com.lombardisoftware.server.psapi.dao.GroupDAOImpl"%>
<%@ page import="com.lombardisoftware.server.psapi.dao.UserDAOImpl"%>
<%@ page import="com.lombardisoftware.portal.utils.MessagesHelper"%>
<%@ page import="java.util.ArrayList, java.math.BigDecimal"%>
<%@ page import="java.util.logging.Logger" %>
<%@ page import="java.util.logging.Level" %>
<%@ page import="com.lombardisoftware.logger.WLELoggerConstants" %>
<%@ page import="com.lombardisoftware.core.UserPreference"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ include file="../contextRoot.jsp" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<jsp:useBean id="tasks" class="java.util.ArrayList" scope="request" />
<jsp:useBean id="specialTasks" class="java.util.ArrayList" scope="request" />
<jsp:useBean id="docs" type="java.util.List" scope="request"/>
<jsp:useBean id="userMap" class="java.util.HashMap" scope="request" />
<jsp:useBean id="groupMap" class="java.util.HashMap" scope="request" />
<jsp:useBean id="taskSorter" class="com.lombardisoftware.psapi.data.ColumnSorter" scope="session"/>
<jsp:useBean id="commentSorter" class="com.lombardisoftware.psapi.data.ColumnSorter" scope="session"/>
<jsp:useBean id="docSorter" class="com.lombardisoftware.psapi.data.ColumnSorter" scope="session"/>
<jsp:useBean id="bpd" class="com.lombardisoftware.psapi.data.BPD" scope="request"/>
<jsp:useBean id="bpdInstance" class="com.lombardisoftware.psapi.data.BPDInstance" scope="request"/>
<jsp:useBean id="user" class="com.lombardisoftware.psapi.data.User" scope="session"/>

<%!
private static final Logger logger = Logger.getLogger(WLELoggerConstants.PORTAL_LOGGER, WLELoggerConstants.WLE_PIIMESSAGE_FILE);
private static final String CLASS_NAME = "com.lombardisoftware.portal.jsp.ProcessDetails";
private static final PortalConfig portalConfig = TWConfiguration.getInstance().getServer().getPortal();

/*
private static boolean isTaskCanBeAssignedToMe(Task task) throws TeamWorksException {
   	ArrayList tselectedIds = new ArrayList();
   	tselectedIds.add(new BigDecimal(task.getTaskID()));
	return AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecutesAction(ActionPolicy.ACTION_ASSIGN_TASK, tselectedIds);
}
*/

private static boolean isCurrentRoleCanSeeTasksOfOtherRoles() {
	  return !TWConstants.OTHER_TASK_VISIBLE_BY_ROLE.equalsIgnoreCase(portalConfig.getOtherTasksVisibility());
}

/*
private static boolean isTaskAssignedToRole(Task inst, javax.servlet.ServletRequest request) {
	HashMap groupMap = (HashMap) request.getAttribute("groupMap");
	//Group grp = (Group) groupMap.get(new Long(inst.getGroupID()));
	return (inst.getGroupID() != 0) && (groupMap != null)
		&& (groupMap.get(new Long(inst.getGroupID())) != null);
}
private static boolean isTaskAssignedToUserRole(Task inst, javax.servlet.ServletRequest request) {
	HashMap groupMap = (HashMap) request.getAttribute("groupMap");
	//Group grp = (Group) groupMap.get(new Long(inst.getGroupID()));
	if (inst.getUserID() == -1)
		return false;
	return (inst.getGroupID() != 0) && (groupMap != null)
		&& (groupMap.get(new Long(inst.getGroupID())) != null);
}
*/
private static boolean isVisibleTask(Task inst, javax.servlet.ServletRequest request) throws TeamWorksException {
	AuthorizationAPIDelegate authApi = AuthorizationAPIDelegateFactory.getInstance().newInstance();
	BigDecimal taskId = new BigDecimal(inst.getTaskID());
	Collection taskIds = Arrays.asList(new Object[]{taskId});
	// TODO: it is not optimal, must use more complicated EJB interface
    //return authApi.canExecutesAction(ActionPolicy.ACTION_ASSIGN_TASK, taskIds) &&
    //	(authApi.canExecutesAction(ActionPolicy.ACTION_REASSIGN_TASK, taskIds)
	//	|| authApi.canExecutesAction(ActionPolicy.ACTION_REASSIGN_TASK_USER_ROLE, taskIds));
    return authApi.canExecutesAction(ActionPolicy.ACTION_ASSIGN_TASK, taskIds)
		|| authApi.canExecutesAction(ActionPolicy.ACTION_REASSIGN_TASK, taskIds)
		|| authApi.canExecutesAction(ActionPolicy.ACTION_REASSIGN_TASK_USER_ROLE, taskIds);
}
%>
<%
 String drillDownURL="getProcessDetails.do?bpdInstanceId=" + bpdInstance.getBpdInstanceID();
 UserPreference userPreference = (UserPreference)session.getAttribute(UserPreference.SESSION_KEY);
 boolean isAllTasksShown = "AllTasks".equals(SessionHelper.getCookieValue(request,"allTasks"));
 DateFormat dateTimeFormat = com.lombardisoftware.portal.utils.BidiUtils.getDateTimeFormat(userPreference);
%>
<script TYPE="text/javascript" src="<%=request.getContextPath()%>/js/processDetails.js"></script>
<div class="body"><!-- Contents tables -->
<!------------------------------------------------------------------------>
<!-- Contents (Details) -->
<!------------------------------------------------------------------------>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Contents", "BEGIN"); %>
<table class="content-table">
 <thead>
  <tr><th colspan="4"><bean:message key="processDetails.ContentsTable.Heading" bundle="ProcessPortal"/></th></tr>
  <tr>
   <td width="120"><bean:message key="processDetails.ContentsTable.ProcessDefinition" bundle="ProcessPortal"/></td>
   <td class="cell-content bidiText"><%=bpd.getName()%></td>
   <td width="120"><bean:message key="processDetails.ContentsTable.Status" bundle="ProcessPortal"/></td>
   <td class="cell-content"><bean:message key="<%=MessagesHelper.INSTANCE_STATUS_DISPLAY_NAME_PREFIX + bpdInstance.getStatusName()%>" bundle="ProcessPortal"/></td>
  </tr>
  <tr>
   <td width="120"><bean:message key="processDetails.ContentsTable.InstanceName" bundle="ProcessPortal"/></td>
   <td class="cell-content bidiText"><%= bpdInstance.getName()==null?"":bpdInstance.getName()%></td>
   <td width="120"><bean:message key="processDetails.ContentsTable.DueDate" bundle="ProcessPortal"/></td>
   <td class="cell-content">
    <%=bpdInstance.getDueDate()==null?"":dateTimeFormat.format(bpdInstance.getDueDate())%>
   </td>
  </tr>
  <tr>
   <td width="120"><bean:message key="processDetails.ContentsTable.InstanceID" bundle="ProcessPortal"/></td>
   <td class="cell-content">
   <% pageContext.setAttribute("columnValue",Long.valueOf(bpdInstance.getBpdInstanceID()));%>
   <bean:write name="columnValue" formatKey="common.numberIntegerFormat" bundle="ProcessPortal"/>
   </td>
   <td>&nbsp;</td>
   <td class="cell-content">&nbsp;</td>
  </tr>
 </thead>
</table>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Contents", "Content END"); %>

<!------------------------------------------------------------------------>
<!-- Tasks -->
<!------------------------------------------------------------------------>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Tasks", "Tasks BEGIN"); %>
<table class="content-table">
<thead>
 <tr>
  <% if(isAllTasksShown) { %>
  <th colspan="8">
  <% } else { %>
  <th colspan="7">
  <% } %>
   <p style="float:left"><bean:message key="processDetails.TasksTable.Heading" bundle="ProcessPortal"/></p>
    <label for="taskShown"></label><select style="float:right" id="taskShown"  onChange="toggleTasks()">
    <option id="allTasks" VALUE="AllTasks"><bean:message key="processDetails.TasksTable.TaskShownType.AllTasks" bundle="ProcessPortal"/></option>
    <option id="allOpenTasks" VALUE="AllOpenTasks" selected="true"><bean:message key="processDetails.TasksTable.TaskShownType.OpenTasks" bundle="ProcessPortal"/></option>
   </select>
  </th>
   </tr>
   <tr>
     <td></td>
     <td><bean:message key="processDetails.TasksTable.ActivityName" bundle="ProcessPortal"/></td>
     <!--Status -->
     <% if (taskSorter.isFirstSorter("Task Status")){%>
     <td class="sort1"><a href="<%=drillDownURL%>&taskCol=Task Status"><bean:message key="processDetails.TasksTable.Status" bundle="ProcessPortal"/></a>
      <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" >
     </td>
     <%}else if (taskSorter.isSecondSorter("Task Status")){%>
     <td class="sort2"><a href="<%=drillDownURL%>&taskCol=Task Status"><bean:message key="processDetails.TasksTable.Status" bundle="ProcessPortal"/></a>
      <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" >
     </td>
      <%}else{%>
     <td><a href="<%=drillDownURL%>&taskCol=Task Status"><bean:message key="processDetails.TasksTable.Status" bundle="ProcessPortal"/></a></td>
     <%}%>

     <!--Participant-->
     <% if (taskSorter.isFirstSorter("Participant")){%>
     <td class="sort1"><a href="<%=drillDownURL%>&taskCol=Participant"><bean:message key="processDetails.TasksTable.Participant" bundle="ProcessPortal"/></a>
      <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" >
     </td>
     <%}else if (taskSorter.isSecondSorter("Participant")){%>
     <td class="sort2"><a href="<%=drillDownURL%>&taskCol=Participant"><bean:message key="processDetails.TasksTable.Participant" bundle="ProcessPortal"/></a>
      <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" >
     </td>
     <%}else{%>
     <td><a href="<%=drillDownURL%>&taskCol=Participant"><bean:message key="processDetails.TasksTable.Participant" bundle="ProcessPortal"/></a></td>
     <%}%>

     <!--Priority-->
     <% if (taskSorter.isFirstSorter("Task Priority")){%>
     <td class="sort1"><a href="<%=drillDownURL%>&taskCol=Task Priority"><bean:message key="processDetails.TasksTable.Priority" bundle="ProcessPortal"/></a>
      <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" ></td>
     <%}else if (taskSorter.isSecondSorter("Task Priority")){%>
     <td class="sort2"><a href="<%=drillDownURL%>&taskCol=Task Priority"><bean:message key="processDetails.TasksTable.Priority" bundle="ProcessPortal"/>
       </a><img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" >
     </td>
     <%}else{%>
     <td><a href="<%=drillDownURL%>&taskCol=Task Priority"><bean:message key="processDetails.TasksTable.Priority" bundle="ProcessPortal"/></a></td>
     <%}%>
     <!--Received-->
     <% if (taskSorter.isFirstSorter("Task Due Date")){%>
     <td class="sort1">
      <a href="<%=drillDownURL%>&taskCol=Task Due Date"><bean:message key="processDetails.TasksTable.DueDate" bundle="ProcessPortal"/></a>
       <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" >
     </td>
     <%}else if (taskSorter.isSecondSorter("Task Due Date")){%>
      <td class="sort2"><a href="<%=drillDownURL%>&taskCol=Task Due Date"><bean:message key="processDetails.TasksTable.DueDate" bundle="ProcessPortal"/></a>
       <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" >
      </td>
      <%}else{%>
      <td><a href="<%=drillDownURL%>&taskCol=Task Due Date"><bean:message key="processDetails.TasksTable.DueDate" bundle="ProcessPortal"/></a></td>
      <%}%>
      <!--Closed-->
      <% if(isAllTasksShown) { %>
       <% if (taskSorter.isFirstSorter("Task Closed Date")){ %>
       <td class="sort1">
        <a href="<%=drillDownURL%>&taskCol=Task Closed Date"><bean:message key="processDetails.TasksTable.ClosedDate" bundle="ProcessPortal"/></a>
         <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" >
       </td>
       <% }else if (taskSorter.isSecondSorter("Task Closed Date")){ %>
       <td class="sort2"><a href="<%=drillDownURL%>&taskCol=Task Closed Date"><bean:message key="processDetails.TasksTable.ClosedDate" bundle="ProcessPortal"/></a>
        <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=taskSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(taskSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" >
       </td>
       <% }else{ %>
       <td><a href="<%=drillDownURL%>&taskCol=Task Closed Date"><bean:message key="processDetails.TasksTable.ClosedDate" bundle="ProcessPortal"/></a></td>
       <% } %>
      <% } %>
      <td><bean:message key="processDetails.TasksTable.Run" bundle="ProcessPortal"/></td>
 </tr>
 </thead>
 <tbody id="tb1">
   <%
     for(int i=0;i<tasks.size();i++) {
         Task inst=(Task)tasks.get(i);
         //check if all tasks are to be displayed
         if (!isAllTasksShown) {
             //skip this task if it is not open
            if (!inst.isOpen())
                 continue;
         }
         //out.println("inst.getGroupId(): " + inst.getGroupID());
         if (!isCurrentRoleCanSeeTasksOfOtherRoles() && !isVisibleTask(inst, request)) {
         	continue;
         }
         /*
         if (isTaskAssignedToRole(inst, request) && !isCurrentRoleCanSeeTasksOfOtherRoles()
         	&& !isTaskCanBeAssignedToMe(inst)) {
        	continue;
         }
         if (isTaskAssignedToUserRole(inst, request) && !isCurrentRoleCanSeeTasksOfOtherRoles()
           	&& !isTaskCanBeAssignedToMe(inst)) {
            	continue;
         }
        */
         User taskUser = (User) userMap.get(Long.valueOf(inst.getUserID()));
    %>
    <tr id="row<%=i+1%>">
     <td width ="1"><label for="item<%=i+1%>"></label><input title='<bean:message key="advancedSearchResults.tasksTable.checkbox.title" bundle="ProcessPortal"/>' type="checkbox" align="center" id="item<%=i+1%>" name="item<%=i+1%>" onclick="selectRow(<%=i+1%>);updateTaskChecked(<%= inst.getTaskID() %>,this.checked);onSelectionChange();document.getElementById('item<%=i+1%>').focus();"></td>
     <% String activityName=inst.getActivityName(); %>
     <td><a href="getProcessDetails.do?bpdInstanceId=<%=inst.getbpdInstanceID()%>&taskId=<%=inst.getTaskID()%>"><%=activityName%></a></td>
     <td><a href="getProcessDetails.do?bpdInstanceId=<%=inst.getbpdInstanceID()%>&taskId=<%=inst.getTaskID()%>"><bean:message key="<%=MessagesHelper.TASK_STATUS_DISPLAY_NAME_PREFIX + inst.getStatusCodeName()%>" bundle="ProcessPortal"/></a></td>
     <td>
  <%
         String participant="";
         if (inst.getGroupID() == 0) {
             if (taskUser != null){
                 participant= taskUser.getUserName();
             }
         } else {
             Group grp = (Group) groupMap.get(Long.valueOf(inst.getGroupID()));
             participant= ((grp == null) ? "" : grp.getDisplayName());
         }
   %>
  <%=inst.getGroupID() > 0 ? ((Group) groupMap.get(Long.valueOf(inst.getGroupID()))).getDisplayName() : (taskUser != null ? taskUser.getUserName() : "" ) %></td>
     <td><bean:message key="<%=MessagesHelper.PRIORITY_DISPLAY_NAME_PREFIX+inst.getPriorityName()%>" bundle="ProcessPortal"/></td>
     <td>
        <%=inst.getDueDate()==null?"":dateTimeFormat.format(inst.getDueDate())%>
     </td>
     <% if(isAllTasksShown) { %>
     <td>
		<%=inst.getCloseDateTime()==null?"":dateTimeFormat.format(inst.getCloseDateTime())%>
     </td>
     <% } %>
     <td>
         <%
             if (TaskInstanceUtils.isTaskRunnable(bpdInstance, inst, user)) {
               if(inst.isInfoPathForm()) {%>
                  <img src="images/run_disabled.gif" alt='<bean:message key="processDetails.TasksTable.tip.RunTaskInfoPath" bundle="ProcessPortal"/>'/>
               <% } else { %>
         <a href="#" title='<bean:message key="processDetails.TasksTable.tip.RunTask" bundle="ProcessPortal"/>' onClick="performPopupActionSingleWindowAndDisable(this, 'teamworksruntask<%=inst.getTaskID()%>', '<%= teamworksContextRoot %>/process.lsw?zWorkflowState=1', 'zTaskId=<%=inst.getTaskID() %>', 'height=600,width=720,scrollbars=yes,resizable=yes');">
         	<img src="images/run.gif" alt="<bean:message key="processDetails.TasksTable.Run" bundle="ProcessPortal"/>" />
         </a>
         <% }
         // disable run task button if instance is suspended
         } else if(bpdInstance.getExecStatus() != BPDConstants.EXECUTION_STATUS_SUSPENDED && TaskInstanceUtils.isTaskRunnableByStatus(inst)) {
              if(AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecuteAction(com.lombardisoftware.server.api.ActionPolicy.ACTION_ASSIGN_TASK, new BigDecimal(inst.getTaskID()))) {
                   if(inst.isInfoPathForm()) {%>
                        <img src="images/run_disabled.gif" alt='<bean:message key="processDetails.TasksTable.tip.RunTaskInfoPath" bundle="ProcessPortal"/>'/>
                    <% } else if(!inst.hasStartProcess()) { %>
                        &nbsp;&nbsp;&nbsp;
                    <% } else if(userPreference.isAlertOnAssignAndRun()) {%>
                        <a href="#" title='<bean:message key="processDetails.TasksTable.tip.AssignAndRunTask" bundle="ProcessPortal"/>' onClick="performPopupActionWithWarningSingleWindow('teamworksruntask<%=inst.getTaskID()%>', 'processDetails/assignTask.do?needToRun=true', 'id=<%=inst.getTaskID()%>', 'height=600,width=720,scrollbars=yes,resizable=yes','<bean:message key="assignAndRunConfirmation.MessageBody" bundle="ProcessPortal" encodeTo="inlinejs"/>')">
                        <img src="images/run.gif" alt="<bean:message key="processDetails.TasksTable.Run" bundle="ProcessPortal"/>" />
                        </a>
                    <% } else { %>
                        <a href="#" title='<bean:message key="processDetails.TasksTable.tip.AssignAndRunTask" bundle="ProcessPortal"/>' onClick="performPopupActionSingleWindowAndDisable(this, 'teamworksruntask<%=inst.getTaskID()%>', 'processDetails/assignTask.do?needToRun=true', 'id=<%=inst.getTaskID()%>', 'height=600,width=720,scrollbars=yes,resizable=yes')">
                        <img src="images/run.gif" alt="<bean:message key="processDetails.TasksTable.Run" bundle="ProcessPortal"/>" />
                        </a>
                    <% }
              } else {
                  %>&nbsp;&nbsp;&nbsp;<%
              }
           } else {
               %>&nbsp;&nbsp;&nbsp;<%
           }
         %>
     </td>
   </tr>
  <% }
   %>
  </tbody>
  </table>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Tasks", "Tasks END"); %>
  
<!------------------------------------------------------------------------>
<!-- Collaboration -->
<!------------------------------------------------------------------------>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Collaboration", "Collaboration BEGIN"); %>
  <table class="content-table">
  <thead>
      <tr>
          <th colspan="5">
              <p style="float:left"><bean:message key="processDetails.CollaborationTable.Heading" bundle="ProcessPortal"/></p>
              <input type="button" value="<bean:message key="processDetails.CollaborationTable.AddCommentButton" bundle="ProcessPortal"/>" style="float:right" style="height:20px"
                     onClick="javascript:performPopupAction('addCommentSetup.do', 'bpdInstanceId=<%= bpdInstance.getBpdInstanceID() %>', 'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto');">
          </th>
      </tr>
      <tr>
          <!-- type icon -->
                                      <% if (commentSorter.isFirstSorter("Task StatusID")) {%>
          <td style="padding: 0px 5px 0 5px" class="sort1">
               
			   <a href="<%= drillDownURL %>&commentCol=Task StatusID"><bean:message key="processDetails.CollaborationTable.Type" bundle="ProcessPortal"/></a> <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getFirstSortOrder() %>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" ></td>
                                      <%} else if (commentSorter.isSecondSorter("Task StatusID")) {%>
          <td style="padding: 0px 5px 0 5px" class="sort2">
               <%
			   
			   %>
			   
			   <a href="<%= drillDownURL %>&commentCol=Task StatusID"><bean:message key="processDetails.CollaborationTable.Type" bundle="ProcessPortal"/></a> <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getSecondSortOrder() %>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" ></td>
                                      <%} else {%>
          <td style="padding: 0px 5px 0 5px">
               <a href="<%= drillDownURL %>&commentCol=Task StatusID"><bean:message key="processDetails.CollaborationTable.Type" bundle="ProcessPortal"/></a>
          </td>
<%}%>
            <!--Date -->
            <% if (commentSorter.isFirstSorter("Task Received Date")){%>
            <td class="sort1"><a href="<%=drillDownURL%>&commentCol=Task Received Date"><bean:message key="processDetails.CollaborationTable.Date" bundle="ProcessPortal"/></a> <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" ></td>
            <%}else if (commentSorter.isSecondSorter("Task Received Date")){%>
            <td class="sort2"><a href="<%=drillDownURL%>&commentCol=Task Received Date"><bean:message key="processDetails.CollaborationTable.Date" bundle="ProcessPortal"/></a><img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" ></td>
            <%}else{%>
            <td><a href="<%=drillDownURL%>&commentCol=Task Received Date"><bean:message key="processDetails.CollaborationTable.Date" bundle="ProcessPortal"/></a></td>
            <%}%>
            <!--From -->
             <% if (commentSorter.isFirstSorter("User Name")){%>
            <td class="sort1"><a href="<%=drillDownURL%>&commentCol=User Name"><bean:message key="processDetails.CollaborationTable.From" bundle="ProcessPortal"/></a>
                <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" >
            </td>
            <%}else if (commentSorter.isSecondSorter("User Name")){%>
            <td class="sort2"><a href="<%=drillDownURL%>&commentCol=User Name"><bean:message key="processDetails.CollaborationTable.From" bundle="ProcessPortal"/></a>
                <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" >
            </td>
            <%}else{%>
            <td><a href="<%=drillDownURL%>&commentCol=User Name"><bean:message key="processDetails.CollaborationTable.From" bundle="ProcessPortal"/></a></td>
             <%}%>
            <!--To -->
            <% if (commentSorter.isFirstSorter("To")){%>
            <td class="sort1"><a href="<%=drillDownURL%>&commentCol=To"><bean:message key="processDetails.CollaborationTable.To" bundle="ProcessPortal"/></a>
                <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" >
            </td>
            <%}else if (commentSorter.isSecondSorter("To")){%>
            <td class="sort2"><a href="<%=drillDownURL%>&commentCol=To"><bean:message key="processDetails.CollaborationTable.To" bundle="ProcessPortal"/></a>
                <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" >
            </td>
            <%}else{%>
            <td><a href="<%=drillDownURL%>&commentCol=To"><bean:message key="processDetails.CollaborationTable.To" bundle="ProcessPortal"/></a></td>
            <%}%>
            <!--Subject --><!-- cant sort for a this type of column in SQL -->
            <td><bean:message key="processDetails.CollaborationTable.Comment" bundle="ProcessPortal"/></td>
            <!-- <td><a href="javascript:SetCookie('sTaskCol','NAME');refreshPage()">Type</a></td> -->
        </tr>
    </thead>
    <tbody>
    <%
		// it's bad stily but there are no other way I need to get message directrly
		com.lombardisoftware.portal.struts.i18n.TWMessageResources messageRes =
		   (com.lombardisoftware.portal.struts.i18n.TWMessageResources)application.getAttribute("ProcessPortal");
		java.util.Locale locale = (java.util.Locale)session.getAttribute(
		        org.apache.struts.Globals.LOCALE_KEY);

    	for (int i=0;i<specialTasks.size();i++) {
            Task inst=(Task)specialTasks.get(i);
            String typeIcon = (String) CommentHelper.getIconName(inst.getStatus());
            String type = inst.getStatusCodeName();
            User fromUser = (User) userMap.get(Long.valueOf(inst.getRcvdFrom()));
            
            String to= "Everyone";
            if (inst.isHelpRequest() || inst.isAlert()) {
                long toId = inst.getUserID();
                if (toId != -1) {
                    User toUser = (User) userMap.get(Long.valueOf(inst.getUserID()));
                    to = ((toUser == null) ? "" : toUser.getFullName());
                } else {
                    Group toGroup = (Group) groupMap.get(Long.valueOf(inst.getGroupID()));
                    to = ((toGroup == null) ? "" : toGroup.getGroupName());
                }
            }

            // Resolve localized task type's text and make sure it complies to the property format we support
			String localizedTypeText = 
			  messageRes.getMessage(locale, ("processDetails.CollaborationTable.TaskType." + type).replaceAll("_", ""));
			if (localizedTypeText.startsWith(
			        com.lombardisoftware.portal.struts.i18n.TWMessageResources.MESSAGE_NOT_FOUND_START)) {
			    localizedTypeText = type;
			}
            
            // no getNarrative method on Task now, how can fix it???
            String comm = inst.getNarrativeWithFreshUpdate();
            if(comm != null && comm.endsWith("viewPopup.IgnoredHelpRequestMessage")) {
                String message = messageRes.getMessage(locale, "viewPopup.IgnoredHelpRequestMessage");
                comm = comm.replaceAll("viewPopup.IgnoredHelpRequestMessage", " " + message);
            }
            if (comm != null && comm.length() > 30) {
                comm = comm.substring(0,30);
                comm += "...";
            }
        %>
        <tr>
           <% String commentHref = "javascript:performPopupAction('viewComment.do', " + "'bpdInstanceId=" + bpdInstance.getBpdInstanceID() + "&taskId=" + inst.getTaskID() + "', " + "'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto');"; %>
            <td width="1%" align="center"><a href="<%= commentHref %>"><img src="<%= typeIcon %>" alt="<%= localizedTypeText %>" title="<%= localizedTypeText %>"/></a></td>
            <td width="14%"><a href="<%= commentHref %>"><%=inst.getRcvdDateTime()==null?"":dateTimeFormat.format(inst.getRcvdDateTime())%></a></td>
            <td width="14%"><a href="<%= commentHref %>"><%=fromUser.getFullName()%></a></td>
            <td width="14%">
              <a href="<%= commentHref %>">
                   <%if("Everyone".equals(to)){%> <bean:message key="addComment.Everyone" bundle="ProcessPortal"/>
                   <% } else { out.write(to);}%></a>
            </td>
            <td width="14%" class="bidiText"><a href="<%= commentHref %>"><%=comm%></a></td>
        </tr>
<% }%>
</tbody>
</table>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Collaboration", "Collaboration END"); %>

<!------------------------------------------------------------------------>
<!-- Documents -->
<!------------------------------------------------------------------------>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Documents", "Documents BEGIN"); %>
<table class="content-table">
 <thead><tr>
   <th colspan="4">
    <p style="float:left"><bean:message key="processDetails.DocumentsTable.Heading" bundle="ProcessPortal"/></p>
    <input type="button" value="<bean:message key="processDetails.DocumentsTable.AddDocumentButton" bundle="ProcessPortal"/>" style="float:right;" style="height:20px;"
     onClick="javascript:performPopupAction('addDocumentSetup.do', 'bpdInstanceId=<%= bpdInstance.getBpdInstanceID() %>', 'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto');">
    </th>
   </tr>
   <tr><%-- These should be sortable  --%>
    <td><bean:message key="processDetails.DocumentsTable.Name" bundle="ProcessPortal"/></td>
    <td><bean:message key="processDetails.DocumentsTable.Revision" bundle="ProcessPortal"/></td>
    <td><bean:message key="processDetails.DocumentsTable.RevisionDate" bundle="ProcessPortal"/></td>
    <td><bean:message key="processDetails.DocumentsTable.LastModifiedBy" bundle="ProcessPortal"/></td>
   </tr>
  </thead>
 <tbody>
  <%
  for (int i=0;i<docs.size();i++) {
    DocumentShell inst = (DocumentShell) docs.get(i);
  %>
  <tr>
   <td width="14%">
    <a href="viewDocumentVersion.do?bpdInstanceId=<%=bpdInstance.getBpdInstanceID()%>&parentId=<%=inst.getParentID()%>"><%=inst.getDocName()%></a>
   </td>
   <td width="14%">
   <%= DocumentsHelper.createLink(inst, String.valueOf(inst.getVersion()))%>
   </td>
   <td width="14%">
    <%=inst.getAuthoredDTG()==null?"":dateTimeFormat.format(inst.getAuthoredDTG())%>
   </td>
   <td width="14%">
   <%=inst.getAuthor().getFullname()%>
   </td>
 </tr>
 <%}%>
 </tbody>
</table>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Documents", "Documents END"); %>

<!------------------------------------------------------------------------>
<!-- Case Management -->
<!------------------------------------------------------------------------>
<%-- Added for Tsunami, add the SharePoint label to the resource bundle --%>  
<% if (bpdInstance.getSharepointSiteURL() != null && bpdInstance.getSharepointSiteURL().length() > 0) { %>  
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Case Management", "Case Management BEGIN"); %>
<table class="content-table">
 <thead>
   <tr>
     <th colspan="2"><p style="float:left">Case Management</p></th>
   </tr>
   <tr>
     <td width="120">SharePoint Site:</td>
     <td style="background:white"><a target="_blank" href="<%=bpdInstance.getSharepointSiteURL()%>"><%=bpdInstance.getSharepointSiteURL()%></a></td>
   </tr>
 </thead>
</table>
<% if (logger.isLoggable(Level.FINE)) logger.logp(Level.FINE, CLASS_NAME, "Case Management", "Case Management END"); %>
<% } %>   
</div>
<!-- RG: kept here for firing the event when the entire page is loaded
         this is a workAround for not using OnLoad() on body -->
<script type="text/javascript">
 updateInstanceChecked(<%=bpdInstance.getBpdInstanceID()%>,true);
 onSelectionChange();
 readPageState();
</script>
