<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ include file="../contextRoot.jsp" %>
<jsp:useBean id="content" class="java.lang.String" scope="request" />
<jsp:useBean id="displayName" class="java.lang.String" scope="request" />
<script type="text/javascript" src="<%=request.getContextPath()%>/js/chart-tooltip.js"></script>
<script type="text/javascript">
function changeBreadcrumbs(text) {
    var el = document.getElementById("breadcrumbs");
    if(el) {
        el.innerHTML= "<h1>" + text + "</h1>";
    }
}

function getContextPath() {
    return '<%= request.getContextPath() %>';
}

function addExportData(csvTable) {
    document.forms.exportData.data.value = "\uFEFF" + document.forms.exportData.data.value + "\n\n" + csvTable;
}

function drilldownClick(label, serie, data, chart, area) {
  // Override this in your own report to do advanced drilldown effects.
  // return true from this one if you want normal page forwarding to take place.

    if (area && area.href) {
        var url = area.href.replace('report_detail\.lsw', 'viewReportPage.do');
        location.href = url;
        return false;
    }
    return true;
}

function init() {
}

function addUserFilter(label, html) {
    var div = document.createElement("DIV");
    var id = document.getElementById("addFilterTag");
    if (id) {
        div.innerHTML = "<center><table border='0' width='95%' cellpadding=0 cellspacing=0>" +
                        "<tr><td class='rpfilterhd'>" + label + "</td></tr>" +
                        "<tr><td class='rpfilterbd'>" + html + "</td></tr></table></center><BR>";
        id.appendChild(div);
    }

    var refreshDataElt = document.getElementById("refreshDataElement");
    if (refreshDataElt) {
        if (refreshDataElt.style.visibility != "visible") {
            refreshDataElt.style.visibility = "visible";
        }
    }
}

function doSaveSettings() {
    var _report_detail_bookmark_title = location.href;
    var reportHeading = document.getElementById("report-heading");
    if (reportHeading) {
        _report_detail_bookmark_title = reportHeading.innerHTML;
    }    
	if (document.all) {
		window.external.AddFavorite(location.href, _report_detail_bookmark_title);
	} else if (window.sidebar) {
		window.sidebar.addPanel(_report_detail_bookmark_title , location.href,  "");
	}        
}


function doSubmitExport() {
	document.forms["exportData"].submit();
}

function launchEPVList() {
  window.open("<%= teamworksContextRoot %>/cs_epv.lsw?zReportId=<%=request.getParameter("zReportId")%>&zContext=<%= request.getParameter("zContext") %>&zTip=<%= request.getParameter("zTip") %>", "epv", "toolbar=no,width=800,height=700,resizable=yes,scrollbars=yes");
}

</script>

<div class="body" id="addPopupToThis">
<% if (content != null && !content.equals("")) { %>
<%= content %>
<% } else { %>
<bean:message key="No.Data.Text" bundle="ProcessPortal"/>
<% } %>
</div>