<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.report.*,
                 java.util.List" %>
<%@ page import="com.lombardisoftware.portal.utils.MessagesHelper" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>

<script type="text/javascript" src="<%=request.getContextPath()%>/js/utils.js"></script>

<% List<String> groups = AdHocReportUtils.getSecurityGroups(); %>

<div class="body" id="body" tabindex="0" role="form" aria-label="<bean:message key="saveAdHocReportHeading.head" bundle="ProcessPortal"/>" onkeypress="moveFocusToWorkLink(event)">
    <html:form action="/jsp/generateReportAction.jsp" method="POST" focus="reportName">
        <html:hidden property="bpdId" />
        <html:hidden property="xAxisBindingNodeTypeProp" />
        <html:hidden property="xAxisBindingVar" />
        <html:hidden property="xAxisSortOrder" />
        <html:hidden property="yAxisBindingNodeTypeProp" />
        <html:hidden property="yAxisBindingVar" />
        <html:hidden property="yAxisFunctionType" />
        <html:hidden property="yAxisConversionType" />
        <html:hidden property="timeRangeType" />
        <html:hidden property="timeRangeStartDate" />
        <html:hidden property="timeRangeEndDate" />
        <html:hidden property="businessDataType" />
        <html:hidden property="chartType" />
        <%
            int i = 0;
            for (AdHocReportData.BusinessDataConstraintData bdcd : AdHocReportUtils.initBusinessDataConstraintDataListFromRequest(request)) {
        %>
        <input type="hidden" name="bdVar<%= i %>" value="<%= bdcd.getVar() %>" />
        <input type="hidden" name="bdType<%= i %>" value="<%= bdcd.getType() %>" />
        <input type="hidden" name="bdCond<%= i %>" value="<%= bdcd.getOperation() %>" />
        <input type="hidden" name="bdVal<%= i %>" value="<%= bdcd.getValue() %>" />
        <%
                i++;
            }
        %>
        <div id="search">
            <div id="header" style="height: 18px;">
                <table width="100%" cellpadding="0" cellspacing="0" border="0" role="presentation">
                    <tbody>
                        <tr valign="middle">
                            <td nowrap="nowrap">
                                <label for="securityGroupId"><bean:message key="reports.adhoc.ReportGroup" bundle="ProcessPortal"/></label>
                                &nbsp;
                                <html:select styleId="securityGroupId" property="securityGroup" style="width: 150px;">
                                    <logic:iterate id="group" collection="<%= groups %>" type="java.lang.String">
                                        <html:option value="<%= group %>"><%= group %></html:option>
                                    </logic:iterate>
                                </html:select>
                            </td>
                            <td align="right">
                                <table width="0" cellpadding="0" cellspacing="0" border="0" role="presentation">
                                    <tbody>
                                        <tr>
                                            <td>
                                                <html:submit value='<%= MessagesHelper.getMessage(application, request, "reports.adhoc.SaveReport", "ProcessPortal") %>' />
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <logic:messagesPresent>
            <div style="color:red">
                <br />
                <html:messages id="error">
                    <bean:write name="error" /><br />
                </html:messages>
            </div>
        </logic:messagesPresent>
        <table cellpadding="0" cellspacing="0" border="0" role="presentation">
            <tr>
                <td valign="top">
                    <table class="content-table-around-line" role="group" aria-describedby="SavedReportDetails ReportName">
                        <thead>
                           <tr>
                                <td id="SavedReportDetails" colspan="2" nowrap="nowrap">
                                    <bean:message key="reports.adhoc.SavedReportDetails" bundle="ProcessPortal"/>
                                </td>
                            </tr>
                        </thead>
                        <tbody>
                            <tr height="30">
                                <td id="ReportName" nowrap="nowrap" width="5%"><bean:message key="reports.adhoc.ReportName" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></td>
                                <td>
                                    <html:text property="reportName" style="width: 150px;" maxlength="54" onkeypress="moveFocusToBody(event)"/>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </td>
            </tr>
        </table>
    </html:form>
</div>
