<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.core.DateFormatHelper,
  com.lombardisoftware.bpd.BPDConstants"%>
<%@ page import="com.lombardisoftware.portal.utils.*,
  com.lombardisoftware.psapi.data.User,
  com.lombardisoftware.psapi.data.Task,
  com.lombardisoftware.psapi.data.Group,
  com.lombardisoftware.data.*,
  com.lombardisoftware.core.*,
  com.lombardisoftware.portal.viewhelper.DocumentsHelper,
  com.lombardisoftware.client.delegate.AuthorizationAPIDelegateFactory,
  com.lombardisoftware.portal.utils.TaskInstanceUtils,
  com.lombardisoftware.portal.utils.AccessibilityUtils,
  com.lombardisoftware.portal.struts.i18n.TWMessageResources,
  com.ibm.icu.text.DateFormat,
  com.lombardisoftware.client.DateFormatUtils,  
  org.apache.struts.Globals,
  java.math.BigDecimal,
  java.util.Locale "%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils" %>
<%@ include file="../contextRoot.jsp" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<jsp:useBean id="specialTasks" class="java.util.ArrayList" scope="request" />
<jsp:useBean id="docs" class="java.util.ArrayList" scope="request"/>
<jsp:useBean id="userMap" class="java.util.HashMap" scope="request" />
<jsp:useBean id="groupMap" class="java.util.HashMap" scope="request" />
<jsp:useBean id="bpdInstance" class="com.lombardisoftware.psapi.data.BPDInstance" scope="request" />
<jsp:useBean id="bpd" class="com.lombardisoftware.psapi.data.BPD" scope="request" />
<jsp:useBean id="task" class="com.lombardisoftware.psapi.data.Task" scope="request" />
<jsp:useBean id="user" class="com.lombardisoftware.psapi.data.User" scope="session"/>
<jsp:useBean id="taskSorter" class="com.lombardisoftware.psapi.data.ColumnSorter" scope="session"/>
<jsp:useBean id="commentSorter" class="com.lombardisoftware.psapi.data.ColumnSorter" scope="session"/>
<div class="body">
<%
  String drillDownURL="getProcessDetails.do?bpdInstanceId=" + bpdInstance.getBpdInstanceID()+ "&taskId="+task.getTaskID();
  String processDetailsRef = request.getContextPath() + "/jsp/getProcessDetails.do?bpdInstanceId=" + bpdInstance.getBpdInstanceID();
  UserPreference userPreference = (UserPreference)session.getAttribute(UserPreference.SESSION_KEY);
  DateFormat dateTimeFormat = BidiUtils.getDateTimeFormat(userPreference);
  if(bpdInstance.getBpdID() >= 0 && bpd.getName() != null){ %>
<table class="content-table">
<thead>
 <tr><th colspan="4"><bean:message key="taskDetails.InstanceDetails" bundle="ProcessPortal"/></th></tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.InstanceDetails.ProcessDefinition" bundle="ProcessPortal"/></td>
  <td class="cell-content bidiText"><a href="<%= processDetailsRef %>"><%=bpd.getName()%></a></td>
  <td width="120"><bean:message key="taskDetails.InstanceDetails.Status" bundle="ProcessPortal"/></td>
  <td class="cell-content"><bean:message key="<%=MessagesHelper.INSTANCE_STATUS_DISPLAY_NAME_PREFIX + bpdInstance.getStatusName()%>" bundle="ProcessPortal"/></td>
 </tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.InstanceDetails.InstanceName" bundle="ProcessPortal"/></td>
  <td class="cell-content bidiText"><a href="<%= processDetailsRef %>">
    <% if(bpdInstance.getName()!=null){%>
    <%=bpdInstance.getName()%>
   <%}%>
  </a></td>
  <td width="120"><bean:message key="taskDetails.InstanceDetails.DueDate" bundle="ProcessPortal"/></td>
  <td class="cell-content"><a href="<%= processDetailsRef %>">
   <%=bpdInstance.getDueDate()==null?"":dateTimeFormat.format(bpdInstance.getDueDate())%>
  </a></td>
 </tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.InstanceDetails.InstanceID" bundle="ProcessPortal"/></td>
  <td class="cell-content"><a href="<%= processDetailsRef %>"><%=bpdInstance.getBpdInstanceID()%></a></td>
  <td>&nbsp;</td>
  <td class="cell-content">&nbsp;</td>
 </tr>
</thead>
</table>
<%}%>

<!-- Task Details Section -->
<table class="content-table">
<thead>
 <tr><th colspan="4"><bean:message key="taskDetails.TaskDetails" bundle="ProcessPortal"/></th></tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.TaskDetails.Participant" bundle="ProcessPortal"/></td>
  <td class="cell-content"><%= task.getParticipantName() %></td>
  <td width="120"><bean:message key="taskDetails.TaskDetails.ReceivedDate" bundle="ProcessPortal"/></td>
  <td class="cell-content">
   <%=task.getRcvdDateTime()==null?"":dateTimeFormat.format(task.getRcvdDateTime())%>
  </td>
 </tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.TaskDetails.Status" bundle="ProcessPortal"/></td>
  <td class="cell-content"><bean:message key="<%=MessagesHelper.TASK_STATUS_DISPLAY_NAME_PREFIX + task.getStatusCodeName()%>" bundle="ProcessPortal"/></td>
  <td width="120"><bean:message key="taskDetails.TaskDetails.DateRead" bundle="ProcessPortal"/></td>
  <td class="cell-content">
   <%=task.getReadDateTime()==null?"":dateTimeFormat.format(task.getReadDateTime())%>
  </td>
 </tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.TaskDetails.DueDate" bundle="ProcessPortal"/></td>
  <td class="cell-content">
   <%=task.getDueDate()==null?"":dateTimeFormat.format(task.getDueDate())%>
  </td>
  <td width="120"><bean:message key="taskDetails.TaskDetails.ClosedBy" bundle="ProcessPortal"/></td>
  <td class="cell-content"><%=task.getClosedByName()%></td>
 </tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.TaskDetails.Priority" bundle="ProcessPortal"/></td>
  <td class="cell-content"><bean:message key="<%=MessagesHelper.PRIORITY_DISPLAY_NAME_PREFIX+task.getPriorityName()%>" bundle="ProcessPortal"/></td>
  <td width="120"><bean:message key="taskDetails.TaskDetails.ClosedDate" bundle="ProcessPortal"/></td>
  <td class="cell-content">
   <%=task.getCloseDateTime()==null?"":dateTimeFormat.format(task.getCloseDateTime())%>
  </td>
 </tr>
 <tr>
  <td width="120"><bean:message key="taskDetails.TaskDetails.ActivityName" bundle="ProcessPortal"/></td>
  <td class="cell-content"><%=task.getActivityName()%></td>
  <td width="120"><bean:message key="taskDetails.TaskDetails.RunTask" bundle="ProcessPortal"/></td>
  <td class="cell-content" class="button">
<%
 if (TaskInstanceUtils.isTaskRunnable(bpdInstance, task, user)) {
  if(task.isInfoPathForm()) {%>
  <img src="images/run_disabled.gif" alt='<bean:message key="processDetails.TasksTable.tip.RunTaskInfoPath" bundle="ProcessPortal"/>'/>
  <% } else { %>
   <a title="Run task" href="#" onClick="performPopupActionSingleWindowAndDisable(this, 'teamworksruntask<%=task.getTaskID()%>', '<%= teamworksContextRoot %>/process.lsw?zWorkflowState=1', 'zTaskId=<%=task.getTaskID() %>', 'height=600,width=720,scrollbars=yes,resizable=yes');"><img src="images/run.gif" align="left" alt="<bean:message key="scoreboard.MyTaskList.run" bundle="ProcessPortal"/>" /></a>
  <% } %></td>
<%
 } else if(TaskInstanceUtils.isTaskRunnableByStatus(task)) {
 if(AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecuteAction(com.lombardisoftware.server.api.ActionPolicy.ACTION_ASSIGN_TASK, new BigDecimal(task.getTaskID()))) {
  if(task.isInfoPathForm()) {%>
   <img src="images/run_disabled.gif" alt='<bean:message key="processDetails.TasksTable.tip.RunTaskInfoPath" bundle="ProcessPortal"/>'/>
   <% } else if(!task.hasStartProcess()) { %>
   &nbsp;&nbsp;&nbsp;
   <% } else if(userPreference.isAlertOnAssignAndRun()){%>
   <a href="#" title='<bean:message key="processDetails.TasksTable.tip.AssignAndRunTask" bundle="ProcessPortal"/>' onClick="performPopupActionWithWarningSingleWindow('teamworksruntask<%=task.getTaskID()%>', 'processDetails/assignTask.do?needToRun=true', 'id=<%=task.getTaskID()%>', 'height=600,width=720,scrollbars=yes,resizable=yes','<bean:message key="assignAndRunConfirmation.MessageBody" bundle="ProcessPortal" encodeTo="inlinejs"/>')">
   <img src="images/run.gif" alt="<bean:message key="scoreboard.MyTaskList.run" bundle="ProcessPortal"/>" /></a>
   <% }else { %>
   <a href="#" title='<bean:message key="processDetails.TasksTable.tip.AssignAndRunTask" bundle="ProcessPortal"/>' onClick="performPopupActionSingleWindowAndDisable(this, 'teamworksruntask<%=task.getTaskID()%>', 'processDetails/assignTask.do?needToRun=true', 'id=<%=task.getTaskID()%>', 'height=600,width=720,scrollbars=yes,resizable=yes')">
   <img src="images/run.gif" alt="<bean:message key="scoreboard.MyTaskList.run" bundle="ProcessPortal"/>" /></a>
   <% }
 } else {
   %>&nbsp;&nbsp;&nbsp;<%
 }
  } else {
   %>&nbsp;&nbsp;&nbsp;<%
  }
%>
</td></tr>
<tr>
 <td width="120"><bean:message key="taskDetails.TaskDetails.Subject" bundle="ProcessPortal"/></td>
 <td colspan="3" class="cell-content"><%=task.getSubject()%></td>
</tr>
</thead>
</table>

<!-- Task Narrative -->
<table class="content-table">
 <thead>
  <tr><th colspan="4"><bean:message key="taskDetails.TaskNarrative" bundle="ProcessPortal"/></th></tr>
  <tr><td colspan="4" style="background:white; white-space: normal;"><%=(task.getNarrativeWithFreshUpdate() != null)?task.getNarrativeWithFreshUpdate():""%></td></tr>
 </thead>
</table>

<%-- Since Tsunami --%>
<% if(task.getSharepointDiscussionURL() != null) { %>
<table class="content-table">
 <thead>
  <tr>
    <th colspan="2"><p style="float:left">SharePoint Collaboration</p></th>
  </tr>
  <tr>
   <td width="120">Discussion Thread:</td>
   <td style="background:white"><a target="_blank" href="<%=task.getSharepointDiscussionURL()%>"><%=task.getSharepointDiscussionURL()%></a></td>
  </tr>  
 </thead>
</table>
<% } %>

<% if(bpdInstance != null && bpdInstance.getBpdInstanceID() != -1) { %>
<table class="content-table">
 <thead>
  <tr>
    <th colspan="5"><p style="float:left"><bean:message key="processDetails.CollaborationTable.Heading" bundle="ProcessPortal"/></p>
     <input type="button" value="<bean:message key="processDetails.CollaborationTable.AddCommentButton" bundle="ProcessPortal"/>" style="float:right" style="height:20px" onClick="javascript:performPopupAction('addCommentSetup.do', 'bpdInstanceId=<%= bpdInstance.getBpdInstanceID() %>', 'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto');">
    </th>
  </tr>
  <tr>
   <!-- type icon -->
   <% if (commentSorter.isFirstSorter("Task StatusID")) {%>
   <td style="padding: 0px 5px 0 5px" class="sort1">
        <a href="<%= drillDownURL %>&commentCol=Task StatusID"><bean:message key="processDetails.CollaborationTable.Type" bundle="ProcessPortal"/></a> <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getFirstSortOrder() %>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>" ></td>
    <%} else if (commentSorter.isSecondSorter("Task StatusID")) {%>
   <td style="padding: 0px 5px 0 5px" class="sort2">
        <a href="<%= drillDownURL %>&commentCol=Task StatusID"><bean:message key="processDetails.CollaborationTable.Type" bundle="ProcessPortal"/></a> <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getSecondSortOrder() %>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>" ></td>
   <%} else {%>
   <td style="padding: 0px 5px 0 5px"><a href="<%= drillDownURL %>&commentCol=Task StatusID"><bean:message key="processDetails.CollaborationTable.Type" bundle="ProcessPortal"/></a></td>
    <%}%>

   <!--Date -->
    <% if (commentSorter.isFirstSorter("Task Received Date")){%>
   <td class="sort1">
        <a href="<%=drillDownURL%>&commentCol=Task Received Date"><bean:message key="processDetails.CollaborationTable.Date" bundle="ProcessPortal"/></a> <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>"  ></td>
    <%}else if (commentSorter.isSecondSorter("Task Received Date")){%>
   <td class="sort2"><a href="<%=drillDownURL%>&commentCol=Task Received Date"><bean:message key="processDetails.CollaborationTable.Date" bundle="ProcessPortal"/></a><img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= commentSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>"  ></td>
    <%}else{%>
   <td><a href="<%=drillDownURL%>&commentCol=Task Received Date"><bean:message key="processDetails.CollaborationTable.Date" bundle="ProcessPortal"/></a></td>
    <%}%>

   <!--From -->
    <% if (commentSorter.isFirstSorter("User Name")){%>
   <td class="sort1"><a href="<%=drillDownURL%>&commentCol=User Name"><bean:message key="processDetails.CollaborationTable.From" bundle="ProcessPortal"/></a>
       <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>"  >
   </td>
    <%}else if (commentSorter.isSecondSorter("User Name")){%>
   <td class="sort2"><a href="<%=drillDownURL%>&commentCol=User Name"><bean:message key="processDetails.CollaborationTable.From" bundle="ProcessPortal"/></a>
       <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>"  >
   </td>
    <%}else{%>
   <td><a href="<%=drillDownURL%>&commentCol=User Name"><bean:message key="processDetails.CollaborationTable.From" bundle="ProcessPortal"/></a></td>
   <%}%>

   <!--To -->
   <% if (commentSorter.isFirstSorter("To")){%>
   <td class="sort1"><a href="<%=drillDownURL%>&commentCol=To"><bean:message key="processDetails.CollaborationTable.To" bundle="ProcessPortal"/></a>
       <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getFirstSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getFirstSortOrder())%>" bundle="ProcessPortal"/>"  >
   </td>
   <%}else if (commentSorter.isSecondSorter("To")){%>
   <td class="sort2"><a href="<%=drillDownURL%>&commentCol=To"><bean:message key="processDetails.CollaborationTable.To" bundle="ProcessPortal"/></a>
       <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%=commentSorter.getSecondSortOrder()%>.gif' alt="<bean:message key="<%=AccessibilityUtils.getMessageKeyForSortOrder(commentSorter.getSecondSortOrder())%>" bundle="ProcessPortal"/>"  >
   </td>
   <%}else{%>
   <td><a href="<%=drillDownURL%>&commentCol=To"><bean:message key="processDetails.CollaborationTable.To" bundle="ProcessPortal"/></a></td>
   <%}%>

   <!--Subject --><!-- cant sort for a this type of column in SQL -->
   <td><bean:message key="processDetails.CollaborationTable.Comment" bundle="ProcessPortal"/></td>

   <!-- <td><a href="javascript:SetCookie('sTaskCol','NAME');refreshPage()">Type</a></td> -->
     </tr>
   </thead>
   <tbody>
  <%for (int i=0;i<specialTasks.size();i++) {
   Task inst=(Task)specialTasks.get(i);
   String typeIcon = (String) CommentHelper.getIconName(inst.getStatus());
   String type = inst.getStatusCodeName();
   User fromUser = (User) userMap.get(Long.valueOf(inst.getRcvdFrom()));

   String to= "Everyone";

   if (inst.isHelpRequest() || inst.isAlert()) {
     long toId = inst.getUserID();
     if (toId != -1) {
       User toUser = (User) userMap.get(Long.valueOf(inst.getUserID()));
       to = ((toUser == null) ? "" : toUser.getFullName());
     } else {
       Group toGroup = (Group) groupMap.get(Long.valueOf(inst.getGroupID()));
       to = ((toGroup == null) ? "" : toGroup.getGroupName());
     }
   }
   
   TWMessageResources messageRes = (TWMessageResources) application.getAttribute("ProcessPortal");
   Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
   
   // Resolve localized task type's text and make sure it complies to the property format we support
   String localizedTypeText = messageRes.getMessage(locale, ("processDetails.CollaborationTable.TaskType." + type).replaceAll("_", ""));
   if (localizedTypeText.startsWith(TWMessageResources.MESSAGE_NOT_FOUND_START)) {
       localizedTypeText = type;
   }

   String comm = inst.getNarrativeWithFreshUpdate();
   
   if (comm != null && comm.endsWith("viewPopup.IgnoredHelpRequestMessage")) {
       String message = messageRes.getMessage(locale, "viewPopup.IgnoredHelpRequestMessage");
       comm = comm.replaceAll("viewPopup.IgnoredHelpRequestMessage", " " + message);
   }
   if (comm != null && comm.length() > 30) {
       comm = comm.substring(0,30);
       comm += "...";
   }
     %>
     <tr>
      <% String commentHref = "javascript:performPopupAction('viewComment.do', " +
      "'bpdInstanceId=" + bpdInstance.getBpdInstanceID() + "&taskId=" + inst.getTaskID() + "', " +
      "'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto');"; %>
   <td width="1%" align="center"><a href="<%= commentHref %>"><img src="<%= typeIcon %>" alt="<%= localizedTypeText %>" title="<%= localizedTypeText %>"/></a></td>
   <td width="14%"><a href="<%= commentHref %>"><%=inst.getRcvdDateTime()==null?"":dateTimeFormat.format(inst.getRcvdDateTime())%></a></td>
   <td width="14%"><a href="<%= commentHref %>"><%=fromUser.getFullName()%></a></td>
   <td width="14%">
     <a href="<%= commentHref %>">
       <%if(to.equals("Everyone")){%>
     <bean:message key="addComment.Everyone" bundle="ProcessPortal"/>
       <% } else { out.write(to);}%>
     </a>
   </td>
   <td width="14%" class="bidiText"><a href="<%= commentHref %>"><%=comm%></a></td>
       </tr>
 <%}%>
   </tbody>
   </table>
<% } %>
<% if(bpdInstance != null && bpdInstance.getBpdInstanceID() != -1) { %>
    <table class="content-table">
        <thead>
    <tr>
     <th colspan="4">
        <p style="float:left"><bean:message key="processDetails.DocumentsTable.Heading" bundle="ProcessPortal"/></p>
        <input type="button" value="<bean:message key="processDetails.DocumentsTable.AddDocumentButton" bundle="ProcessPortal"/>" style="float:right;" style="height:20px;"
       onClick="javascript:performPopupAction('addDocumentSetup.do', 'bpdInstanceId=<%= bpdInstance.getBpdInstanceID() %>', 'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto');">
     </th>
    </tr>
    <tr><%-- These should be sortable  --%>
     <td><bean:message key="processDetails.DocumentsTable.Name" bundle="ProcessPortal"/></td>
     <td><bean:message key="processDetails.DocumentsTable.Revision" bundle="ProcessPortal"/></td>
     <td><bean:message key="processDetails.DocumentsTable.RevisionDate" bundle="ProcessPortal"/></td>
     <td><bean:message key="processDetails.DocumentsTable.LastModifiedBy" bundle="ProcessPortal"/></td>
    </tr>
      </thead>
      <tbody>
    <%
      for (int i=0;i<docs.size();i++) {
          DocumentShell inst = (DocumentShell) docs.get(i);
    %>
    <tr>
      <td width="14%"><a href="viewDocumentVersion.do?bpdInstanceId=<%=bpdInstance.getBpdInstanceID()%>&parentId=<%=inst.getParentID()%>"><%=inst.getDocName()%></a></td>
      <td width="14%"><%= DocumentsHelper.createLink(inst, String.valueOf(inst.getVersion()))%></td>
      <td width="14%">
       <%=inst.getAuthoredDTG()==null?"":dateTimeFormat.format(inst.getAuthoredDTG())%>
      </td>
      <td width="14%">
      <%=inst.getAuthor().getFullname()%>
      </td>
    </tr>
    <%}%>
        </tbody>
    </table>
<% } %>
</div>
<script>
  //emulate a updatebuttons to get the toolbar buttons set
  updateTaskChecked(<%=task.getTaskID()%>,true);
  updateInstanceChecked(<%=bpdInstance.getBpdInstanceID()%>,true);
  onSelectionChange();
</script>
