<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.utils.MessagesHelper" %>
<%@ page import="com.lombardisoftware.client.persistence.common.ID" %>
<%@ page import="java.util.Locale" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ page import="java.util.Map"%>
<%@ page isELIgnored="false" %>
<%@ include file="../contextRoot.jsp" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>


<jsp:useBean id="businessDataConstraints" type="java.util.List" scope="request" />
<jsp:useBean id="dateBusinessDataItems" type="java.util.List" scope="request" />

<script type="text/javascript" src="<%=request.getContextPath()%>/js/utils.js"></script>
<link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css">

<%
    // Norwegian in "no" in Java but "nb" in Dojo.
    String language = ((Locale) session.getAttribute(Globals.LOCALE_KEY)).toString();
    if (language.equals("no")) {
        language = "nb";
    }else{
        language = language.toLowerCase().replace('_', '-');
    }

    Map<String, String> attrData = UserAttributesHelper.getUserAttributes();
    String dojoDatePackage = BidiUtils.getDojoDatePackage(attrData);
    if (dojoDatePackage.equals("dojo.date")) {
        dojoDatePackage = "";
    }
%>
<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js"
        djConfig="parseOnLoad:true, locale:'<%= language %>'"></script>

<jsp:include page="bidi/BidiDateUtility.jsp" flush="true" />

<script type="text/javascript">
    dojo.require("dijit.form.DateTextBox");
    dojo.require("dojo.date.locale");
    dojo.registerModulePath("com.lombardisw","<%= processPortalSupportContextRoot %>/js");
    dojo.require("com.lombardisw.InfoDialog");

    dateBusinessDataItems = [<%
        for(Object varName : dateBusinessDataItems) {
             %>"<%=varName.toString()%>",<%
        }
    %>];

    dojo.addOnLoad(function(){

        // Setup calendar drop-down style.
        dojo.addClass(dojo.body(), "soria");

        // Copy values from JSP fields to dojo widgets.
        if (!dojo.byId("startDateField").value) {// set to current date - defect 101080
            var currentDate = dateToString(new Date);
            dojo.byId("startDateField").value = currentDate;
            dojo.byId("endDateField").value = currentDate;
        }
        startDateWidget.setValue(parseDate(dojo.byId("startDateField").value));
        endDateWidget.setValue(parseDate(dojo.byId("endDateField").value));

        // Copy dates from widgets to JSP fields.
        startDateWidget.onChange = function(){
            dojo.byId("startDateField").value = getGregorianDateStrFromObj(startDateWidget.getValue());
        };

        endDateWidget.onChange = function(){
            dojo.byId("endDateField").value = getGregorianDateStrFromObj(endDateWidget.getValue());
        };
        
        initWizardContent();
    });

    function /*date*/ getGregorianDateStrFromObj(dateObj) {
        var gregObj = dateObj;
        if (dateObj && getCalendarType() != "gregorian") {
            gregObj = dateObj.toGregorian();
        }
        if (!gregObj) {
            gregObj = new Date();
        }
        gregStr = dateToString(gregObj);
        return gregStr;
    }

    function /*String*/ getDateFormat() {
        var dateFormat = "yyyy-MM-dd";
        return dateFormat;
    }

    function /*Date*/ parseDate(/*String*/ stringDate) {
        return dojo.date.locale.parse(stringDate, {datePattern: "yyyy-MM-dd", selector: "date"});
    }

    function /*String*/ dateToString(/*Date*/ date) {
        return dojo.date.locale.format(date, {datePattern: "yyyy-MM-dd", selector: "date"});
    }
</script>

<script type="text/javascript">
    function initWizardContent() {
        // Define visibility for wizard content
        var bpdList = getHtmlElement("bpdList");
        
        if (bpdList.value == -1) {
            setDisplayVisible("wizardContent", false);
        } else {
            setDisplayVisible("wizardContent", true);
        }
        
        // Define visibility for X-Axis section's controls
        var xAxisBindingNodeTypeList = getHtmlElement("xAxisBindingNodeTypeList");
        
        if (xAxisBindingNodeTypeList.value == -1) {
            setDisplayVisible("xAxisBindingVarList", false);
        } else {
            setDisplayVisible("xAxisBindingVarList", true);
        }
        
        // Define visibility for Y-Axis section's controls
        var yAxisBindingNodeTypeList = getHtmlElement("yAxisBindingNodeTypeList");
        
        if (yAxisBindingNodeTypeList.value == -1) {
            setDisplayVisible("yAxisBindingVarList", false);
        } else {
            setDisplayVisible("yAxisBindingVarList", true);
        }
        
        // Define visibility for business data filter section
        var businessDataTypeList = getHtmlElement("businessDataTypeList");
        
        if (businessDataTypeList.value == -1) {
            setDisplayVisible("businessDataItemsList", false);
        } else {
            setDisplayVisible("businessDataItemsList", true);
        }
        
        enableXAxisCombos();
        enableFunctionAndConvertCombo();
        enableCustomDatesFields();
        updateChartFromCombo();
		var D = document;
		var firstHeight= Math.max(
			Math.max(D.body.scrollHeight, D.documentElement.scrollHeight),
			Math.max(D.body.offsetHeight, D.documentElement.offsetHeight),
			Math.max(D.body.clientHeight, D.documentElement.clientHeight)
		);
		var height = (parseInt(firstHeight) + 1);
		var msgBody={"resizeDashboardIframe":height};
		if (window.parent) {
			try  {
		window.parent.postMessage(dojo.toJson(msgBody), "*");
			} catch(e) {
				var messObj={origin: window.location.protocol + "//" + window.location.host,
										data: dojo.toJson(msgBody), 
										source: window};
				window.parent.onMessage(messObj);
				
    }
		}
    }
    
    function enableXAxisCombos() {
        var xAxisBindingVarList = getHtmlElement("xAxisBindingVarList");
        var sortOrderList = getHtmlElement("sortOrderList");
        
        if (xAxisBindingVarList.value == -1) {
            sortOrderList.disabled = true;
        } else {
            sortOrderList.disabled = false;
        }
    }
    
    function enableFunctionAndConvertCombo() {
        var yAxisBindingNodeTypeList = getHtmlElement("yAxisBindingNodeTypeList");
        var yAxisBindingVarList = getHtmlElement("yAxisBindingVarList");
        
        // Auto-tracked and tracking group
        if(yAxisBindingNodeTypeList.value == 0 || yAxisBindingNodeTypeList.value == 1) {
            var callback = {
                success: function(o) {
                    if(o == "number") {
                        setDisplayVisible("functionSectionId", true);
                        setDisplayVisible("conversionSectionId", false);
                    } else {
                        setDisplayVisible("functionSectionId", false);
                        setDisplayVisible("conversionSectionId", false);
                    }
                },
                failure: function(o) {
                    setDisplayVisible("functionSectionId", false);
                    setDisplayVisible("conversionSectionId", false);
                }
            }
            
	    var varScope = (yAxisBindingNodeTypeList.value == 0) ? "autoTracked" : "trackingGroup";
            getVariableType(varScope, yAxisBindingVarList.value, callback);
        }
        // Step Duration or Timing interval
        else if (yAxisBindingNodeTypeList.value == 2 || yAxisBindingNodeTypeList.value == 3) {
            if (yAxisBindingVarList.value == -1) {
                setDisplayVisible("functionSectionId", false);
                setDisplayVisible("conversionSectionId", false);
            } else {
                setDisplayVisible("functionSectionId", true);
                setDisplayVisible("conversionSectionId", true);
            }
        }
    }
    
    function enableCustomDatesFields() {
        var timeRangeList = getHtmlElement("timeRangeList");
        // Custom period
        if (timeRangeList.value == 9) {
            setDisplayVisible("startDateFieldSection", true);
            setDisplayVisible("endDateFieldSection", true);
        } else {
            setDisplayVisible("startDateFieldSection", false);
            setDisplayVisible("endDateFieldSection", false);
            //Empty fields, when change combobox value
            var startDateField = getHtmlElement("startDateField");
            var endDateField = getHtmlElement("endDateField"); 
            startDateField.value = "";
            endDateField.value = "";            
        }
    }
    
    function getVariableType(varScope, varName, callback) {
        var bpdId = getHtmlElement("bpdList").value;
        if(bpdId == -1) {
            return;
        }
        
        var url = "<%=request.getContextPath()%>/jsp/getVariableType.do?bpdId=" + bpdId + "&scope=" + varScope + "&name=" + varName;
        dojo.xhrGet({
            url: url,
            handleAs: "text",
            load: callback.success,
            error: callback.failure 
        });
    }
    
    function updateChart(isXls) {
        var bpdList                  = getHtmlElement("bpdList");                  // bpdId
        var xAxisBindingNodeTypeList = getHtmlElement("xAxisBindingNodeTypeList"); // xAxisBindingType
        var xAxisBindingVarList      = getHtmlElement("xAxisBindingVarList");      // xAxisBindingItem
        var sortOrderList            = getHtmlElement("sortOrderList");            // xAxisSortOrder
        var yAxisBindingNodeTypeList = getHtmlElement("yAxisBindingNodeTypeList"); // yAxisBindingType
        var yAxisBindingVarList      = getHtmlElement("yAxisBindingVarList");      // yAxisBindingItem
        var yAxisFunctionList        = getHtmlElement("yAxisFunctionList");        // yAxisFunction
        var yAxisConversionList      = getHtmlElement("yAxisConversionList");      // yAxisConversion
        var timeRangeList            = getHtmlElement("timeRangeList");            // timePeriod
        var startDateField           = getHtmlElement("startDateField");           // startDateField
        var endDateField             = getHtmlElement("endDateField");             // endDateField
        var chartTypeList            = getHtmlElement("chartTypeList");            // chartType
        
        // Custom Period
        if (timeRangeList.value == 9 && !customTimePeriodCheck()) {
            com.lombardisw.InfoDialog.showInfo(
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "reports.adhoc.CustomPeriodIncorrect", "ProcessPortal")) %>",
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "generateprocess.button.ok", "ProcessPortal")) %>");
        } else if (sanityCheck()) {
            var query = "?bpdId=" + bpdList.value;
            query += "&xAxisBindingType=" + xAxisBindingNodeTypeList.value;
            query += "&xAxisBindingItem=" + xAxisBindingVarList.value;
            query += "&xAxisSortOrder=" + sortOrderList.value;
            query += "&yAxisBindingType=" + yAxisBindingNodeTypeList.value;
            query += "&yAxisBindingItem=" + yAxisBindingVarList.value;
            query += "&yAxisFunction=" + yAxisFunctionList.value;
            query += "&yAxisConversion=" + yAxisConversionList.value;
            query += "&timePeriod=" + timeRangeList.value;
            query += "&startDate=" + getGregorianDateStrFromObj(startDateWidget.value);
            query += "&endDate=" + getGregorianDateStrFromObj(endDateWidget.value);
            query += "&chartType=" + chartTypeList.value;

            var items = document.getElementById("businessDataFilterId").rows;
            for(var index = 0; index < items.length; ++index) {
                var row = items[index];
                var id = row.getAttribute("id").substring(6);
                var bdType = "bdType" + id;
                var bdVar = "bdVar" + id;
                var bdVal = "bdVal" + id;
                var bdCond = "bdCond" + id;
                
                var bdTypeEl = getHtmlElement(bdType);
                var bdVarEl = getHtmlElement(bdVar);
                var bdValEl = getHtmlElement(bdVal);
                var bdCondEl = getHtmlElement(bdCond);
                
                if(!(bdTypeEl && bdVarEl && bdValEl && bdCondEl)) {
                    break;
                }
                
                query += "&" + bdType + "=" + bdTypeEl.value;
                query += "&" + bdVar + "=" + bdVarEl.value;
                query += "&" + bdVal + "=" + bdValEl.value;
                query += "&" + bdCond + "=" + bdCondEl.value;
            }
            
            if (isXls == true) {
                query += "&generationType=xls";
                var wizardForm = getHtmlElement("wizardForm");
                wizardForm.action = "<%=request.getContextPath()%>/jsp/adhocReportChart" + query;
                wizardForm.submit();
                
                // Restore original action
                wizardForm.action = "<%=request.getContextPath()%>/jsp/viewAdHocReportWizard.do";
            } else if(isXls == false) {
			    query += "&generationType=csv";
                var wizardForm = getHtmlElement("wizardForm");
                wizardForm.action = "<%=request.getContextPath()%>/jsp/adhocReportChart" + query;
                wizardForm.submit();
                
                // Restore original action
                wizardForm.action = "<%=request.getContextPath()%>/jsp/viewAdHocReportWizard.do";
			}
			else {
                query += "&generationType=chart";
                forceImageReload(getHtmlElement("chartImgId"), "adhocReportChart" + query);
                imageAltReload(getHtmlElement("chartImgId"));
            }
        } else {
            com.lombardisw.InfoDialog.showInfo(
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "reports.adhoc.SelectAxisBinding", "ProcessPortal")) %>",
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "generateprocess.button.ok", "ProcessPortal")) %>");
        }
    }
    function imageAltReload(image){
    	var xAxisBindingItem= getHtmlElement("xAxisBindingVarList").value; 
		var yAxisBindingItem= getHtmlElement("yAxisBindingVarList").value; 
		var altValue;
        if (xAxisBindingItem == -1 || yAxisBindingItem == -1) {
            altValue= "<%= MessagesHelper.getMessage(application, request, "adHocReport.chartAlt", "ProcessPortal") %>"; 
        }else{
        	altValue= xAxisBindingItem+" / "+yAxisBindingItem;
        }
        if(image!=null)
        	image.alt=altValue;
        return altValue;
    }
    
    function customTimePeriodCheck() {
        var startDateField = getHtmlElement("startDateField");
        var endDateField = getHtmlElement("endDateField");
        
        if (startDateField.value == "" || endDateField.value == "") {
            return false;
        } 
        if (parseDate(startDateField.value) > parseDate(endDateField.value)) {
                return false;
        }
                return true;
            } 
    
    function sanityCheck() {
        var xAxisBindingNodeTypeList = getHtmlElement("xAxisBindingNodeTypeList");
        var xAxisBindingVarList      = getHtmlElement("xAxisBindingVarList");
        var yAxisBindingNodeTypeList = getHtmlElement("yAxisBindingNodeTypeList");
        var yAxisBindingVarList      = getHtmlElement("yAxisBindingVarList");
        
        if (xAxisBindingNodeTypeList.value != -1 && xAxisBindingVarList.value != -1
                && yAxisBindingNodeTypeList.value != -1 && yAxisBindingVarList.value != -1) {
            return true;
        } else {
            return false;
        }
    }
    
    function updateChartFromCombo() {
        if (sanityCheck()) {
            updateChart();
        } else {
            var chartImgId = getHtmlElement("chartImgId");
            var chartTypeList = getHtmlElement("chartTypeList");
            forceImageReload(chartImgId, "adhocReportChart?bpdId=-1&chartType=" + chartTypeList.value);
            imageAltReload(getHtmlElement("chartImgId"));
        }
    }

    function generateReport() {
		if (sanityCheck()) {
    		var timeRangeList = getHtmlElement("timeRangeList");
        	if (timeRangeList.value == 9 && !customTimePeriodCheck()) {
                com.lombardisw.InfoDialog.showInfo(
                    "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "reports.adhoc.CustomPeriodIncorrect", "ProcessPortal")) %>",
                    "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "generateprocess.button.ok", "ProcessPortal")) %>");
            } else {
	            var wizardForm = getHtmlElement("wizardForm");
	            wizardForm.action = "<%=request.getContextPath()%>/jsp/saveAdHocReport.do";
	            wizardForm.submit();
	            
	            // Restore original action
	            wizardForm.action = "<%=request.getContextPath()%>/jsp/viewAdHocReportWizard.do";
            }
        } else {
            com.lombardisw.InfoDialog.showInfo(
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "reports.adhoc.SelectAxisBinding", "ProcessPortal")) %>",
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "generateprocess.button.ok", "ProcessPortal")) %>");
        }
    }
    
    var bdIdx = <%= businessDataConstraints.size() %>;
    var removeImgSrc = "<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/remove.gif";
    
    function addBusinessConstraint() {
        var businessDataTypeList = getHtmlElement("businessDataTypeList");
        var businessDataItemsList = getHtmlElement("businessDataItemsList");
        
        if (businessDataTypeList.value == -1 || businessDataItemsList.value == -1) {
            com.lombardisw.InfoDialog.showInfo(
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "reports.adhoc.SpecifyNodeType", "ProcessPortal")) %>",
                "<%= BidiUtils.applyUCC(attrData, MessagesHelper.getMessage(application, request, "generateprocess.button.ok", "ProcessPortal")) %>");
        } else {
            var businessDataFilter = getHtmlElement("businessDataFilterId");
            
            var oTr = document.createElement("tr");
            oTr.setAttribute("id", "bdTrId" + bdIdx);
            oTr.setAttribute("height", "30");
            
            var oTd1 = document.createElement("td");
            oTd1.setAttribute("width", "10%");
            oTd1.setAttribute("align", "right");
            oTd1.innerHTML = "<input type='hidden' id='bdType" + bdIdx + "' name='bdType" + bdIdx + "' value='" + businessDataTypeList.value + "' />"
                           + "<input type='hidden' id='bdVar" + bdIdx + "' name='bdVar" + bdIdx + "' value='" + businessDataItemsList.value + "' />"
                           + businessDataItemsList.value;
            
            var oTd2 = document.createElement("td");
            oTd2.setAttribute("width", "10%");
            
            var oSelect = document.createElement("select");
            oSelect.setAttribute("id", "bdCond" + bdIdx);
            oSelect.setAttribute("name", "bdCond" + bdIdx);
            
            var oOption1 = document.createElement("option");
            oOption1.setAttribute("value", "=");
            oOption1.appendChild(document.createTextNode("="));
            
            var oOption2 = document.createElement("option");
            oOption2.setAttribute("value", "!=");
            oOption2.appendChild(document.createTextNode("<%= MessagesHelper.getMessage(application, request, "reports.adhoc.notEqual", "ProcessPortal") %>"));//needed because JAWS won't speak the ! in !=
            
            var oOption3 = document.createElement("option");
            oOption3.setAttribute("value", ">=");
            oOption3.appendChild(document.createTextNode(">="));
            
            var oOption4 = document.createElement("option");
            oOption4.setAttribute("value", ">");
            oOption4.appendChild(document.createTextNode(">"));
            
            var oOption5 = document.createElement("option");
            oOption5.setAttribute("value", "<=");
            oOption5.appendChild(document.createTextNode("<="));
            
            var oOption6 = document.createElement("option");
            oOption6.setAttribute("value", "<");
            oOption6.appendChild(document.createTextNode("<"));
            
            oSelect.appendChild(oOption1);
            oSelect.appendChild(oOption2);
            oSelect.appendChild(oOption3);
            oSelect.appendChild(oOption4);
            oSelect.appendChild(oOption5);
            oSelect.appendChild(oOption6);
            
            var oTd3 = document.createElement("td");
            oTd3.setAttribute("width", "10%");

            var oText = document.createElement("input");
            oText.setAttribute("type", "text");
            oText.setAttribute("id", "bdVal" + bdIdx);
            oText.setAttribute("name", "bdVal" + bdIdx);
            oText.style.width = "150px";


            var oTd4 = document.createElement("td");
            
            var oImg = document.createElement("img");
            oImg.setAttribute("src", removeImgSrc);
            oImg.setAttribute("tabindex","0");
            oImg.setAttribute("title", "<%= MessagesHelper.getMessage(application, request, "reports.adhoc.RemoveConstr", "ProcessPortal") %>");
            oImg.style.cursor = "pointer";
            
            var bdTrId = "bdTrId" + bdIdx;
            oImg.onclick = function() { removeBusinessConstraint(bdTrId) };
            oImg.onkeypress = function(e) {
                if (e.which == dojo.keys.ENTER || e.which == dojo.keys.SPACE ){                 
                    removeBusinessConstraint(bdTrId);
                }
            }
            
            oTd2.appendChild(oSelect);
            oTd3.appendChild(oText);
            oTd4.appendChild(oImg);
            oTr.appendChild(oTd1);
            oTr.appendChild(oTd2);
            oTr.appendChild(oTd3);
            oTr.appendChild(oTd4);
            businessDataFilter.appendChild(oTr);
            
            if(dateBusinessDataItems.indexOf(businessDataItemsList.value) != -1) {
               dateCombobox = new dijit.form.DateTextBox({value: new Date()});
               element = document.getElementById("bdVal" + bdIdx);
               element.parentNode.replaceChild(dateCombobox.domNode, element);
               dateCombobox.domNode.getElementsByTagName("input")[dateCombobox.domNode.getElementsByTagName("input").length - 1].id = "bdVal" + bdIdx;
               dateCombobox.domNode.getElementsByTagName("input")[dateCombobox.domNode.getElementsByTagName("input").length - 1].name = "bdVal" + bdIdx;
            }
            
            bdIdx++;
        }
    }
    
    function removeBusinessConstraint(bdTrId) {
        var bdTrIdElem = getHtmlElement(bdTrId);
        
        bdTrIdElem.parentNode.removeChild(bdTrIdElem);
        
        bdIdx--;
    }
</script>

<jsp:useBean id="bpdCollection"           type="java.util.List" scope="request" />
<jsp:useBean id="xAxisBindingNodeType"    type="java.util.List" scope="request" />
<jsp:useBean id="yAxisBindingNodeType"    type="java.util.List" scope="request" />
<jsp:useBean id="businessDataNodeType"    type="java.util.List" scope="request" />
<jsp:useBean id="businessDataItems"       type="java.util.List" scope="request" />
<jsp:useBean id="xAxisTrackedItems"       type="java.util.List" scope="request" />
<jsp:useBean id="sortingOrderTypes"       type="java.util.Map"  scope="request" />
<jsp:useBean id="yAxisTrackedItems"       type="java.util.List" scope="request" />
<jsp:useBean id="functionTypes"           type="java.util.Map"  scope="request" />
<jsp:useBean id="conversionTypes"         type="java.util.Map"  scope="request" />
<jsp:useBean id="rangeTypes"              type="java.util.List" scope="request" />
<jsp:useBean id="chartTypes"              type="java.util.Map"  scope="request" />

<jsp:useBean id="ViewAdHocReportWizardPage" class="org.apache.struts.validator.DynaValidatorActionForm" scope="request" />

<div class="body" id="body" tabindex="0" role="form" aria-label="<bean:message key="reports.adhoc.AdHocReportWizardTitle" bundle="ProcessPortal"/>" onkeypress="moveFocusToWorkLink(event)">
    <html:form styleId="wizardForm" action="/jsp/viewAdHocReportWizard.do" method="POST">
        <div id="search">
            <div id="header" style="height: 18px;">
                <table width="100%" cellpadding="0" cellspacing="0" border="0" role="presentation">
                    <tbody>
                        <tr valign="middle">
                            <td nowrap="nowrap">
                                <label for="bpdList"><bean:message key="reports.adhoc.BusinessProcess" bundle="ProcessPortal"/></label>
                                &nbsp;
                                <html:select styleId="bpdList" property="bpdId" onchange="this.form.submit()" style="width: auto;">
                                    <% if (ViewAdHocReportWizardPage.getString("bpdId") == null || ViewAdHocReportWizardPage.getString("bpdId").length() == 0) { %>
                                        <html:option value="-1">-<bean:message key="reports.adhoc.SelectBpd" bundle="ProcessPortal"/>-</html:option>
                                    <% } %>
                                    <logic:iterate id="favBpd" collection="<%= bpdCollection %>" type="com.lombardi.langutil.collections.Pair<String, String>">
                                        <html:option value="<%= favBpd.getSecond() %>"><%= favBpd.getFirst() %></html:option>
                                    </logic:iterate>
                                </html:select>
                            </td>
                            <% if (ViewAdHocReportWizardPage.getString("bpdId") != null && ViewAdHocReportWizardPage.getString("bpdId").length() > 0) { %>
                                <td align="right">
                                    <table width="0" cellpadding="0" cellspacing="0" border="0" role="presentation">
                                        <tbody>
                                            <tr>
                                                <td>
                                                    <input type="button" value="<bean:message key="reports.adhoc.SaveAsTeamworksReport" bundle="ProcessPortal"/>" onclick="generateReport()" aria-label="<bean:message key="reports.adhoc.CreateReportFromChart.CursorMode" bundle="ProcessPortal"/>" title="<bean:message key="reports.adhoc.CreateReportFromChart" bundle="ProcessPortal"/>" style="height:20px" />
                                                </td>
                                                <td>
                                                    <input type="button" value="<bean:message key="reports.adhoc.ExcelExport" bundle="ProcessPortal"/>" onclick="updateChart(true)" title="<bean:message key="reports.adhoc.ExportRawToExcel" bundle="ProcessPortal"/>" style="height:20px"/>
                                                </td>
												<td>
                                                    <input type="button" value="<bean:message key="reports.adhoc.CSVExport" bundle="ProcessPortal"/>" onclick="updateChart(false)" title="<bean:message key="reports.adhoc.ExportRawToCsv" bundle="ProcessPortal"/>" style="height:20px"/>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </td>
                            <% } %>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <logic:messagesPresent>
            <div style="color:red">
                <br />
                <html:messages id="error">
                    <bean:write name="error" /><br />
                </html:messages>
            </div>
        </logic:messagesPresent>
        <table align="center" width="100%" cellpadding="0" cellspacing="0" border="0" role="presentation">
            <tr id="wizardContent" valign="top" style="display:none;">
                <td style="padding-right: 10px;">
                    <table width="100%" cellpadding="0" cellspacing="0" border="0" role="presentation">
                        <tr>
                            <td valign="top" height="5%">
                                <table width="100%" class="content-table-around-line" role="group" aria-label="<bean:message key="reports.adhoc.XAxis" bundle="ProcessPortal"/>">
                                    <thead>
                                        <tr>
                                            <td colspan="3" id="xAxis">
                                                <bean:message key="reports.adhoc.XAxis" bundle="ProcessPortal"/>
                                            </td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr height="30">
                                            <td nowrap="nowrap" width="5%"><label for="xAxisBindingNodeTypeList"><bean:message key="reports.adhoc.Binding" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td width="10%">
                                                <html:select styleId="xAxisBindingNodeTypeList" property="xAxisBindingNodeTypeProp" onchange="this.form.submit()" style="width: 200px;">
                                                    <html:option value="-1">-<bean:message key="reports.adhoc.SelectNodeType" bundle="ProcessPortal"/>-</html:option>
                                                    <logic:iterate id="xAxisBindingNodeString" indexId="index" collection="<%= xAxisBindingNodeType %>" type="java.lang.String">
                                                        <html:option value="<%= index.toString() %>"><%= xAxisBindingNodeString %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                            <td>
                                                <html:select styleId="xAxisBindingVarList" property="xAxisBindingVar" style="display:none" onchange="enableXAxisCombos()">
                                                    <% if (xAxisTrackedItems.size() > 0) { %>
                                                    <html:option value="-1">-<bean:message key="reports.adhoc.SelectTrackedItem" bundle="ProcessPortal"/>-</html:option>
                                                    <% } else { %>
                                                    <html:option value="-1">-<bean:message key="reports.adhoc.NoTrackedItems" bundle="ProcessPortal"/>-</html:option>
                                                    <% } %>
                                                    <logic:iterate id="xAxisBindingVarString" collection="<%= xAxisTrackedItems %>" type="java.lang.String">
                                                        <html:option value="<%= xAxisBindingVarString %>"><%= xAxisBindingVarString %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                        </tr>
                                        <tr height="30">
                                            <td><label for="sortOrderList"><bean:message key="reports.adhoc.Sorting" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td colspan="2">
                                                <html:select styleId="sortOrderList" property="xAxisSortOrder">
                                                    <logic:iterate id="xAxisSortOrderKey" collection="<%= sortingOrderTypes.keySet() %>" type="java.lang.String">
                                                        <html:option value="<%= sortingOrderTypes.get(xAxisSortOrderKey).toString() %>"><%= xAxisSortOrderKey %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top" height="5%">
                                <table width="100%" class="content-table-around-line" role="group" aria-label="<bean:message key="reports.adhoc.YAxis" bundle="ProcessPortal"/>">
                                    <thead>
                                        <tr>
                                            <td colspan="3" id="yAxis">
                                                <bean:message key="reports.adhoc.YAxis" bundle="ProcessPortal"/>
                                            </td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr height="30">
                                            <td nowrap="nowrap" width="5%"><label for="yAxisBindingNodeTypeList"><bean:message key="reports.adhoc.Binding" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td width="10%">
                                                <html:select styleId="yAxisBindingNodeTypeList" property="yAxisBindingNodeTypeProp" onchange="this.form.submit()">
                                                    <html:option value="-1">-<bean:message key="reports.adhoc.SelectNodeType" bundle="ProcessPortal"/>-</html:option>
                                                    <logic:iterate id="yAxisBindingNodeTypeString" indexId="index" collection="<%= yAxisBindingNodeType %>" type="java.lang.String">
                                                        <html:option value="<%= index.toString() %>"><%= yAxisBindingNodeTypeString %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                            <td>
                                                <html:select styleId="yAxisBindingVarList" property="yAxisBindingVar" style="display:none" onchange="enableFunctionAndConvertCombo()">
                                                    <% if (yAxisTrackedItems.size() > 0) { %>
                                                    <html:option value="-1">-<bean:message key="reports.adhoc.SelectTrackedItem" bundle="ProcessPortal"/>-</html:option>
                                                    <% } else { %>
                                                    <html:option value="-1">-<bean:message key="reports.adhoc.NoTrackedItems" bundle="ProcessPortal"/>-</html:option>
                                                    <% } %>
                                                    <logic:iterate id="yAxisBindingVarString" collection="<%= yAxisTrackedItems %>" type="java.lang.String">
                                                        <html:option value="<%= yAxisBindingVarString %>"><%= yAxisBindingVarString %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                        </tr>
                                        <tr height="30" id="functionSectionId" style="display:none">
                                            <td nowrap="nowrap" width="5%"><label for="yAxisFunctionList"><bean:message key="reports.adhoc.Function" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td colspan="2">
                                                <html:select styleId="yAxisFunctionList" property="yAxisFunctionType">
                                                    <logic:iterate id="yAxisFunctionKey" indexId="index" collection="<%= functionTypes.keySet() %>" type="java.lang.String">
                                                        <html:option value="<%= functionTypes.get(yAxisFunctionKey).toString() %>"><%= yAxisFunctionKey %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                        </tr>
                                        <tr height="30" id="conversionSectionId" style="display:none">
                                            <td width="5%"><label for="yAxisConversionList"><bean:message key="reports.adhoc.Convert" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td colspan="2">
                                                <html:select styleId="yAxisConversionList" property="yAxisConversionType">
                                                    <logic:iterate id="yAxisConversionKey" indexId="index" collection="<%= conversionTypes.keySet() %>" type="java.lang.String">
                                                        <html:option value="<%= conversionTypes.get(yAxisConversionKey).toString() %>"><%= yAxisConversionKey %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top" height="5%">
                                <table width="100%" class="content-table-around-line" role="group" aria-label="<bean:message key="reports.adhoc.TimePeriodFilter" bundle="ProcessPortal"/>">
                                    <thead>
                                        <tr>
                                            <td colspan="3">
                                                <bean:message key="reports.adhoc.TimePeriodFilter" bundle="ProcessPortal"/>
                                            </td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr height="30">
                                            <td nowrap="nowrap" width="5%"><label for="timeRangeList"><bean:message key="reports.adhoc.TimeRange" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td>
                                                <html:select styleId="timeRangeList" property="timeRangeType" onchange="enableCustomDatesFields()">
                                                    <logic:iterate id="timeRangeString" collection="<%= rangeTypes %>" indexId="rangeIndex" type="java.lang.String">
                                                        <html:option value="<%= rangeIndex.toString() %>"><%= timeRangeString %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                            </td>
                                        </tr>
                                        <tr height="30" id="startDateFieldSection" style="display:none">
                                            <td nowrap="nowrap"><label for="startDateWidgetId"><bean:message key="reports.adhoc.StartDate" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td>
                                                <input id="startDateWidgetId" dojoType="dijit.form.DateTextBox" datePackage="<%=dojoDatePackage%>" value="new Date()" jsId="startDateWidget">
                                                <html:hidden styleId="startDateField" property="timeRangeStartDate"/>
                                            </td>
                                        </tr>
                                        <tr height="30" id="endDateFieldSection" style="display:none">
                                            <td nowrap="nowrap"><label for="endDateWidgetId"><bean:message key="reports.adhoc.EndDate" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                            <td>
                                                <input id="endDateWidgetId" dojoType="dijit.form.DateTextBox" datePackage="<%=dojoDatePackage%>" value="new Date()" jsId="endDateWidget">
                                                <html:hidden styleId="endDateField" property="timeRangeEndDate"/>
                                            </td>
                                        </tr>
                                        
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top" nowrap="nowrap">
                               <table width="100%" class="content-table-around-line" role="group" aria-label="<bean:message key="reports.adhoc.BusinessDataFilter" bundle="ProcessPortal"/>">
                                    <thead>
                                        <tr>
                                            <td colspan="3">
                                                <bean:message key="reports.adhoc.BusinessDataFilter" bundle="ProcessPortal"/>
                                            </td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr height="30">
                                            <td width="10%">
                                                <html:select styleId="businessDataTypeList" property="businessDataType" onchange="this.form.submit()">
                                                    <html:option value="-1">-<bean:message key="reports.adhoc.SelectNodeType" bundle="ProcessPortal"/>-</html:option>
                                                    <logic:iterate id="businessDataNodeTypeString" indexId="index" collection="<%= businessDataNodeType %>" type="java.lang.String">
                                                        <html:option value="<%= index.toString() %>"><%= businessDataNodeTypeString %></html:option>
                                                    </logic:iterate>
                                                </html:select>
                                                 <select id="businessDataItemsList" style="display:none" onchange="" aria-label="businessDataItemsList">
                                                    <% if (businessDataItems.size() > 0) { %>
                                                    <option value="-1">-<bean:message key="reports.adhoc.SelectTrackedItem" bundle="ProcessPortal"/>-</option>
                                                    <% } else { %>
                                                    <option value="-1">-<bean:message key="reports.adhoc.NoTrackedItems" bundle="ProcessPortal"/>-</option>
                                                    <% } %>
                                                    <logic:iterate id="businessDataItemsString" collection="<%= businessDataItems %>" type="java.lang.String">
                                                        <option value="<%= businessDataItemsString %>"><%= businessDataItemsString %></option>
                                                    </logic:iterate>
                                                </select>
                                                <input type="button" value="<bean:message key="reports.adhoc.Add" bundle="ProcessPortal"/>" title="<bean:message key="reports.adhoc.CreateNewConstr" bundle="ProcessPortal"/>" onclick="addBusinessConstraint()" />
                                            </td>
                                        </tr>
                                        <tr><td><table role="presentation"><tbody id="businessDataFilterId">
                                        <% if (businessDataConstraints.size() > 0) { %>
                                        <logic:iterate id="bdc" indexId="index" collection="<%= businessDataConstraints %>" type="com.lombardisoftware.portal.report.AdHocReportData.BusinessDataConstraintData">
                                            <script type="text/javascript">
                                                        dojo.addOnLoad(function(){
                                                           var bdIdx = <%= index %>;
                                                           dateCombobox = new dijit.form.DateTextBox({value: new Date("<%= bdc.getValue() %>")});
                                                           element = document.getElementById("bdVal" + bdIdx);
                                                           element.parentNode.replaceChild(dateCombobox.domNode, element);
                                                           dateCombobox.domNode.getElementsByTagName("input")[dateCombobox.domNode.getElementsByTagName("input").length - 1].id = "bdVal" + bdIdx;
                                                           dateCombobox.domNode.getElementsByTagName("input")[dateCombobox.domNode.getElementsByTagName("input").length - 1].name = "bdVal" + bdIdx;
                                                        });
                                                </script>
                                            <tr id="bdTrId<%= index %>" height="30">
                                                <td width="10%" align="right">
                                                    <input type="hidden" id="bdType<%= index %>" name="bdType<%= index %>" value="<%= bdc.getType() %>" />
                                                    <input type="hidden" id="bdVar<%= index %>" name="bdVar<%= index %>" value="<%= bdc.getVar() %>" />
                                                    <%= bdc.getVar() %>
                                                </td>
                                                <td width="10%">
                                                    <label for="bdCond<%= index %>"></label><select id="bdCond<%= index %>" name="bdCond<%= index %>" style="width:50px;">
                                                        <option value="="<%= bdc.getOperation().equals("=") ? " selected=\"selected\"" : "" %>>=</option>
                                                        <option value="!="<%= bdc.getOperation().equals("!=") ? " selected=\"selected\"" : "" %>>!=</option>
                                                        <option value=">="<%= bdc.getOperation().equals(">=") ? " selected=\"selected\"" : "" %>>&gt;=</option>
                                                        <option value=">"<%= bdc.getOperation().equals(">") ? " selected=\"selected\"" : "" %>>&gt;</option>
                                                        <option value="<="<%= bdc.getOperation().equals("<=") ? " selected=\"selected\"" : "" %>>&lt;=</option>
                                                        <option value="<"<%= bdc.getOperation().equals("<") ? " selected=\"selected\"" : "" %>>&lt;</option>
                                                    </select>
                                                </td>
                                                <td width="10%">
                                                    <label for="bdVal<%= index %>"></label><input type="text" id="bdVal<%= index %>" name="bdVal<%= index %>" value="<%= bdc.getValue() %>" style="width:150px;" />
                                                </td>
                                                <td>
                                                    <img tabindex="0" src="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/remove.gif" alt="<bean:message key="reports.adhoc.RemoveConstr" bundle="ProcessPortal"/>" style="cursor:pointer;cursor:hand" onclick="removeBusinessConstraint('bdTrId<%= index %>')" title="<bean:message key="reports.adhoc.RemoveConstr" bundle="ProcessPortal"/>" />
                                                </td>
                                            </tr>
                                        </logic:iterate>
                                        <% } %>
                                        </tbody></table></td></tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
                <td valign="top" width="70%">
                    <table width="100%" class="content-table-around-line" role="presentation">
                        <thead>
                            <tr>
                                <td colspan="2" width="100%">
                                    <bean:message key="reports.adhoc.ChartPreview" bundle="ProcessPortal"/>
                                </td>
                                <td nowrap="nowrap" align="right">
                                    <input type="button" value="<bean:message key="reports.adhoc.RefreshChart" bundle="ProcessPortal"/>" onclick="updateChart()" title="<bean:message key="reports.adhoc.RefreshChartTitle" bundle="ProcessPortal"/>" />
                                </td>
                            </tr>
                        </thead>
                        <tbody role="group" aria-label="<bean:message key="reports.adhoc.ChartPreview" bundle="ProcessPortal"/>" aria-describedby="chartTextInstruction">
                            <tr height="30">
                                <td nowrap="nowrap" width="5%"><label for="chartTypeList"><bean:message key="reports.adhoc.ChartLayout" bundle="ProcessPortal"/><%= MessagesHelper.getMessage(application, request, "reports.adhoc.SingleColon", "ProcessPortal") %></label></td>
                                <td>
                                    <html:select styleId="chartTypeList" property="chartType" onchange="updateChartFromCombo()" onkeypress="moveFocusToBody(event)">
                                        <logic:iterate id="chartTypeKey" indexId="index" collection="<%= chartTypes.keySet() %>" type="java.lang.String">
                                            <html:option value="<%= index.toString() %>"><%= chartTypes.get(chartTypeKey).toString() %></html:option>
                                        </logic:iterate>
                                    </html:select>
                                </td>
                                <td>&nbsp;</td>
                            </tr>
							<tr>
							<td colspan="2" id="chartTextInstruction">
							<%= MessagesHelper.getMessage(application, request, "adHocReport.chartTextInstruction", "ProcessPortal") %>
							</td>
							</tr>
                            <tr>
                                <td colspan="3" align="center">
                                    <img id="chartImgId" src="images/spacer.gif" alt="imageAltReload(null)"/>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </td>
            </tr>
        </table>
    </html:form>
</div>
