<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.core.DateFormatHelper"%>
<%@ page import="com.lombardisoftware.psapi.data.Task"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants"%>
<%@ page import="org.apache.struts.action.DynaActionForm"%>
<%@ page import="com.lombardisoftware.client.DateFormatUtils"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<jsp:useBean id="task" class="com.lombardisoftware.psapi.data.Task" scope="request"/>
<jsp:useBean id="user" class="com.lombardisoftware.psapi.data.User" scope="session"/>
<jsp:useBean id="sender" class="com.lombardisoftware.psapi.data.User" scope="request"/>
<jsp:useBean id="recipient" class="com.lombardisoftware.psapi.data.User" scope="request"/>
<jsp:useBean id="to" class="java.lang.String" scope="request"/>
<%
    DynaActionForm form = (DynaActionForm) request.getAttribute(Constants.FormBeans.ViewComment.FORM_NAME);
    String bpdInstanceId = form.getString(Constants.FormBeans.ViewComment.BPD_INSTANCE_ID);

    String status = task.getStatus();
    String hrStatus = "";

    boolean showButtons = true;
    if(Task.TASK_STATUS_HELP_REQUEST.equals(status)) {
        hrStatus = "viewPopup.Status.NeedsResponse";
    } else if(Task.TASK_STATUS_IGNORED_HELP_REQUEST.equals(status)) {
        hrStatus = "viewPopup.Status.Ignored";
        showButtons = false;
    } else if(Task.TASK_STATUS_ANSWERED_HELP_REQUEST.equals(status)) {
        hrStatus = "viewPopup.Status.Answered";
        showButtons = false;
    }

    Boolean addressedToRecipient = (Boolean) request.getAttribute(Constants.Request.ADDRESSED_TO_RECIPIENT);
%>
<div style="text-align: left" class="body">
    <form name="commentForm" action="addCommentExecute.do" method="post">
            <div><bean:message key="addComment.From" bundle="ProcessPortal"/>: <strong><%= sender.getFullName() %></strong></div>
            <div><bean:message key="addComment.To" bundle="ProcessPortal"/>: 
               <strong>
                   <%if(to.equals("Everyone")){%> 
                       <bean:message key="addComment.Everyone" bundle="ProcessPortal"/>              
                   <% } else { out.write(to);}%>
               </strong>
            </div>
            <div><bean:message key="addComment.Date" bundle="ProcessPortal"/>: 
                <strong><%=task.getRcvdDateTime()==null?"":DateFormatUtils.getDateTimeFormat().format(task.getRcvdDateTime())%></strong>
            </div>
            <% if (task.isHelpRequest()) { %>
            <div><bean:message key="viewPopup.Status" bundle="ProcessPortal"/>: <strong><bean:message key="<%= hrStatus %>" bundle="ProcessPortal"/></strong></div>
            <% } %>
            <div style="margin-top: 20px; margin-bottom: 3px">
                 <% if(task.getNarrativeWithFreshUpdate().endsWith("viewPopup.IgnoredHelpRequestMessage")){ 
                       // ignore message %>
                       <label for="commentId1"></label><textarea id="commentId1" readonly name="comment" cols="100" rows="16"><%= task.getNarrativeWithFreshUpdate().replaceAll("viewPopup.IgnoredHelpRequestMessage"," ")%><bean:message key="viewPopup.IgnoredHelpRequestMessage" bundle="ProcessPortal"/></textarea>
                 <% } else {%>
                       <label for="commentId2"></label><textarea id="commentId2" readonly name="comment" cols="100" rows="16"><%= task.getNarrativeWithFreshUpdate()%></textarea>
                 <% } %>
            </div>
            <input type="button" style="height:20;" value="<bean:message key="common.buttonClose" bundle="ProcessPortal"/>" onClick="window.close(); return false;"/>
            <% if(showButtons && task.isHelpRequest() && (addressedToRecipient != null && addressedToRecipient.booleanValue())) {%>
                    <input type="button" style="height:20;" value="<bean:message key="common.buttonReply" bundle="ProcessPortal"/>" onClick="javascript:replyHR(<%= bpdInstanceId %>, <%= task.getTaskID() %>);"/>
                    <input type="button" style="height:20;" value="<bean:message key="common.buttonIgnore" bundle="ProcessPortal"/>" onClick="javascript:ignoreHR(<%= bpdInstanceId %>, <%= task.getTaskID() %>, '<%= user.getFullName() %>');"/>
            <% } %>
    </form>
</div>
