<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page import="java.util.Map"%>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>


<%
    Map<String, String> attrData = UserAttributesHelper.getUserAttributes(); 
%>

<script type="text/javascript" src="<%=request.getContextPath()%>/js/utils.js"></script>
<script type="text/javascript">
    function showChart(oSelect) {
        if ((oSelect.value == -1) || (oSelect.value == "-1")) {
            return;
        }
        forceImageReload(getHtmlElement("chartImgId"), "adhocReportChart?reportId=" + oSelect.value);
    }
	
	function showExcel(oSelect) {
	   if ((oSelect.value == -1) || (oSelect.value == "-1")) {
	        return;
		}
        var query = "?reportId=" + oSelect.value;
		query += "&generationType=xls";
		
		var generatedReportsForm= getHtmlElement("generatedReportsForm");
        generatedReportsForm.action = "<%=request.getContextPath()%>/jsp/adhocReportChart" + query;
        generatedReportsForm.submit();
                
        // Restore original action
        generatedReportsForm.action = "<%=request.getContextPath()%>/jsp/viewGeneratedReports.do";
    }
	
	function showCSV(oSelect) {
	   if ((oSelect.value == -1) || (oSelect.value == "-1")) {
	        return;
		}
        var query = "?reportId=" + oSelect.value;
		query += "&generationType=csv";
		
		var generatedReportsForm= getHtmlElement("generatedReportsForm");
        generatedReportsForm.action = "<%=request.getContextPath()%>/jsp/adhocReportChart" + query;
        generatedReportsForm.submit();
                
        // Restore original action
        generatedReportsForm.action = "<%=request.getContextPath()%>/jsp/viewGeneratedReports.do";
    }
	
function moveFocusToRefresh(event) {
    if (event.keyCode == "9" ){//TAB
        var button = getHtmlElement("refreshReportButton");
        if (!button) {//do nothing if button is on this page since it will move to Refresh anyway
            moveFocusToBody(event);
        }
    } 
}

function confirmDelete(message, url) {
    var messageUCC = applyUCC(message);
    if (confirm(messageUCC)) {
        window.location.href = url;
    }
}
</script>

<jsp:useBean id="ViewGeneratedReportsPage" class="com.lombardisoftware.portal.form.ViewGeneratedReportsForm" scope="request" />
<c:set var="form" value="${ViewGeneratedReportsPage}" />

<div class="body" tabindex="0" id="body" role="form" aria-label="<bean:message key="reports.adhoc.SavedAdhocReports" bundle="ProcessPortal"/>" onkeypress="moveFocusToWorkLink(event)">
<html:form styleId="generatedReportsForm" action="/jsp/viewGeneratedReports.do" method="POST">
    <div id="search">
        <div id="header" style="height: 18px;">
            <table width="100%" cellpadding="0" cellspacing="0" border="0">
                <tbody>
                    <tr valign="middle">
                        <td nowrap="nowrap">
                            <label for="savedReportsList"><bean:message key="reports.adhoc.SavedAdhocReports" bundle="ProcessPortal"/></label>
                            &nbsp;
                            <html:select property="reportId" styleId="savedReportsList" onchange="this.form.submit()" style="width: 150px;">
                                <c:choose>
                                    <c:when test="${not empty form.reportList}">
                                        <c:if test="${empty form.reportName}">
                                            <html:option value="-1">-<bean:message key="reports.adhoc.SelectReport" bundle="ProcessPortal"/>-</html:option>
                                        </c:if>
                                        <logic:iterate id="report" name="form" indexId="index" property="reportList" type="com.lombardisoftware.portal.report.ReportTO">
                                            <html:option value="${report.id}"><bean:write name="report" property="name" /></html:option>
                                        </logic:iterate>
                                    </c:when>
                                    <c:otherwise>
                                        <html:option value="-1">-<bean:message key="reports.adhoc.NoSavedReports" bundle="ProcessPortal"/>-</html:option>
                                    </c:otherwise>
                                </c:choose>
                            </html:select>
                        </td>
                        <c:if test="${form.userInAuthorsRole}">
                            <td align="<%=BidiUtils.getalignment(attrData,"right")%>">
                                <table width="0" cellpadding="0" cellspacing="0" border="0">
                                    <tbody>
                                        <tr>
                                            <td>
                                                <c:url value="/jsp/viewAdHocReportWizard.do" var="newReportUrl" />
                                                <input type="button" value="<bean:message key="reports.adhoc.NewAdhocReport" bundle="ProcessPortal"/>" onclick="window.location.href='${newReportUrl}'" onkeypress="moveFocusToRefresh(event)"/>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </c:if>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
    <logic:messagesPresent>
        <div style="color:red">
            <br />
            <html:messages id="error">
                <bean:write name="error" /><br />
            </html:messages>
        </div>
    </logic:messagesPresent>
    <c:if test="${not empty form.reportName}">
        <table class="content-table-around-line">
            <thead>
                <tr valign="middle">
                    <td class="bidiText">
                        ${form.reportName}
                    </td>
                    <td align="<%=BidiUtils.getalignment(attrData,"right")%>">
                        <table width="0" cellpadding="0" cellspacing="0" border="0">
                            <tbody>
                                <tr>
                                    <td>
                                        <input id="refreshReportButton" type="button" value="<bean:message key='reports.adhoc.Refresh' bundle='ProcessPortal'/>" onclick="showChart(getHtmlElement('savedReportsList'))" />
                                    </td>
									<td>
                                        <input id="excelReportButton" type="button" value="<bean:message key='reports.adhoc.ExcelExport' bundle='ProcessPortal'/>" onclick="showExcel(getHtmlElement('savedReportsList'))" />
                                    </td>
									<td>
                                        <input id="csvReportButton" type="button" value="<bean:message key='reports.adhoc.CSVExport' bundle='ProcessPortal'/>" onclick="showCSV(getHtmlElement('savedReportsList'))" />
                                    </td>
                                    <c:if test="${form.userInAuthorsRole}">
                                        <td style="border-width: 0px;">
                                            <c:url value="/jsp/viewGeneratedReports.do" var="deleteUrl">
                                                <c:param name="action" value="Delete" />
                                                <c:choose>
                                                    <c:when test="${requestScope.reportId != null}">
                                                        <c:param name="reportId" value="${requestScope.reportId}" />
                                                    </c:when>
                                                    <c:otherwise>
                                                        <c:param name="reportId" value="${form.reportId}" />
                                                    </c:otherwise>
                                                </c:choose>
                                            </c:url>
                                            <c:set var="reportName1" value="${form.reportName}" scope="request" />
                                            <% String reportName2 = BidiUtils.applyUCC(attrData, (String)request.getAttribute("reportName1")); %>                                                                                       
                                            <input type="button" value="<bean:message key='reports.adhoc.DeleteReport' bundle='ProcessPortal'/>" 
                                            onclick="confirmDelete('<bean:message key="reports.adhoc.AreYouSureYouWantToDelete" bundle="ProcessPortal" arg0="<%= reportName2 %>"/>','${deleteUrl}')" onkeypress="moveFocusToBody(event)" />                                            
                                        </td>
                                    </c:if>
                                </tr>
                            </tbody>
                        </table>
                    </td>
                </tr>
            </thead>
            <tbody>
                <tr align="center">
                    <td colspan="2">
                        <img id="chartImgId" src="adhocReportChart?reportId=${form.reportId}" title="${form.reportName}" alt="${form.reportName}"/>
                    </td>
                </tr>
            </tbody>
        </table>
    </c:if>
</html:form>
<c:if test="${requestScope.reportId != null}">
<script type="text/javascript">
    var savedReportsSelect = getHtmlElement("savedReportsList");
    savedReportsSelect.value = "${requestScope.reportId}";
    showChart(savedReportsSelect);
</script>
</c:if>
</div>
