<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.psapi.data.Task"%>
<%@ page import="com.lombardisoftware.portal.utils.CommentHelper"%>
<%@ taglib prefix="tiles" uri="/WEB-INF/struts-tiles.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<jsp:useBean id="task" class="com.lombardisoftware.psapi.data.Task" scope="request"/>
<%
    String status = task.getStatus();
    String key = "viewPopup.Title.";

    if(Task.TASK_STATUS_ALERT.equals(status)) {
        key += "Alert";
    } else if(Task.TASK_STATUS_COMMENT.equals(status)) {
        key += "Comment";
    } else if(Task.TASK_STATUS_HELP_REQUEST.equals(status)) {
        key += "HelpRequest";
    } else if(Task.TASK_STATUS_IGNORED_HELP_REQUEST.equals(status)) {
        key += "HelpRequest";
    } else if(Task.TASK_STATUS_ANSWERED_HELP_REQUEST.equals(status)) {
        key += "HelpRequest";
    } else {
        key += "Comment";
    }

    String iconPath = CommentHelper.getIconName(status);
    String title = "<img border=\"0\" src=\"" + iconPath + "\">";
%>
<tiles:insert page="layouts/Popup.jsp" flush="true">
    <tiles:put name="title"><bean:message key="<%=key%>" bundle="ProcessPortal"/></tiles:put>
    <tiles:put name="heading"><%= title %><bean:message key="<%=key%>" bundle="ProcessPortal"/></tiles:put>
    <tiles:put name="head" value="../tiles/ViewCommentHead.jsp"/>
    <tiles:put name="body" value="../tiles/ViewCommentBody.jsp"/>
</tiles:insert>