<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%@ include file="contextRoot.jsp" %>

<%
    String redirectTo = null;

    // Find the TWforwardPage cookie
    Cookie [] cookies = request.getCookies();
    if (cookies != null) {
        for (int i = 0; i < cookies.length; i++) {
            Cookie cookie = cookies[i];
            if (cookie.getName().equals("TWforwardPage")) {
                if (cookie.getValue() != null) {
                    redirectTo = cookie.getValue();
                    // remove the cookie - it has been used
                    cookie.setMaxAge(0);
                    response.addCookie(cookie);
                }
            }
        }
    }

	String redirectURL = processPortalContextRoot;
    if (redirectTo != null) {
		if ((redirectTo.indexOf("portal/jsp/viewScoreboard.do") > 0) || (redirectTo.indexOf("portal/jsp/getProcessDetails.do") > 0) ||
		(redirectTo.indexOf("portal/jsp/getSavedSearch.do") > 0) || (redirectTo.indexOf("portal/jsp/processInstanceDiagram.jsp") > 0)) {
			response.sendRedirect(redirectTo);
		} else {
			response.sendRedirect(redirectURL);
		}
    } else {
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head><title><bean:message key="main.message.title" bundle="ProcessPortal"/></title></head>
  <body><logic:forward name="WELCOME"/></body>
</html>
<% } %>