<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants,
   com.lombardisoftware.portal.utils.LocaleUtil"%>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<%@ include file="jsp/contextRoot.jsp" %>

<logic:empty name="isLoginActionPerfomed" scope="request">
  <bean:define id="isLoginActionPerfomed" value="true" toScope="request"/>
  <%

      StringBuffer loginActionPath = new StringBuffer(128);
      loginActionPath.append(request.getContextPath()).append("/login.do");
      char sep = '?';
      String successPage = request.getParameter("sp");
      if (successPage != null) {
          loginActionPath.append("?sp=").append(URLEncoder.encode(successPage));
          sep = '&';
      }
      String msgKey = request.getParameter(Constants.Request.ERROR_MESSAGE);
      if (msgKey != null) {
          loginActionPath.append(sep).append(Constants.Request.ERROR_MESSAGE).append('=').append(URLEncoder.encode(msgKey));
      }
  %>
    <% try { // Kill IllegalStateException and proceed to login page. %>
    <logic:redirect href="<%= loginActionPath.toString() %>"/>
    <% } catch (IllegalStateException e) {} %>
</logic:empty>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head>
<title><bean:message key="login.title" bundle="ProcessPortal"/></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/login.css" media="screen, projection" />
<script>

/** Detect if browser is IE */
function /* Boolean */ isIE() {
    return navigator.userAgent.indexOf("MSIE") >= 0;
}

function doOnLoad() {
  document.login.j_username.focus();
  allowSubmit = true;
  if (isIE()) {
    var autologinDiv = document.getElementById("autologinLink");
    if (autologinDiv != null) {
      autologinDiv.style.visibility = "visible";
    }
  }
}

function setCookie(name, value, expires, path, domain, secure) {
 var curCookie = name + "=" + escape(value) +
  ((expires) ? "; expires=" + expires.toGMTString() : "") +
  ((path) ? "; path=" + path : "") +
  ((domain) ? "; domain=" + domain : "") +
  ((secure) ? "; secure" : "");
 document.cookie = curCookie;
}

var allowSubmit = false;

function doOnSubmit() {
 <%--We want to make sure the applet has been loaded before we log in so that we can get the correct locale/time zone info from the client. If all else fails we assume GMT...--%>
 if (!allowSubmit) {
  window.status = '<bean:message key="login.window.status" bundle="ProcessPortal" encodeTo="js" />';
  return false;
 }
  try {
    setCookie("ibm.bpm.timezoneOffset", new Date().getTimezoneOffset(), null, "/");
  } catch(ex) {
   //do nothing    
  }
 return true;
}
</script>
</head>
<body onLoad="doOnLoad()" id="pbody">
<div id="login-header">
<div class="logo"></div>
</div>
<div id="login-body">
<table cellpadding="0" cellspacing="0" width="100%">
 <tr>
  <td>&nbsp;</td>
  <td width="500">
    <div id="login-content">
      <table id="content-header" cellspacing="0" cellpadding="0">
        <tr>
          <td id="content-header-left"></td>
          <td id="content-title"><bean:message key="login.desc" bundle="ProcessPortal" /></td>
          <td id="content-header-right"></td>
        </tr>
      </table><div id="content-border">
       <%String msgKey = request.getParameter(Constants.Request.ERROR_MESSAGE);
         if(msgKey == null){
             msgKey = (String)session.getAttribute(Constants.Request.ERROR_MESSAGE);
          }%>
	<%if(msgKey != null) {%>
		<div id="login-error">
			<bean:message key="<%=msgKey%>" bundle="ProcessPortal"/>
		</div>
	<%}%>
	<form method="POST" action="j_security_check" name="login" onSubmit="return doOnSubmit()">
		<div>
		  <table id="login-table" align="center">
			<tr>
			  <td><label for="j_username_id"><bean:message key="login.fields.username" bundle="ProcessPortal"/></label></td>
			  <td><input style="width:130" type="text" name="j_username" id="j_username_id"></td>
			</tr>
			<tr>
			  <td><label for="j_password_id"><bean:message key="login.fields.password" bundle="ProcessPortal"/></label></td>
			 <td><input style="width:130" type="password" name="j_password" id="j_password_id"></td>
			</tr>
			<tr><td colspan="2" align="center"><input type="submit" value="<bean:message key="login.button.Login" bundle="ProcessPortal"/>"></td></tr>
            <%
                if (TWConfiguration.getInstance().getServer().isShowAutologinLink()) {
                    %><tr><td colspan="2" align="center"><div id="autologinLink" style="visibility:hidden"><a href="<%= processPortalSupportContextRoot %>/autoLogin.jsp?sp=<%= processPortalSupportContextRoot %>/jsp/getSavedSearch.do"><bean:message key="login.text.autologin" bundle="ProcessPortal"/></a></div></td></tr><%
                }
            %>
	</table>
            <% 
                if (request.getSession().getAttribute(Constants.Session.INSTALLED_LOCALES) != null 
                        && LocaleUtil.CAN_USER_CHOOSE_LOCALE) { 
            %>
            <%-- Language selection on login page disabled until we have more design details for login page -->
			<%--<div id="lang-select">--%>
			 <%--<bean:size id="installedLocalesSize" name="<%=Constants.Session.INSTALLED_LOCALES%>" scope="session"/>--%>
			 <%--<bean:define id="userLocale" name="<%=org.apache.struts.Globals.LOCALE_KEY%>" scope="session" type="java.util.Locale"/>--%>
			<%--<input type="hidden" name="<%=Constants.Request.LOCALE_NAME %>" value="<%= userLocale.toString() %>">--%>
			   <%--<logic:greaterThan name="installedLocalesSize" value="1">--%>
			<%--<logic:iterate id="locale" name="<%=Constants.Session.INSTALLED_LOCALES%>" type="java.util.Locale">--%>
			<%--<% if(!locale.equals(userLocale)){%>--%>
			<%--<a href="<%=request.getContextPath()%>/login.do?localeName=<%= locale.toString()%>">--%>
			<%--<%=locale.getDisplayName(locale)%>--%>
			<%--</a>--%>
			<%--<%} else {%>--%>
			<%--<%=locale.getDisplayName(locale)%>--%>
		<%--<%}%>--%>
		<%--&nbsp;--%>
		<%--</logic:iterate><br>--%>
			<%--</logic:greaterThan>--%>
		<%--</div>--%>
			<%}%>
            
        <div id="login-copyright"><bean:message key="portal.common.copyright" bundle="ProcessPortal" encodeTo="none"/></div>
        </div>
      </form>
      </div>
    </div>
  </td>
  <td>&nbsp;</td>
</tr>
</table>
</div>
</body>
</html>
