<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.core.TWHttpClient,
                 com.lombardisoftware.core.config.TWConfiguration,
                 com.lombardisoftware.utility.ApplicationServerPlatform,
                 com.lombardisoftware.utility.Base64Encoder,
                 com.lombardisoftware.core.TeamWorksRuntimeException" %>
<%@ include file="jsp/contextRoot.jsp" %>
<%-- This page is named redirect-login rather than redirectLogin or something else because this --%>
<%-- let's us use the same java code in UtilityAllCore to generate redirect login requests --%>
<%
	String username = null;
	String password = null;
    if (TWConfiguration.getInstance().getAuthoringEnvironment().isAddRedirectUrlCredentials()) {
        if (TWConfiguration.getInstance().getAuthoringEnvironment().isEncodeRedirectUrlCredentials()) {
			String credentials = request.getParameter("credentials");
			if (credentials != null) {
			    int pos = credentials.indexOf(":");
			    try {
			        username = new String(Base64Encoder.base64ToByteArray(credentials.substring(0, pos)), "UTF-8");
			        password = new String(Base64Encoder.base64ToByteArray(credentials.substring(pos + 1)), "UTF-8");
			    } catch(java.io.UnsupportedEncodingException e) {
			    	throw TeamWorksRuntimeException.asTeamWorksRuntimeException(e);
			    }
		    } else {
                username = request.getParameter("j_username");
                password = request.getParameter("j_password");
            }
		} else {
		    username = request.getParameter("j_username");
		    password = request.getParameter("j_password");
		}
	}

	    String redirectTo = processPortalSupportContextRoot +"/" + request.getParameter("j_forward");
	    if (redirectTo != null) {
            redirectTo = redirectTo.replace('|', '&');
            
			// Add redirect cookie
			Cookie cookie = new Cookie("WASReqURL", redirectTo);
			response.addCookie(cookie);
	    }

	    Cookie [] cookies = request.getCookies();
	    if (cookies != null) {
			for (int i = 0; i < cookies.length; i++) {
			    Cookie cookie = cookies[i];
			    if ("JSESSIONID".equals(cookie.getName())) {
					// Delete the JSESSIONID cookie to make sure we actually log in
					cookie.setMaxAge(0);
					response.addCookie(cookie);
			    }
			}
	    }
		if (session!=null) session.invalidate();
	    if ((username != null) || (password != null)) {
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
        <title>Redirect Login</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<script>
			function setCookie(name, value, expires, path, domain, secure) {
				var curCookie = name + "=" + escape(value) +
				((expires) ? "; expires=" + expires.toGMTString() : "") +
				((path) ? "; path=" + path : "") +
				((domain) ? "; domain=" + domain : "") +
				((secure) ? "; secure" : "");
				document.cookie = curCookie;
			}
	
			try {
				setCookie("ibm.bpm.timezoneOffset", new Date().getTimezoneOffset(), null, "/");
			} catch(ex) { }
		</script>
    </head>
    <body onLoad="document.login.submit()">
        <form method="POST" action="j_security_check" name="login">
            <input type="hidden" name="j_username" value="<%= username %>">
            <input type="hidden" name="j_password" value="<%= password %>">
        </form>
    </body>
</html>
<%
            } else {
				//response.sendRedirect(redirectTo);

				//String redirectPath = request.getAttribute("origin").toString();
				request.getSession().setAttribute("origin", redirectTo);
				response.sendRedirect("/pushTZCookie.jsp");
            }
%>
