<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="tiles" uri="/WEB-INF/struts-tiles.tld"%>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ page import = "java.util.Map" %>

<%
    Map<String, String> attrData = UserAttributesHelper.getUserAttributes();
%>

<html>

<head>
    <title><tiles:getAsString name="title"/></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css" media="screen, projection" />
    <script type="text/javascript" src="<%=request.getContextPath()%>/jsp/js/core.jsp"></script>
    <script type="text/javascript" src="<%=request.getContextPath()%>/js/main.js"></script>
    <tiles:get name="head"/>
</head>

<% if(BidiUtils.isBidi(attrData)) { %>
    <body dir="rtl" onload="pageLoad()">
<% } else { %>
<body onload="pageLoad()">
<% } %>

<table cellspacing="0" cellpadding="0" border="0" id="layout">
    <tr valign="top">
        <td align="center" id="content" nowrap>
            <div class="heading">
                <% if(BidiUtils.isBidi(attrData)) { %>
                    <div class="heading-right"></div>
                    <h1 style="float:right;padding:5px 12px 0 0;"><tiles:getAsString name="heading"/></h1>
                <% } else { %>
                <div class="heading-right"></div>
                <h1><tiles:getAsString name="heading"/></h1>
                <% } %>
            </div>
            <tiles:get name="body"/>
        </td>
    </tr>
</table>
<div id="content-bottom">
    <% if(BidiUtils.isBidi(attrData)) { %>
        <div class="right"></div>
        <div class="left"></div>
    <% } else { %>
    <div class="left"></div>
    <div class="right"></div>
    <% } %>
</div>
</body>
</html>