<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants"%>
<%@ page import="com.lombardisoftware.portal.viewhelper.CommentsViewHelper"%>
<%@ page import="com.lombardisoftware.client.DateFormatUtils"%>
<%@ page import="com.lombardisoftware.core.UserPreference"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>

<% UserPreference userPreference = (UserPreference) session.getAttribute(UserPreference.SESSION_KEY); %>
<jsp:useBean id="user" class="com.lombardisoftware.psapi.data.User" scope="session"/>
<div style="text-align: left" class="body">
    <html:javascript formName="AddCommentExecute" bundle="ProcessPortal"/>
    <logic:messagesPresent>
        <html:messages id="msg" header="errors.header" footer="errors.footer" bundle="ProcessPortal">
            <li><bean:write name="msg" bundle="ProcessPortal"/></li>
        </html:messages>
    </logic:messagesPresent>
    <html:form action="/jsp/addCommentExecute.do" method="POST" focus="comment" onsubmit="return validateAddCommentExecute(this)">
            <div><bean:message key="addComment.From" bundle="ProcessPortal"/><strong><%= user.getFullName() %></strong></div>
            <div><bean:message key="addComment.To" bundle="ProcessPortal"/><strong><bean:message key="addComment.Everyone" bundle="ProcessPortal"/></strong></div>
            <div><bean:message key="addComment.Date" bundle="ProcessPortal"/>
                  <strong><%=BidiUtils.getDateTimeFormat(userPreference).format(CommentsViewHelper.getDBDate())%></strong>
            </div>
            <div style="margin-top: 20px; margin-bottom: 3px"><label for="commentId"></label><textarea id="commentId" name="comment" cols="100" rows="16"></textarea></div>
        <html:submit style="height:20;">
             <bean:message key="common.buttonSave" bundle="ProcessPortal"/>
        </html:submit>
        <input type="button" style="height:20;" value="<bean:message key="common.buttonCancel" bundle="ProcessPortal"/>" onClick="window.close(); return false;"/>
        <html:hidden property="<%= Constants.FormBeans.AddCommentExecute.BPD_INSTANCE_ID %>"/>
    </html:form>
</div>
