<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="java.math.BigDecimal" %>
<%@ page import="teamworks.SecurityUtils" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import = "java.util.*" %>
<%@ page import="com.lombardisoftware.portal.struts.Constants" %>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%@ include file="../contextRoot.jsp" %>

<%
    final Object bpdInstanceId = request.getAttribute("bpdInstanceId");
    Map<String, String> attrData = UserAttributesHelper.getUserAttributes();
    String language = UserAttributesHelper.getLanguage(attrData);
%>

<script type="text/javascript">
    function moveFocusToBody(event) {
        var b = document.getElementById("body");
        if (b) {
            b.focus();//a11y
        }
    }
</script>

<script type="text/javascript">
    if (typeof TW == 'undefined') {
        var TW = {};
        TW.pageData = {};
    };    
    TW.pageData.bpdInstanceId = <%= bpdInstanceId %>;
    TW.pageData.cpType = <%= request.getParameter("cpType") %>;
    TW.pageData.hasId = "<%= request.getParameter("hasId") == null ? 0 : request.getParameter("hasId") %>";
    TW.pageData.printable = <%= request.getParameter("printable") %>;
</script>

<script type="text/javascript" src="<%=request.getContextPath()%>/js/jquery/jquery-1.2.6.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/jquery/json2.js"></script>

<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js"
        djConfig="locale:'<%= language %>'"></script>
<link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css" />

<jsp:include page="bidi/BidiDateUtility.jsp" flush="true" />
<script type="text/javascript">
    // Initialize the words for duration units for criticalPath.js
    var daySingular = "<bean:message key='flash.diagram.popup.day.singular' bundle='ProcessPortal' encodeTo='js' />";
    var dayPlural = "<bean:message key='flash.diagram.popup.day.plural' bundle='ProcessPortal' encodeTo='js' />";
    var hourSingular = "<bean:message key='flash.diagram.popup.hour.singular' bundle='ProcessPortal' encodeTo='js' />";
    var hourPlural = "<bean:message key='flash.diagram.popup.hour.plural' bundle='ProcessPortal' encodeTo='js' />";
    var minuteSingular = "<bean:message key='flash.diagram.popup.minute.singular' bundle='ProcessPortal' encodeTo='js' />";
    var minutePlural = "<bean:message key='flash.diagram.popup.minute.plural' bundle='ProcessPortal' encodeTo='js' />";
    var monthSingular = "<bean:message key='flash.diagram.popup.month.singular' bundle='ProcessPortal' encodeTo='js' />";
    var monthPlural = "<bean:message key='flash.diagram.popup.month.plural' bundle='ProcessPortal' encodeTo='js' />";
</script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/criticalPath/criticalPath.js"></script>
<script type="text/javascript" src="<%=request.getContextPath()%>/js/criticalPath/criticalMassUpdates.js"></script>

<script type="text/javascript" src="<%=request.getContextPath()%>/js/exportCSV.js"></script>

<link rel="stylesheet" href="<%=request.getContextPath()%>/jsp/css/criticalPathDefault.css" type="text/css">

<!--[if IE 6]>
<link rel="stylesheet" href="<%=request.getContextPath()%>/jsp/css/criticalPathIE6.css" type="text/css">
<![endif]-->

<%@ page import="com.lombardisoftware.client.persistence.common.POType, com.lombardisoftware.client.persistence.common.ID, com.lombardisoftware.client.delegate.common.TWTreeElement"%>
<jsp:useBean id="historicalScenarios" type="java.util.List" scope="request"/>

<div>
    <form name="exportData" method="post" target="_new" action="<%= teamworksContextRoot %>/data-redirect.jsp">
        <input type="hidden" name="data" value="">
        <input type="hidden" name="fileName" value="filename=criticalPathData.csv">
    </form>
</div>

<div class="body" role="form" aria-label="<bean:message key="criticalPath.table.dueDates.head" bundle="ProcessPortal"/>" aria-describedby="helpText" tabindex="0" id="body" >

<span style="font-size: 120%; font-weight: bold"  class="hideInPrintable"><label for="path"><bean:message key="criticalPath.div.select.path.title" bundle="ProcessPortal"/></label></span>

<select id="path"  class="hideInPrintable" name="projectionList">
    <option value="1"><bean:message key="criticalPath.div.select.path.option1" bundle="ProcessPortal"/></option>
    <option value="2"><bean:message key="criticalPath.div.select.path.option2" bundle="ProcessPortal"/></option>
    <option value="3"><bean:message key="criticalPath.div.select.path.option3" bundle="ProcessPortal"/></option>
</select>
<span style="font-size: 120%; font-weight: bold; margin-<%=BidiUtils.getalignment(attrData,"left")%>:20px; margin-top:5px;"  class="hideInPrintable">
<a title="<bean:message key="toolbar.tip.ShowProcessInstanceDiagram" bundle="ProcessPortal"/>"
	href="#DIAGRAM" onclick="popUpDiagram(); return false;">
        <img src="<%=BidiUtils.getLocalizedFileName(attrData, "images/process/enabled/bpd_16x16.gif")%>"
        alt="<bean:message key="toolbar.tip.ShowProcessInstanceDiagram" bundle="ProcessPortal"/>">
	</a></span>
<select id="pathHistoricalScenario" style="display: none" class="hideInPrintable" name="pathHistoricalScenario" aria-label="pathHistoricalScenario">
    <option value="0"><bean:message key="criticalPath.div.select.history.option1" bundle="ProcessPortal"/></option>
<%
  for(java.util.Iterator it = historicalScenarios.iterator(); it.hasNext();) {
      TWTreeElement<POType.HistoricalScenario> scenario = (TWTreeElement<POType.HistoricalScenario>)it.next();
%>
    <option value="<%= ID.toExternalString(scenario.getId()) %>"><%= scenario.getName() %></option>
<%
  }
%>
</select>

<div style="<%=BidiUtils.getalignment(attrData,"float:right")%>"><a id="printable" href="#PRINTABLE" target="_blank"><bean:message key="criticalPath.div.title" bundle="ProcessPortal"/></a></div>

<p id="helpText">
	<bean:message key="criticalPath.div.body.detail" bundle="ProcessPortal" encodeTo="ascii"/>
</p>

<div id="durationModification" style="display:none">
	<bean:message key="criticalPath.div.body.duration.modificationNotice" arg0="{0}" arg1= "{1}" arg2 = "{2}" arg3 = "{3}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="durationModificationActivity" style="display:none">
	<bean:message key="criticalPath.div.body.duration.modificationNotice.activity" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="durationModificationTask" style="display:none">
	<bean:message key="criticalPath.div.body.duration.modificationNotice.task" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="durationModificationInstance" style="display:none">
	<bean:message key="criticalPath.div.body.duration.modificationNotice.instance" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="dueDateModification" style="display:none">
	<bean:message key="criticalPath.div.body.dueDate.modificationNotice" arg0="{0}" arg1= "{1}" arg2 = "{2}" arg3 = "{3}"  bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="dueDateModificationActivity" style="display:none">
	<bean:message key="criticalPath.div.body.dueDate.modificationNotice.activity" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="dueDateModificationTask" style="display:none">
	<bean:message key="criticalPath.div.body.dueDate.modificationNotice.task" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="dueDateModificationInstance" style="display:none">
	<bean:message key="criticalPath.div.body.dueDate.modificationNotice.instance" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="priorityModification" style="display:none">
	<bean:message key="criticalPath.div.body.priority.modificationNotice" arg0="{0}" arg1= "{1}" arg2 = "{2}" arg3 = "{3}"  bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="priorityModificationActivity" style="display:none">
	<bean:message key="criticalPath.div.body.priority.modificationNotice.activity" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="priorityModificationTask" style="display:none">
	<bean:message key="criticalPath.div.body.priority.modificationNotice.task" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="priorityModificationInstance" style="display:none">
	<bean:message key="criticalPath.div.body.priority.modificationNotice.instance" arg0="{0}" arg1= "{1}" arg2 = "{2}" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="task" style="display:none">
	<bean:message key="criticalPath.div.body.task" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="instance" style="display:none">
	<bean:message key="criticalPath.div.body.instance" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="activity" style="display:none">
	<bean:message key="criticalPath.div.body.activity" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="hour" style="display:none">
	<bean:message key="flash.diagram.popup.hour.singular" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="hours" style="display:none">
	<bean:message key="flash.diagram.popup.hour.plural" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="minute" style="display:none">
	<bean:message key="flash.diagram.popup.minute.singular" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="minutes" style="display:none">
	<bean:message key="flash.diagram.popup.minute.plural" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="day" style="display:none">
	<bean:message key="flash.diagram.popup.day.singular" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="days" style="display:none">
	<bean:message key="flash.diagram.popup.day.plural" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="month" style="display:none">
	<bean:message key="flash.diagram.popup.month.singular" bundle="ProcessPortal" encodeTo="ascii"/>
</div>

<div id="months" style="display:none">
	<bean:message key="flash.diagram.popup.month.plural" bundle="ProcessPortal" encodeTo="ascii"/>
</div>


<!-- Contents tables -->
<table id="instanceDetails" class="content-table" role="presentation">
    <thead>
        <tr>
            <th colspan="4">
                <div style="<%=BidiUtils.getalignment(attrData,"float:left")%>">
                   <bean:message key="criticalPath.table.instanceDetails.title" bundle="ProcessPortal"/>
                </div>                
                <%--Bidi_ACGC_Start,Call Alignment Function --%>
                <a class="hideInPrintable exportCriticalPath" href="javascript:doSubmitExport()" style="<%=BidiUtils.getalignment(attrData,"float:right")%>">
                <img src="images/export_16x16.gif" style="vertical-align: middle" alt="">&nbsp;<bean:message key="criticalPath.table.instanceDetails.title.href" bundle="ProcessPortal"/></a>                
            </th>
        </tr>
        <tr>
            <td width="120"><bean:message key="criticalPath.table.instanceDetails.process.definition" bundle="ProcessPortal"/></td>
            <td id="bpdName" class="cell-content bidiText"></td>
            <td width="120"><bean:message key="criticalPath.table.instanceDetails.duedate.current" bundle="ProcessPortal"/></td>
            <td class="cell-content"><span id="dueDate"></span></td>
        </tr>
        <tr>
            <td width="120"><bean:message key="criticalPath.table.instanceDetails.instance.name" bundle="ProcessPortal"/></td>
            <td id="instanceName" class="cell-content bidiText"></td>
            <td width="120" id="currentDueDateTitle"><label for="updateDueDate"><bean:message key="criticalPath.table.instanceDetails.duedate.update" bundle="ProcessPortal"/></label></td>
            <td class="cell-content dueDate"><input <% if (SecurityUtils.instanceDueDateCanChange(new BigDecimal((String)bpdInstanceId))) { %>class="needJscalendar"<% } else { %>DISABLED<% } %> id="updateDueDate" type="text" value="" size="40"></td>
        </tr>
        <tr>
            <td width="120"><bean:message key="criticalPath.table.instanceDetails.instance.id" bundle="ProcessPortal"/></td>
            <td id="instanceId" class="cell-content"></td>
            <td width="120"><bean:message key="criticalPath.table.instanceDetails.duedate.projected" bundle="ProcessPortal"/></td>
            <td class="cell-content"><span id="projectedDueDate"></span></td>
        </tr>
        <tr>
            <td width="120"><bean:message key="criticalPath.table.instanceDetails.status" bundle="ProcessPortal"/></td>
            <td id="status" class="cell-content"></td>
            <td>&nbsp;</td>
            <td class="cell-content">&nbsp;</td>
        </tr>
    </thead>
</table>

<table id="massUpdates2" class="content-table" role="presentation">
    <thead>
    <tr>
        <td><bean:message key="criticalPath.table.mass.updates" bundle="ProcessPortal"/></td>
        <td class="cell-content" colspan="3">
            <select id="massUpdate2ChangeType" size="1" name="massUpdate2ChangeTypeList" aria-label="massUpdate2ChangeTypeList">
                <option value=""><bean:message key="criticalPath.table.massUpdate2ChangeType.option1" bundle="ProcessPortal"/></option>
                <option value="resetToCurrent"><bean:message key="criticalPath.table.massUpdate2ChangeType.option2" bundle="ProcessPortal"/></option>
                <option value="decreasePercent"><bean:message key="criticalPath.table.massUpdate2ChangeType.option3" bundle="ProcessPortal"/></option>
                <option value="decreaseAmount"><bean:message key="criticalPath.table.massUpdate2ChangeType.option4" bundle="ProcessPortal"/></option>
                <option value="increasePercent"><bean:message key="criticalPath.table.massUpdate2ChangeType.option5" bundle="ProcessPortal"/></option>
                <option value="increaseAmount"><bean:message key="criticalPath.table.massUpdate2ChangeType.option6" bundle="ProcessPortal"/></option>
                <option value="setValue"><bean:message key="criticalPath.table.massUpdate2ChangeType.option7" bundle="ProcessPortal"/></option>
            </select>
            <select id="massUpdate2ChangeWhat" size="1" style="display: none;" name="massUpdate2ChangeWhatList" aria-label="massUpdate2ChangeWhatList">
                <option value=""><bean:message key="criticalPath.table.massUpdate2ChangeWhat.option1" bundle="ProcessPortal"/></option>
                <option value="duration"><bean:message key="criticalPath.table.massUpdate2ChangeWhat.option2" bundle="ProcessPortal"/></option>
                <option value="dueDate"><bean:message key="criticalPath.table.massUpdate2ChangeWhat.option3" bundle="ProcessPortal"/></option>
                <option value="priority"><bean:message key="criticalPath.table.massUpdate2ChangeWhat.option4" bundle="ProcessPortal"/></option>
            </select>
            
            <span id="massUpdates2NewValueSpan">
                <select id="massUpdate2Priorities" class="massUpdatePriorities" size="1" style="display: none;" name="massUpdate2PrioritiesList" aria-label="massUpdate2PrioritiesList">
                    <option><bean:message key="criticalPath.table.massUpdates2NewValueSpan.option1" bundle="ProcessPortal"/></option>
                </select>

                <input id="massUpdate2NewValue" type="text" size="12" style="display: none;" aria-label="enter number" name="massUpdate2NewValueInput" aria-label="massUpdate2NewValueInput">
                
                <span id="massUpdate2NewDueDateSpan" style="display: none;">
                    <input id="massUpdate2NewDueDate" class="needJscalendar" type="text" size="20" aria-label="enter date" name="massUpdate2NewDueDateInput" aria-label="massUpdate2NewDueDateInput">
                </span>
                
            </span>
            
            <span id="massUpdate2NewValuePercentSymbol" style="display: none;"><bean:message key="criticalPath.table.percent" bundle="ProcessPortal"/></span>

            <select id="massUpdate2ApplyToWhat" size="1" name="massUpdate2ApplyToWhatList" aria-label="massUpdate2ApplyToWhatList">
                <option value=""><bean:message key="criticalPath.table.massUpdate2ApplyToWhat.option1" bundle="ProcessPortal"/></option>
                <option value="all"><bean:message key="criticalPath.table.massUpdate2ApplyToWhat.option2" bundle="ProcessPortal"/></option>
                <option value="changed"><bean:message key="criticalPath.table.massUpdate2ApplyToWhat.option3" bundle="ProcessPortal"/></option>
                <option value="unchanged"><bean:message key="criticalPath.table.massUpdate2ApplyToWhat.option4" bundle="ProcessPortal"/></option>
                <option value="criticalPath"><bean:message key="criticalPath.table.massUpdate2ApplyToWhat.option5" bundle="ProcessPortal"/></option>
            </select>

            <select id="massUpdate2ApplyToType" size="1" name="massUpdate2ApplyToTypeList" aria-label="massUpdate2ApplyToTypeList">
                <option value=""><bean:message key="criticalPath.table.massUpdate2ApplyToType.option1" bundle="ProcessPortal"/></option>
                <option value="activities"><bean:message key="criticalPath.table.massUpdate2ApplyToType.option2" bundle="ProcessPortal"/></option>
                <option value="tasks"><bean:message key="criticalPath.table.massUpdate2ApplyToType.option3" bundle="ProcessPortal"/></option>
                <option value="all"><bean:message key="criticalPath.table.massUpdate2ApplyToType.option4.aaat" bundle="ProcessPortal"/></option>
            </select>

            <select id="massUpdateApplyMatch" size="1" style="display: none;" name="massUpdateApplyMatchList" aria-label="massUpdateApplyMatchList">
                <option value=""><bean:message key="criticalPath.table.massUpdateApplyMatch.option1" bundle="ProcessPortal"/></option>
                <option value="equals"><bean:message key="criticalPath.table.massUpdateApplyMatch.option2" bundle="ProcessPortal"/></option>
                <option value="notEquals"><bean:message key="criticalPath.table.massUpdateApplyMatch.option3" bundle="ProcessPortal"/></option>
                <option value="greaterThan"><bean:message key="criticalPath.table.massUpdateApplyMatch.option4" bundle="ProcessPortal"/></option>
                <option value="lessThan"><bean:message key="criticalPath.table.massUpdateApplyMatch.option5" bundle="ProcessPortal"/></option>
            </select>

            <button id="massUpdate2UpdateValue" value="massUpdate2UpdateValue"><bean:message key="criticalPath.table.button" bundle="ProcessPortal"/></button>
        </td>
    </tr>
    </thead>
</table>

<table id="dueDates" class="content-table" role="presentation">
    <thead>
        <tr>
            <th colspan="8">
            	<%--Bidi_ACGC_Start,Call Alignment Function --%>
                <div style="<%=BidiUtils.getalignment(attrData,"float:right")%>">
                   <div id="showCritical" class="hideInPrintable"  tabindex="0" title="<bean:message key="criticalPath.showAll.i18n" bundle="ProcessPortal"/>" 
                      alt="<bean:message key="criticalPath.showAll.i18n" bundle="ProcessPortal"/>" style="vertical-align: middle; cursor: pointer; display:inline">
                      <img id="showCriticalImg" src="images/icon/critical-mode.gif" alt="" />
                   </div>
                </div>
                <%--Bidi_ACGC_End--%>
                <bean:message key="criticalPath.table.dueDates.head" bundle="ProcessPortal"/>&nbsp;
                   <img id="showLegend" tabindex="0" src="<%=BidiUtils.getLocalizedFileName(attrData, "images/linkto_help.gif")%>" 
                      title="<bean:message key="criticalPath.showHideLegend" bundle="ProcessPortal"/>" alt="<bean:message key="criticalPath.showHideLegend" bundle="ProcessPortal"/>"
                      style="vertical-align: middle; cursor: pointer;">
                <div id="legend" style="display: none; position: absolute; z-index: 100;">
                <%--Bidi_ACGC_Start,Call isBidi Function --%>                                   
				<% if(BidiUtils.isBidi(attrData)) { %>
  				<div style="width: 100px; position:relative; right: 185px; top: -30px">
  				<% } else { %>
                    <div style="width: 100px; position:relative; left: 185px; top: -30px">
  				<% } %>
  				<%--Bidi_ACGC_End--%>
                        <table class="content-table" style="background-color: white; padding: 3px; border: 3px solid lightgray;" role="presentation">
                            <thead>
                                <tr>
                                    <th><bean:message key="criticalPath.table.dueDates.title" bundle="ProcessPortal"/></th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr class="milestone">
                                    <td class="name"><bean:message key="criticalPath.table.dueDates.milestone" bundle="ProcessPortal"/></td>
                                </tr>
                                <tr class="activity">
                                    <td class="name"><bean:message key="criticalPath.table.dueDates.activity" bundle="ProcessPortal"/></td>
                                </tr>
                                <tr class="task">
                                    <td class="name"><img src="images/execution_context.gif" style="vertical-align: middle" alt="">&nbsp;<bean:message key="criticalPath.table.dueDates.task" bundle="ProcessPortal"/>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>


                </div>
            </th>
        </tr>
        <tr class="ff2reloadfix">
            <td class="longColumnHead" rowspan="2"><bean:message key="criticalPath.table.dueDates.step" bundle="ProcessPortal"/></td>
            <td class="longColumnHead" rowspan="2"><bean:message key="criticalPath.table.dueDates.owner" bundle="ProcessPortal"/></td>
            <td colspan="3" class="hideInPrintable">
                <div style="<%=BidiUtils.getalignment(attrData,"float:right")%>">&nbsp;<img id="showCurrentArrow" 
                        src="<%=BidiUtils.getLocalizedFileName(attrData, "images/arrow_left.png")%>" tabindex="0" role="button"                                                         
                        title="<bean:message key="criticalPath.showValues" bundle="ProcessPortal"/>" alt="<bean:message key="criticalPath.showValues" bundle="ProcessPortal"/>"
                        style="vertical-align: middle"></div>
                <span id="updatesOrCurrent"><bean:message key="criticalPath.table.dueDates.updates" bundle="ProcessPortal"/></span>
            </td>
            <td colspan="2" class="current">
                <div style="<%=BidiUtils.getalignment(attrData,"float:right")%>" class="hideInPrintable">&nbsp;<img id="hideCurrentArrow" 
                        src="<%=BidiUtils.getLocalizedFileName(attrData, "images/arrow_right.png")%>" tabindex="0" role="button"
                        title="<bean:message key="criticalPath.hideValues" bundle="ProcessPortal"/>" alt="<bean:message key="criticalPath.hideValues" bundle="ProcessPortal"/>"
                        style="vertical-align: middle"></div>
                <bean:message key="criticalPath.table.dueDates.current" bundle="ProcessPortal"/>
            </td>
        </tr>
        <!--
        <tr><td class="longColumnHead">Owner</td><td>Priority</td><td>Duration</td><td>Due Date</td><td>ID</td><td>Duration</td><td>Due Date</td></tr>
        -->
        <tr>
            <td class="hideInPrintable"><bean:message key="criticalPath.table.dueDates.priority" bundle="ProcessPortal"/></td>
            <td class="hideInPrintable"><bean:message key="criticalPath.table.dueDates.duration" bundle="ProcessPortal"/></td>
            <td class="hideInPrintable"><bean:message key="criticalPath.table.dueDates.duedate" bundle="ProcessPortal"/></td>
            <td class="current"><bean:message key="criticalPath.table.dueDates.duration" bundle="ProcessPortal"/></td>
            <td class="current"><bean:message key="criticalPath.table.dueDates.duedate" bundle="ProcessPortal"/></td>
        </tr>
    </thead>
    <tbody id="dueDatesContent">
    </tbody>
</table>

<div id="changesContainer">
    <table id="changes" class="content-table" style="display: none;" role="presentation">
        <thead>
            <tr>
                <th><div class="icon" tabindex="0">
                       <span class="iconA11y">&#9660</span></div>
                    <bean:message key="criticalPath.div.changesContainer.changes" bundle="ProcessPortal"/>
                </th>
            </tr>
        </thead>
        <tbody id="changesBody" role="status" aria-live="polite">
        </tbody>
    </table>

    <p id="saveRevert">
        <button id="save" class="changeControl" disabled="disabled" value="save"><bean:message key="criticalPath.save" bundle="ProcessPortal"/></button>&nbsp;<button id="revert" class="changeControl" disabled="disabled" value="revert"><bean:message key="criticalPath.revert" bundle="ProcessPortal"/></button>
    </p>
</div>

<table class="content-table" role="presentation">
</table>
</div>
<div tabindex="0" onfocus="moveFocusToBody(event)"></div>
</div>

<script type="text/javascript">
    instances[TW.pageData.bpdInstanceId] = true;
    onSelectionChange();
</script>

<script type="text/javascript">
	function popUpDiagram() {
		var cpType = "<%= request.getParameter(Constants.Request.BPD_CRITICAL_PATH_TYPE) %>";
		var parentId = "<%= request.getParameter(Constants.Request.BPD_CRITICAL_PARENT_ID) %>";
		var url = "<%=request.getContextPath()%>/jsp/tiles/CriticalPathFlows.jsp?cpType="+cpType;
		if (parentId!="null") {
			url = url+"&parentId="+parentId;
		}
         dojo.xhrGet({
           url: url,
           handleAs: "text",
		   preventCache: true,
           sync: true,
           load: function(data, xhrArgs){
			 if (data && data.length && data.length>2) {
				 var startIndex = data.indexOf("[");
				 var endIndex = data.lastIndexOf("]");
				 if (startIndex+1 < endIndex){
					 var newString = data.substring(startIndex+1, endIndex);
					 var splitString=newString.split(",");
					 var newArray=[];
					 for (var i=0; i<splitString.length; i++) {
						// remove leading blanks and add to array
						var tStr = splitString[i].replace(/^\s+/, '').replace(/\:/g, "_colon_").replace(/-/g, "_hyphen_"); 
						//Need to replace ":" with "_colon_", since the ":" breaks JSON deserialization
						//Need to replace "-" with "_hyphen_", since the "-" breaks JSON deserialization
						newArray.push(tStr);
					 }
					 var dojoString = dojo.toJson(newArray);
					 var instanceId = <%= bpdInstanceId %>;

					 var msgBody = '{"instanceId":'+instanceId+', "criticalPathFlows":'+dojoString+'}';
					 if (window.parent) {
						try  {

					 window.parent.postMessage(msgBody, "*");
						} catch(e) {
							var messObj={origin: window.location.protocol + "//" + window.location.host,
													data: msgBody, 
													source: window};
							window.parent.onMessage(messObj);
							
						}
					}
				 }
			   }
		   }
         });
	}
</script>
