<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<div class="body">
 <html:javascript formName="GeneralPreferencesExecute" bundle="ProcessPortal"/>
 <logic:messagesPresent>
<html:messages id="msg" header="errors.header" footer="errors.footer" bundle="ProcessPortal"><li><bean:write name="msg" bundle="ProcessPortal"/></li></html:messages>
</logic:messagesPresent>
<html:form action="/jsp/generalPreferencesExecute.do" method="POST" focus="userEmail" onsubmit="return validateGeneralPreferencesExecute(this)">
<table><tbody>
 <tr>
  <td><label for="fullNameId"><bean:message key="generalPreference.fields.userName" bundle="ProcessPortal"/></label></td>
  <td><html:text styleId="fullNameId" property="<%= Constants.FormBeans.GeneralPreferencesExecute.FULL_NAME %>" name="GeneralPreferencesExecute" readonly="true" style="width:307px; background-Color:silver"/></td>
 </tr>
 <tr>
  <td><label for="emailId"><bean:message key="generalPreference.fields.userEmail" bundle="ProcessPortal"/></label></td>
  <td><html:text styleId="emailId" property="<%= Constants.FormBeans.GeneralPreferencesExecute.USER_EMAIL %>"  name="GeneralPreferencesExecute" style="width:307px" styleClass="bidi_url"/></td>
 </tr>
 <tr>
   <td><label for="onTaskEmailId"><bean:message key="generalPreference.fields.onTaskEmail" bundle="ProcessPortal"/></label></td>
   <td><html:checkbox styleId="onTaskEmailId" property="<%= Constants.FormBeans.GeneralPreferencesExecute.ON_TASK_EMAIL %>" name="GeneralPreferencesExecute" value="true"/></td>
 </tr>
 <tr>
  <td><label for="userLocaleId"><bean:message key="generalPreference.fields.userLocale" bundle="ProcessPortal"/></label></td>
  <td><bean:define id="options" name="<%= Constants.Session.INSTALLED_LOCALES_OPTIONS %>" scope="session"/>
   <html:select styleId="userLocaleId" property="<%= Constants.FormBeans.GeneralPreferencesExecute.USER_LOCALE %>" disabled="<%= !com.lombardisoftware.portal.utils.LocaleUtil.CAN_USER_CHOOSE_LOCALE%>">
   <html:options collection="options" property="value" labelProperty="label" /></html:select>
  </td>
 </tr>
 <tr>
  <td><label for="alertOnAssignAndRunId"><bean:message key="generalPreference.fields.alertOnAssignAndRun" bundle="ProcessPortal"/></label></td>
  <td><html:checkbox styleId="alertOnAssignAndRunId" property="<%= Constants.FormBeans.GeneralPreferencesExecute.ALERT_ON_ASSIGN_AND_RUN %>" name="GeneralPreferencesExecute" value="true"/></td>
 </tr>
 <tr>
  <td><label for="calendarTypeId"><bean:message key="generalPreference.fields.calendarType" bundle="ProcessPortal"/></label></td>
  <td><bean:define id="calendarTypeOptions" name="<%= Constants.Session.CALENDAR_TYPES_OPTIONS %>" scope="session"/>
   <html:select styleId="calendarTypeId" property="<%= Constants.FormBeans.GeneralPreferencesExecute.CALENDAR_TYPE %>">
   <html:options collection="calendarTypeOptions" property="value" labelProperty="label" /></html:select>
  </td>
 </tr>
 
 <tr><td colspan="2" align="center"><input type="submit" name="update" value="<bean:message key="generalPreference.buttons.saveChanges" bundle="ProcessPortal"/>"></td></tr>
</tbody></table></html:form></div>