<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="tiles" uri="/WEB-INF/struts-tiles.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ page import = "java.util.Map" %>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.MessagesHelper" %>

<%@ include file="../contextRoot.jsp" %>

<jsp:useBean id="content" class="java.lang.String" scope="request" />
<script TYPE="text/javascript"src="<%=request.getContextPath()%>/js/toolbar.js"></script>

<%
	boolean isBidi = false;
	String imgClass = "";
	Map<String, String> attrData = UserAttributesHelper.getUserAttributes();
    String language = UserAttributesHelper.getLanguage(attrData);
    if("ar".equalsIgnoreCase(language) || "he".equalsIgnoreCase(language) || "he".equalsIgnoreCase(language)){
    	isBidi = true;
    	imgClass = "img_rtl";
    } 
%>

<% if (content != null && !content.equals("")) { %>
<div id="toolbar">
  <table border="0" cellspacing="0" cellpadding="0">
        <tr valign="top">
           <td id="nav" class="nav_toolbar"><div id="nav_header"></div></td>
            <td class="button" nowrap>
	       <a href="javascript:doSaveSettings();"><img src="<%= processPortalSupportContextRoot %>/jsp/images/reporting/enabled/save_16x16.gif" class="<%= imgClass %>" align="<%= isBidi ? "right" : "left" %>" alt=""><bean:message key="reportToolbar.href.save" bundle="ProcessPortal"/></a>
	    <td class="divider">|</td>
	    <td class="button" nowrap>
	       <a href="javascript:launchEPVList()"><img src="<%= processPortalSupportContextRoot %>/jsp/images/reporting/enabled/epv_16x16.gif" class="<%= imgClass %>" align="<%= isBidi ? "right" : "left" %>" alt=""><bean:message key="reportToolbar.href.process.manage" bundle="ProcessPortal"/></li></a>
	     <td class="divider">|</td>
	    <td class="button" nowrap>
	    <form name="exportData" method="post" target="_new" action="<%= teamworksContextRoot %>/data-redirect.jsp">
			<input type="hidden" name="data" value="">
			<input type="hidden" name="fileName" value="filename=<%= MessagesHelper.getMessage(application, request, "reportToolbar.href.export.csvname", "ProcessPortal") %>">
	        <a href="javascript:doSubmitExport()"><img src="<%= processPortalSupportContextRoot %>/jsp/images/reporting/enabled/export_16x16.gif" class="<%= imgClass %>" align="<%= isBidi ? "right" : "left" %>" alt=""><bean:message key="reportToolbar.href.export" bundle="ProcessPortal"/></a>
	    </form>
        <td id="userFilterRefreshDivider" class="divider hidden">|</td>
        <td class="button" nowrap>
            <a id="userFilterRefreshButton" class="hidden" href="javascript:doSubmitRefresh();"><img src="<%= processPortalSupportContextRoot %>/jsp/images/reporting/enabled/refresh_16x16.gif" align="<%= isBidi ? "right" : "left" %>" alt=""><bean:message key="reports.adhoc.Refresh" bundle="ProcessPortal"/></a>

  </table>
</div>
<% } %>
