<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>

<%@ include file="../contextRoot.jsp" %>

<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<jsp:useBean id="content" class="java.lang.String" scope="request" />
<script type="text/javascript" src="<%=request.getContextPath()%>/js/chart-tooltip.js"></script>

<link rel="stylesheet" type="text/css" href="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css">

<LINK REL="stylesheet" HREF="<%= teamworksContextRoot %>/html/common/coach_popup.css" TYPE="text/css">

<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js" 
     djConfig="parseOnLoad:true"></script>
    
    
<SCRIPT type="text/javascript" src="<%= teamworksContextRoot %>/script/coach_designer.js"></SCRIPT>
<SCRIPT type="text/javascript" src="<%= teamworksContextRoot %>/script/javascript.js"></SCRIPT>
<SCRIPT type="text/javascript" src="<%= teamworksContextRoot %>/script/validation.js"></SCRIPT>
<SCRIPT type="text/javascript" src="<%= teamworksContextRoot %>/script/formatting/number-functions.js"></SCRIPT>
<SCRIPT type="text/javascript" src="<%= teamworksContextRoot %>/script/formatting/lombardi-format.js"></SCRIPT> 

<SCRIPT type="text/javascript" src="<%= teamworksContextRoot %>/script/DateTimePicker.js"></SCRIPT>    
  

<script type="text/javascript">
    dojo.require("DateTimePicker");
    dojo.require("dojo.date.locale");

    if (typeof TW == 'undefined') {
        var TW = {};
        TW.pageData = {};
    };

    TW.pageData.zReportId = "";

</script>   
<script type="text/javascript">

function handleToolbar() {
    // Disable Export if no export data (SLA Overview)
    var nodes = document.getElementsByName("exportData");
    if (nodes) {
        var inputs = nodes[0].children;
        if (inputs[0] && inputs[0].name && (inputs[0].name == "data")) {
            if (inputs[0].value.length == 0) {
                for (var i in inputs) { 
                    if (inputs[i].tagName && inputs[i].tagName.toUpperCase() == "A") {                
                        var images = inputs[i].children;
                        for (var j in images) { 
                            if (images[j].tagName && images[j].tagName.toUpperCase() == "IMG") {                                        
                                var src = images[j].src;
                                images[j].src = src.replace(/enabled/, "disabled");                
                                break;
                            }
                        }
                        inputs[i].disabled = true;
                        inputs[i].removeAttribute('href');
                        inputs[i].style.color = "grey";
                        break;
                    }
                }
            }
        }
    }
    //Manage Exposed Process Values needs zReportId
    nodes = document.getElementsByTagName("select");
    if (nodes && nodes[0]) {
        var onchg = nodes[0].getAttribute("onChange");
        if (!!onchg && onchg.split) {        
            var parm1 = onchg.split("?");
            if (parm1[1]) {        
                var parm2 = parm1[1].split("&");
                if (parm2[0]) {            
                    var parm3 = parm2[0].split("=");
                    if (parm3[0] && parm3[0] == "zReportId") {
                        TW.pageData.zReportId = parm3[1];                    
                    }
                }
            }
        }
    }
    if (TW.pageData.zReportId == "") { 
        nodes = document.getElementsByTagName("a");
        if (nodes) {
            for (var i in nodes) {
                if (nodes[i].getAttribute) {            
                    var href = nodes[i].getAttribute("href");
                    if (href && href.indexOf("zReportId") > -1) {            
                        var parm1 = href.split("?");
                        if (parm1[1]) {        
                            var parm2 = parm1[1].split("&");
                            if (parm2[0]) {            
                                var parm3 = parm2[0].split("=");
                                if (parm3[0] && parm3[0] == "zReportId") {
                                    TW.pageData.zReportId = parm3[1];                    
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    //disable Manage Exposed Process Values if zReportId is not found (SLA Overview)
    if (TW.pageData.zReportId == "") { 
        nodes = document.getElementsByTagName("a");
        for (var i in nodes) {
            if (nodes[i].getAttribute) {            
                var href = nodes[i].getAttribute("href");
                if (href && href.indexOf("launchEPVList") > -1) {
                    if (nodes[i].firstChild && nodes[i].firstChild.src) {                    
                        var src = nodes[i].firstChild.src;
                        nodes[i].firstChild.src = src.replace(/enabled/, "disabled");                
                    }
                    nodes[i].disabled = true;
                    nodes[i].removeAttribute('href');
                    nodes[i].style.color = "grey";
                    break;
                }
            }
        }
    }
}

function addExportData(csvTable) {
    document.forms.exportData.data.value = "\uFEFF" + document.forms.exportData.data.value + "\n\n" + csvTable;
}


function drilldownClick(label, serie, data, chart, area) {
  // Override this in your own report to do advanced drilldown effects.
  // return true from this one if you want normal page forwarding to
  // take place.

    if (area && area.href) {
        var url = area.href.replace('report_detail\.lsw', '../../teamworks/reportDetails.lsw');
        window.open(url, "ReportDetails");
        return false;
    }
    return true;
}

function addUserFilter(label, html) {
	
    var div = document.createElement("SPAN");
    var id = document.getElementById("nav");

    var txt = "";
    txt += "<div id='nav_filter'>" +
    	  	 "<div class='divider'>&nbsp;</div>\n" +
    			"<div id='nav_header_filter'>" +
  					"<div class='heading'>" +
	      	     		"<h1>" + label + "</h1>" +
	          	      "</div>" +
	               "</div>" +
	           "</div>"+
           "<div class='body'><ul><li style='height:auto;'>" + html + "</li></ul></div>";

    div.innerHTML = txt;
    id.appendChild(div);
    
	var refresh = document.getElementById("userFilterRefreshButton");
	if (refresh) {
		dojo.removeClass(refresh,"hidden");
        refresh = document.getElementById("userFilterRefreshDivider");
        if (refresh) dojo.removeClass(refresh,"hidden");
	}    
}

function doSaveSettings() {
    var _report_detail_bookmark_title = location.href;
    var reportHeading = document.getElementById("report-heading");
    if (reportHeading) {
        _report_detail_bookmark_title = reportHeading.innerHTML;
    }    
	if (document.all) {
		window.external.AddFavorite(location.href, _report_detail_bookmark_title);
	} else if (window.sidebar) {
		window.sidebar.addPanel(_report_detail_bookmark_title , location.href,  "");
	}        
}

function doSubmitExport() {
	document.forms["exportData"].submit();
}

function launchEPVList() {
  window.open("<%= teamworksContextRoot %>/cs_epv.lsw?zReportId="+TW.pageData.zReportId+"&zContext=<%= request.getAttribute("zContext") %>", "epv", "toolbar=no,width=800,height=700,resizable=yes,scrollbars=yes");
}

function displayDateFilter(fName, initialValue) {
    var nameAttribute = fName;
    var valueAttribute=initialValue;
    var elementId = fName;
    var dpattern = document.getElementById("dateWrap-" + elementId).getAttribute("datePattern");

    var dateWidget = new DateTimePicker({
        id: elementId,
        name: elementId,
        dateTimePattern: dpattern,
        boundToDate: true
    });
    dateWidget.attr("value", valueAttribute);


    document.getElementById("dateWrap-" + elementId).appendChild(dateWidget.domNode);
    dateWidget.startup();
    var element = dojo.byId(elementId);

    dojo.attr(element, "name", nameAttribute);
    dojo.attr(element, "value", valueAttribute);
}

function init() {
}

function doSubmitRefresh() {
    var ele = document.getElementById("refreshData");
    var isItemForSubmit = false;
	var filters = document.getElementsByTagName("INPUT");
	if (filters) {
		for (var i = 0; i < filters.length; ++i) {
			var inp = document.createElement("INPUT");
			if (filters[i].type && filters[i].type != "hidden") {
				inp.type = "hidden";
				inp.value = filters[i].value;
				inp.name = filters[i].name;
                ele.appendChild(inp);
                isItemForSubmit = true;
			}
		}        
	}
    filters = document.getElementsByTagName("SELECT");
    if (filters) {
        for (var i = 0; i < filters.length; ++i) {
            if (filters[i].options) {                
                var value = filters[i].options[filters[i].selectedIndex].value;
                if (value) {        
                    var inp = document.createElement("INPUT");
                    inp.type = "hidden";
                    inp.value = value;
                    inp.name = filters[i].name;
                    ele.appendChild(inp);
                    isItemForSubmit = true;
                }
            }
        }        
    }    
    if (isItemForSubmit) {    
        ele.submit();
	}
}

</script>
<html:form styleId="refreshData" method="POST" action="/jsp/refreshScoreboard.do">
    <input type="hidden" name="id" value=<%=request.getParameter("id")%> />
</html:form>
<div class="body" id="addPopupToThis">
    <%= content %>
</div>

