<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.portal.struts.Constants.FormBeans.ViewDocumentVersions, 
                 com.lombardisoftware.portal.struts.Constants.Request, 
                 com.lombardisoftware.portal.viewhelper.DocumentsHelper, 
                 com.lombardisoftware.client.DateFormatUtils,
                 com.ibm.icu.text.DateFormat"%>
<%@ page import="com.lombardisoftware.core.UserPreference"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<bean:define id="docs" name="<%= Request.DOCS %>" scope="request" type="com.lombardisoftware.data.DocumentShell[]"/>
<bean:parameter id="parentId" name="<%= ViewDocumentVersions.PARENT_ID %>"/>
<bean:parameter id="bpdInstanceId" name="<%= ViewDocumentVersions.BPD_INSTANCE_ID %>"/>
<%    
	UserPreference userPreference = (UserPreference)session.getAttribute(UserPreference.SESSION_KEY);
    DateFormat dateFormat = BidiUtils.getDateTimeFormat(userPreference);
%>
<script type="text/javascript">
function performPopupAction(url, idString, windowParams) {
    if (url.indexOf('?') > -1) {
        url += '&';
    } else {
        url += '?';
    }
    if (typeof windowParams == "undefined") {
        windowParams = "height=350,width=340,scrollbars=no,resizable=no";
    }
    window.open(url + idString, '_blank', windowParams).focus();
}
</script>
<div class="body">
<table class="content-table">
    <thead>
    <tr>
        <th colspan="5">
            <p style="float:left">
            <bean:message key="documentVersion.DocumentsTable.Heading" bundle="ProcessPortal"/>
            </p>
            <input type="button" value="<bean:message key="documentVersion.DocumentsTable.AddDocumentVersion" bundle="ProcessPortal"/>" style="float:right; height:20px;" onClick="javascript:performPopupAction('addDocumentVersionSetup.do', 'bpdInstanceId=<%= bpdInstanceId %>&parentId=<%= parentId %>', 'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto');">

        </th>
    </tr>
    <tr>
        <td><bean:message key="documentVersion.DocumentsTable.Version" bundle="ProcessPortal"/></td>
        <td><bean:message key="documentVersion.DocumentsTable.Filename" bundle="ProcessPortal"/></td>
        <td><bean:message key="documentVersion.DocumentsTable.Type" bundle="ProcessPortal"/></td>
        <td><bean:message key="documentVersion.DocumentsTable.ModifiedBy" bundle="ProcessPortal"/></td>
        <td><bean:message key="documentVersion.DocumentsTableLastModifiedDate" bundle="ProcessPortal"/></td>
    </tr>
    </thead>
    <tbody>
    <logic:iterate id="doc" name="docs" type="com.lombardisoftware.data.DocumentShell">
        <tr>
            <td width="14%"><%= DocumentsHelper.createLink(doc, Integer.toString(doc.getVersion())) %></td>
            <td width="14%"><%= DocumentsHelper.createLink(doc, doc.getFileName()) %></td>
            <td width="14%"><%= DocumentsHelper.createLink(doc, DocumentsHelper.getFileTypeName(doc)) %></td>
            <td width="14%"><%= DocumentsHelper.createLink(doc, doc.getAuthor().getFullname()) %></td>
            <td width="14%"><%= DocumentsHelper.createLink(doc, dateFormat.format(doc.getAuthoredDTG())) %></td>
        </tr>
    </logic:iterate>
    </tbody>
</table>
</div>