<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>

<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.core.BidiPreferences"%>
<%@ page import="java.util.Map"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%
	Map<String, String> attrData = UserAttributesHelper.getUserAttributes();
%>

<script type="text/javascript">

getDojoDatePackageAsString = function() {
	return (<%="'"+BidiUtils.getDojoDatePackage(attrData)+"'"%>);
}

getDojoDatePackage = function() {
	return (<%=BidiUtils.getDojoDatePackage(attrData)%>);
}

getDateFormatPattern = function() {
	<%	
		String dateFormatPattern =  
			((com.ibm.icu.text.SimpleDateFormat) com.lombardisoftware.client.DateFormatUtils.getDateTimeFormat()).toPattern();
	%>;	
	return (<%="'"+dateFormatPattern+"'"%>);
}

getTimeFormatPattern = function() {
	<%	
		String timeFormatPattern =  
			((com.ibm.icu.text.SimpleDateFormat) com.lombardisoftware.client.DateFormatUtils.getTimeFormat(com.lombardisoftware.client.DateFormatUtils.FORMAT_MEDIUM)).toPattern();
	%>;	
	return (<%="'"+timeFormatPattern+"'"%>);
}

getCalendarType = function() {
	<%	
		String calendarType = "gregorian";
		if (BidiUtils.getCalendarType(attrData).equals(BidiPreferences.CALENDAR_TYPE_ISLAMIC)) {
			calendarType = "islamic";
		} else if (BidiUtils.getCalendarType(attrData).equals(BidiPreferences.CALENDAR_TYPE_HEBREW)) {
			calendarType = "hebrew";
		} 
	%>
	return (<%="'"+calendarType+"'"%>);
}


if(getCalendarType()=='islamic') {
	dojo.require("dojox.date.islamic");
    dojo.require("dojox.date.islamic.Date");
    dojo.require("dojox.date.islamic.locale");
}
else if(getCalendarType()=="hebrew") {
	dojo.require("dojox.date.hebrew");
    dojo.require("dojox.date.hebrew.Date");
    dojo.require("dojox.date.hebrew.locale");
}
</script>
